;; This module provides access to the getrusage(3C) system call via
;; the getcputime interfacing function
;; The source code has been adapted from the times module of bigloolib
;; See http://bigloo-lib.sourceforge.net/ for details
(module cputime
  (extern (include #"sys/resource.h"))
  (export (getcputime)))

(define (getcputime)
  (let ()
    (pragma #"struct rusage ru")
    (let (seconds microseconds)
      (pragma::long #"getrusage(RUSAGE_SELF,&ru)")
      (set! seconds (pragma::long #"ru.ru_utime.tv_sec"))
      (set! microseconds (pragma::long #"ru.ru_utime.tv_usec"))
      (+ (* seconds 100) (quotient microseconds 10000)))))
