(module input
	(include "dctp.sch")
	(export (read-tptp filename))
	(import (parser "parser.scm") (silent globals "globals.scm")))

(define (read-tptp filename)
  (let (infile)
    (if (not (file-exists? filename))
	(begin
	  (display "file not found: ")
	  (display filename)
	  (newline)
	  (exit 1)
	  #f)
	(begin
	  (set! infile (open-input-file filename))
	  (read/lalrp tptp-parser tptp-scanner infile)
	  (close-input-port infile)
	  #t))))
