(* $Id: equality.mli,v 1.3 2004/12/28 14:06:48 alexf Exp $ *)

(*
This file is part of the first order theorem prover Darwin
Copyright (C) 2004  The University of Iowa
                    Universitaet Koblenz-Landau 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)



(** equality by axiomatization

{e =} is fixed as the equality predicate symbol.
*)


(** {6 Types} *)

type symbol = Symbol.symbol
type clause = Term.clause



(** {6 Functions} *)

(** returns the predicate symbols contained in the clauses. *)
val get_predicate_symbols: clause list -> symbol list

(** does the problem contain equality?. *)
val contains_equality: clause list -> bool

(** adds the equality axioms needed for the clause set. *)
val add_equality: clause list -> clause list
