type config = Config.config
type literal = Term.literal
type state = State.state
type choice_point = State.choice_point
type bound = Bound.bound

type random_jump

type replay =
  | Left of literal
  | Right of literal
  | Split of literal

type saved_branch =
    replay list


val create: config -> state -> bound -> random_jump

val jump: random_jump -> choice_point option

val finished: random_jump -> bool

(* raise Not_found *)
val pop: random_jump -> saved_branch

(* source -> target *)
val register: random_jump -> random_jump -> unit

val saved_branch_to_string: saved_branch -> string
