#!/usr/bin/env python2.3
# ----------------------------------
"""
Usage: do_dp_plots.py [Options]

Create a number of plots from test data on the theory of arrays. This
is rather specialized code. To change the number or contents of the
plots, edit the code below.

Histograms be displayed on the screen or written as eps files.

Options:

-h
 Print this information and exit.

-f
 Create result files (default is to display graphs via X)

-d<directory>
 Point to the directory where the result files can be found. This
 overrides the hard-coded default.

Copyright 2005 Stephan Schulz, schulz@eprover.org

This code is part of the support structure for the equational
heorem prover E. Visit

 http://www.eprover.org
 
for more information.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program ; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307 USA 

The original copyright holder can be contacted as

Stephan Schulz (I4)
Technische Universitaet Muenchen
Institut fuer Informatik
Boltzmannstrasse 3
Garching bei Muenchen
Germany

or via email (address above).
"""

import re
import sys
import os.path
from os import system

import pylib_eprots
import pylib_graphs


sample = pylib_graphs.statistic_sample("IOS_UCLID_E_sts29")
sample.parse_from_eprot("/Users/schulz/SOURCES/Projects/VERONA/dp/array/IOS_UCLID_TEST_RESULTS/FULL/protokoll_E_sts29")
print "Mean: ", sample.mean()
print "Median: ", sample.median()
print "Max: ", sample.maximum()

sample.compute_distribution(0.02)
sample.gnuplot(True)

sample = pylib_graphs.statistic_sample("IOS_UCLID_E_Auto")
sample.parse_from_eprot("/Users/schulz/SOURCES/Projects/VERONA/dp/array/IOS_UCLID_TEST_RESULTS/FULL/protokoll_E_Auto")
print "Mean: ", sample.mean()
print "Median: ", sample.median()
print "Max: ", sample.maximum()

sample.compute_distribution(0.02)
sample.gnuplot(True)

