#include "../ladr/top_input.h"
#include "../ladr/cnf.h"

#define PROGRAM_NAME    "miniscope"
#define PROGRAM_VERSION "2005-A"
#include "../PROGRAM_DATE.h"

/*************
 *
 *   main()
 *
 *************/

int main(int argc, char **argv)
{
  Plist formulas;
  Formula f;

  init_standard_ladr();

  formulas = read_formula_list(stdin, stderr);

  f = formulas_to_conjunction(formulas);

  printf("\n------------------------\n");

  printf("\nbefore (denial): ");
  p_formula(f);

  f = nnf(negate(f));
  printf("\nnnf (positive):    ");
  p_formula(f);
    
  f = miniscope_formula(f, 0);

  if (f->type == AND_FORM) {
    int i;
    printf("result is %d subproblems\n", f->arity);
    for (i = 0; i < f->arity; i++) {
      printf("\nproblem %d:  ", i+1);
      p_formula(negate(f->kids[i]));
    }
  }
  else {
    printf("\nresult indivisible\n\n");
    p_formula(negate(f));
  }

  printf("exiting %s\n", PROGRAM_NAME);
  exit(0);
}  /* main */
