<?xml version="1.0"?>

<!-- java org.apache.xalan.xslt.Process -TT -TS -IN FOF.xml -XSL xtstp2post.xsl -OUT out.post -->
<!-- java org.apache.xalan.xslt.Process -IN FOF.xml -XSL xtstp2post.xsl  -OUT out -->

<xsl:stylesheet
  xmlns="http://www.w3.org/1999/XSL/Transform"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xtstp="http://xff.sf.net/xff/ext/tstp/xff-v0.3-ext-tstp.xsd"
  version="2.0">
<!--    xpath-default-namespace="http://www.tptp.org/xtstp" -->
<!--   xmlns:java="http://xml.apache.org/xslt/java"   -->
<!--   exclude-result-prefixes="java" -->

  <xsl:output
    method="text"
    omit-xml-declaration="yes"
    />

  <!-- xsl:import href="copyover.xsl"/ -->

  <!-- commont template definitions -->
  <xsl:template name="replace-string">
    <xsl:param name="text"/>
    <xsl:param name="replace"/>
    <xsl:param name="with"/>
    <xsl:choose>
      <xsl:when test="contains($text,$replace)">
        <xsl:value-of select="substring-before($text,$replace)"/>
        <xsl:value-of select="$with"/>
        <xsl:call-template name="replace-string">
	  <xsl:with-param name="text" select="substring-after($text,$replace)"/>
          <xsl:with-param name="replace" select="$replace"/>
          <xsl:with-param name="with" select="$with"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$text"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
 

  <!-- list processer -->
  <xsl:template name="clist">
    <xsl:param name="separator"/>
    <xsl:param name="sublist"/>
    <xsl:for-each select="$sublist">
      <xsl:value-of select="$separator" />
      <xsl:apply-templates select="." />
    </xsl:for-each>
  </xsl:template>

  <!-- list processer -->
  <xsl:template name="list">
    <xsl:param name="separator"/>
    <xsl:param name="sublist"/>

    <xsl:apply-templates select="$sublist[1]" />
    <xsl:call-template name="clist">
      <xsl:with-param name="separator" select="$separator"/>
      <xsl:with-param name="sublist" select="$sublist[position()>1]"/>
    </xsl:call-template>
  </xsl:template>

  <!-- quoted string -->
  <xsl:template name="qstring">
    <xsl:param name="value"/>
    <xsl:text>'</xsl:text>
    <xsl:value-of select="$value"/>
    <xsl:text>'</xsl:text>
  </xsl:template>

  <!--
       <xsl:key name="obx" match="OBX" use="@Observation_ID"/>
       
       <xsl:template match="tdObsResults">
         <xsl:apply-templates select="OBX[count( . | key( 'obx',
                                      @Observation-ID)[1] ) = 1]"/>
       </xsl:template>
       
       <xsl:template match="OBX">
         <xsl:value-of select="@Observation_ID"/>
       </xsl:templaet>
       
       --> 
  <xsl:template name="constDecls">
    <xsl:param name="constlist"/>
    <xsl:for-each select="$constlist">
      <xsl:text>(</xsl:text>
      <xsl:value-of select="@name"/>
      <xsl:text> i</xsl:text>
      <xsl:for-each select="*">
        <xsl:text> i</xsl:text>
      </xsl:for-each>
      <xsl:text>)&#xa;</xsl:text>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="predDecls">
    <xsl:param name="predlist"/>
    <xsl:for-each select="$predlist">
      <xsl:text>(</xsl:text>
      <xsl:value-of select="." />
      <xsl:value-of select="./@name" />
      <xsl:text>o</xsl:text>
      <xsl:for-each select="*">
        <xsl:text> i</xsl:text>
      </xsl:for-each>
      <xsl:text>)&#xa;</xsl:text>
    </xsl:for-each>
  </xsl:template>

  <xsl:key name="funcKey" match="xtstp:func" use="@name"/>
  <xsl:key name="predKey" match="xtstp:pred" use="@name"/>

  <xsl:template match="xtstp:xff">
    <xsl:text>(problem Xtstp2Post_</xsl:text>
<!--     <xsl:value-of select="java:format(java:java.text.SimpleDateFormat.new('yyyy_d_MMMM_h_mm_ss'), java:java.util.Date.new())"/> -->
    <xsl:text>&#xa;(in base)&#xa;</xsl:text>
    <xsl:text>(constants&#xa;</xsl:text>
    <xsl:for-each select=".//xtstp:func[count( . | key('funcKey', @name)[1] ) = 1]">
      <xsl:variable name="n" select="@name"/>
      <xsl:text>(</xsl:text>
      <xsl:value-of select="$n"/>
      <xsl:text> </xsl:text>
      <xsl:if test="count(*) > 0">
        <xsl:text>(</xsl:text>
      </xsl:if>
      <xsl:text>i</xsl:text>
      <xsl:for-each select="*">
         <xsl:text> i</xsl:text>
      </xsl:for-each>
      <xsl:if test="count(*) > 0">
        <xsl:text>)</xsl:text>
      </xsl:if>
      <xsl:text>)&#xa;</xsl:text>
    </xsl:for-each>

    <xsl:for-each select=".//xtstp:pred[count( . | key('predKey', @name)[1] ) = 1]">
      <xsl:variable name="n" select="@name"/>
      <xsl:text>(</xsl:text>
      <xsl:value-of select="$n"/>
      <xsl:text> </xsl:text>
      <xsl:if test="count(*) > 0">
        <xsl:text>(</xsl:text>
      </xsl:if>
      <xsl:text>o</xsl:text>
      <xsl:for-each select="*">
         <xsl:text> i</xsl:text>
      </xsl:for-each>
      <xsl:if test="count(*) > 0">
        <xsl:text>)</xsl:text>
      </xsl:if>
      <xsl:text>)&#xa;</xsl:text>
    </xsl:for-each>
    <xsl:text>)&#xa;</xsl:text>
    <xsl:apply-templates/>
  <xsl:text>)&#xa;</xsl:text>
</xsl:template>

<!--    <xsl:apply-templates select="./formula/*/qvar]" mode="proof"/> -->
<!--     <xsl:text>)&#xa;</xsl:text> -->


  <xsl:template match="xtstp:include">
    <xsl:text>;; include skipped...</xsl:text>
<!--       <xsl:call-template name="qstring"> -->
<!--        <xsl:with-param name="value" select="@filename"/> -\-> -->
<!--       </xsl:call-template>-->
<!--       <xsl:call-template name="clist"> -->
<!--         <xsl:with-param name="separator" select="','"/> -->
<!--         <xsl:with-param name="sublist" select="xtstp:formula-ref"/> -->
<!--       </xsl:call-template> -->
<!--      <xsl:text>).&#xa;</xsl:text>  -->
  </xsl:template>
  
<!--   <xsl:template match="xtstp:formula-ref"> -->
<!--     <xsl:value-of select="@name"/> -->
<!--   </xsl:template> -->

  <xsl:template match="xtstp:formula">
      <xsl:text>(</xsl:text>
      <xsl:choose>
        <xsl:when test="@type='axiom'"> <xsl:text>assumption</xsl:text></xsl:when>
        <xsl:when test="@type='conjecture'"> <xsl:text>conclusion</xsl:text></xsl:when>
      </xsl:choose>
      <xsl:text> </xsl:text>
      <xsl:value-of select="string(./@name)"/>
      <xsl:text>&#xa;</xsl:text>
      <xsl:apply-templates/>
    <xsl:text>)&#xa;</xsl:text>
  </xsl:template>

  <xsl:template name="lambda">
    <xsl:param name="quantor"/>
    <xsl:param name="varlist"/>
    <xsl:param name="body"/>
    <xsl:for-each select="$varlist">
      <xsl:text>(</xsl:text>
      <xsl:value-of select="$quantor" />
      <xsl:text> (lam (</xsl:text>
      <xsl:value-of select="string(@name)" />
      <xsl:text> i) </xsl:text>
    </xsl:for-each>
    <xsl:text>&#xa;</xsl:text>
    <xsl:apply-templates select="$body" />
    <xsl:for-each select="$varlist">
      <xsl:text>))</xsl:text>
    </xsl:for-each>
  </xsl:template>

  <xsl:template match="xtstp:quantify">
        <xsl:call-template name="lambda">
          <xsl:with-param name="quantor" select="@type"/>
          <xsl:with-param name="varlist" select="xtstp:qvar"/>
          <xsl:with-param name="body" select="*[node() != 'xtstp:var']"/>
        </xsl:call-template>
  </xsl:template>

  <!-- processess connective subtree
       $symbol  paramter specifies the connective symbol (it is converted
                to a TSTP symbol
       $sublist gives a list of subtrees to process; for each subtree, TSTP
                symbol glyph is emited and then the subtree is processed
		recursively
  -->
  <xsl:template name="connector">
    <xsl:param name="symbol"/>
      <!-- OPTIMIZE: is there a way to store the result for repetive use? -->
      <xsl:choose>
        <xsl:when test="$symbol='not'"> <xsl:text>not </xsl:text></xsl:when>
        <xsl:when test="$symbol='or'">  <xsl:text>or </xsl:text></xsl:when>
        <xsl:when test="$symbol='and'">
          <xsl:text disable-output-escaping="yes">and </xsl:text></xsl:when>
	<xsl:when test="$symbol='impl'">
          <xsl:text disable-output-escaping="yes">implies</xsl:text></xsl:when>
        <xsl:when test="$symbol='equiv'">
	  <xsl:text disable-output-escaping="yes">equiv</xsl:text></xsl:when>
        <xsl:otherwise>
          <xsl:message terminate="yes">
            Unknown connective '<xsl:value-of select="$symbol" />'
          </xsl:message>
        </xsl:otherwise>
      </xsl:choose>
  </xsl:template>
  <!-- processess connective subtree
       $symbol  paramter specifies the connective symbol (it is converted
                to a TSTP symbol
       $sublist gives a list of subtrees to process; for each subtree, TSTP
                symbol glyph is emited and then the subtree is processed
		recursively
  -->
  <xsl:template name="connective">
    <xsl:param name="symbol"/>
    <xsl:param name="sublist"/>
      <!-- OPTIMIZE: is there a way to store the result for repetive use? -->
    <xsl:text>(</xsl:text>
    <xsl:call-template name="connector">
      <xsl:with-param name="symbol" select="$symbol"/>
    </xsl:call-template>
    <xsl:apply-templates select="$sublist[1]" />
    <xsl:text> </xsl:text>
    <xsl:if test="count($sublist[position()>1])>1">
      <xsl:call-template name="connective">
        <xsl:with-param name="symbol" select="$symbol"/>
        <xsl:with-param name="sublist" select="$sublist[position()>1]"/>
      </xsl:call-template>
    </xsl:if>
    <xsl:if test="not(count($sublist[position()>1])>1)">
      <xsl:apply-templates select="$sublist[2]" />
    </xsl:if>
    <xsl:text>)</xsl:text>
  </xsl:template>
 
 <xsl:template match="xtstp:conn-1">
   <xsl:text>(</xsl:text>
   <xsl:call-template name="connector">
     <xsl:with-param name="symbol" select="@symbol"/>
   </xsl:call-template>
   <xsl:text> </xsl:text>
   <xsl:apply-templates select="*[1]" />
   <xsl:text>)</xsl:text>
 </xsl:template>

 <xsl:template match="xtstp:not">
   <xsl:text>(not </xsl:text>
    <xsl:apply-templates select="*[1]" />
   <xsl:text>)</xsl:text>
 </xsl:template>

 <xsl:template match="xtstp:and">
   <xsl:text>(and </xsl:text>
    <xsl:apply-templates select="*[1]" />
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="*[2]" />
   <xsl:text>)</xsl:text>
 </xsl:template>

 <xsl:template match="xtstp:or">
   <xsl:text>(or </xsl:text>
    <xsl:apply-templates select="*[1]" />
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="*[2]" />
   <xsl:text>)</xsl:text>
 </xsl:template>

 <xsl:template match="xtstp:impl">
   <xsl:text>(implies </xsl:text>
    <xsl:apply-templates select="*[1]" />
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="*[2]" />
   <xsl:text>)</xsl:text>
 </xsl:template>

 <xsl:template match="xtstp:pred|xtstp:func">
    <xsl:if test="count(*)>0">
      <xsl:text>(</xsl:text>
    </xsl:if>
    <xsl:value-of select="string(@name)" />
    <xsl:if test="count(*)>0">
      <xsl:text> </xsl:text>
      <xsl:call-template name="list">
        <xsl:with-param name="separator" select="' '"/>
        <xsl:with-param name="sublist" select="*"/>
      </xsl:call-template>
      <xsl:text>)</xsl:text>
    </xsl:if>
  </xsl:template>

  <xsl:template match="xtstp:equal">
    <xsl:text>(= </xsl:text>
    <xsl:apply-templates select="*[1]" />
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="*[2]" />
    <xsl:text>)</xsl:text>
  </xsl:template>
  
  <xsl:template match="xtstp:true">
    <xsl:text>true</xsl:text>
  </xsl:template>
  <xsl:template match="xtstp:false">
    <xsl:text>false</xsl:text>
  </xsl:template>

  <xsl:template match="xtstp:var">
    <xsl:value-of select="string(@name)" />
    <xsl:if test="@type!=''">
      <xsl:text>:</xsl:text>
      <xsl:value-of select="@type"/>
    </xsl:if>
    <!-- TODO: strange number -->
  </xsl:template>
  
  <xsl:template match="xtstp:number">
    <xsl:value-of select="." />
  </xsl:template>
  <xsl:template match="xtstp:qstring">
    <xsl:call-template name="qstring">
      <xsl:with-param name="value" select="."/>
    </xsl:call-template>
  </xsl:template>
  

  <!-- TODO: newlines in headers and comments -->
  <xsl:template match="xtstp:head">
<!--     <xsl:text>%</xsl:text> -->
<!--     <xsl:if test="@field!=''"> -->
<!--       <xsl:text> </xsl:text> -->
<!--       <xsl:value-of select="@field"/> -->
<!--       <xsl:value-of select="substring('            ',string-length(@field))"/> -->
<!--       <xsl:text> : </xsl:text> -->
<!--     </xsl:if> -->
<!--     <xsl:call-template name="replace-string"> -->
<!--      <xsl:with-param name="text" select="text()"/> -->
<!--      <xsl:with-param name="replace" select="'&#xa;'"/> -->
<!--      <xsl:with-param name="with" select="'&#xa;%                 '"/> -->
<!--     </xsl:call-template> -->
<!--     <xsl:text>&#xa;</xsl:text> -->
<!--     <xsl:if test="following-sibling::comment"> -->
<!--       <xsl:text>% Comment         </xsl:text> -->
<!--     </xsl:if> -->
  </xsl:template>

   <xsl:template match="xtstp:comment">
    <xsl:text>;;</xsl:text>
<!--     <xsl:call-template name="replace-string"> -->
<!--      <xsl:with-param name="text" select="text()"/> -->
<!--      <xsl:with-param name="replace" select="'&#xa;'"/> -->
<!--      <xsl:with-param name="with" select="'&#xa;%'"/> -->
<!--     </xsl:call-template> -->
<!--     <xsl:text>&#xa;</xsl:text> -->
  </xsl:template>


  <!-- record extensions -->
  <xsl:template match="xtstp:source">
    <!-- TODO xsl:text>,</xsl:text -->
    <xsl:if test="not(*)"> 
      <xsl:text>unknown</xsl:text>
    </xsl:if>
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="xtstp:dag-source">
    <xsl:value-of select="@name" />
  </xsl:template>
  
  <xsl:template match="xtstp:inference">
  </xsl:template>
  
  <xsl:template match="xtstp:parent-info">
  </xsl:template>
  
  <xsl:template match="xtstp:details">
  </xsl:template>
  
  <xsl:template match="xtstp:theory">
  </xsl:template>
  
  <xsl:template match="xtstp:file-source">
  </xsl:template>
  
  <xsl:template match="xtstp:creator">
  </xsl:template>
  
  <!-- TODO info*
  <xsl:template match="">
  </xsl:template>
  -->


  <xsl:template match="xtstp:info">
    <xsl:text>,</xsl:text>
    <!-- if there is no source, we must put there something -->
    <!-- TODO: narrow the query -->
    <xsl:if test="not(preceding-sibling::source[position()=1])"> 
      <xsl:text>unknown,</xsl:text>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>
