import java.util.List;

import java.io.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import javax.xml.namespace.QName;

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.Namespace;
import org.jdom.JDOMException;
import org.jdom.xpath.XPath;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;

import org.mathweb.core.BasicService;
import org.mathweb.onto.OWLJDom;

public class ShutdownMathServ extends BasicService
{
  
  private String serviceConfigFile = getSystemProperty("mathserv.services.config", "MATHSERV_SERVICES_CONFIG");
  private static OWLJDom owlJDom = OWLJDom.getInstance();
  private static String endpoint = "http://localhost:8080/axis/services/";
  public static final Namespace WSDD_NS = Namespace.getNamespace("wsdd","http://xml.apache.org/axis/wsdd/");
  public static final XPath servicex = newXPath("./wsdd:service");
  public static final XPath classNamex = newXPath("./wsdd:parameter[@name='className']/@value");
  public static final XPath methodsx = newXPath("./wsdd:parameter[@name='allowedMethods']/@value");
  public static final XPath msdlx = newXPath("./wsdd:parameter[@name='msdlDescription']/@value");
  
  public static XPath newXPath(String x)
  {
    try{
      XPath xpath =  XPath.newInstance(x);
      xpath.addNamespace(WSDD_NS);
      return xpath;
    } catch(Exception e){
      return null;
    }
  }

  public void shutdown()
  {
    try{
      String servXML = null;
      Element root = null;
      List servs = null;
      servXML = readFile(serviceConfigFile);
      if (servXML != null) {
	try{
	  root = owlJDom.getRootElement(servXML);    
	  servs = servicex.selectNodes(root);
	} catch(Exception e) {
	}
      }
      if (root == null) return;
      for(int i=0 ; i<servs.size(); i++){
	try { 
	  Element s = (Element) servs.get(i);
	  String servName = s.getAttributeValue("name");
	  String className = classNamex.valueOf(s);
	  String[] path = className.trim().split("[.]");
	  String qname = "http://";
	  for (int k = (path.length - 2); k > -1 ; k--){
	    qname = qname + path[k];
	    if (k>0) 
	      qname = qname + ".";
	  }
	  try {
	    Service  service = new Service();
	    Call     call    = (Call) service.createCall();
	    call.setTargetEndpointAddress( new java.net.URL(endpoint + servName) );
	    call.setOperationName(new QName(qname, "shutdown") );	
	    System.out.print("shutting down " +endpoint + servName + "...");
	    String ret = (String) call.invoke( new Object[0] );
	    System.out.println(" done.");
	    //  	  logger.info(" parsed!!!");
	    // 	  put(service);
	  } catch (Exception e) {
	    System.out.println(" failed.");
            e.printStackTrace();
	    //	    System.err.println(e.toString());
	  }
	} catch(Exception e){
	  e.printStackTrace();
	}
      }
    } catch(Exception e){
      e.printStackTrace();
    }
  }

  public static void main(String [] args) {
    ShutdownMathServ shut = new ShutdownMathServ();
    shut.shutdown();
    System.exit(0);
  }
}



