package org.mathweb.atp;

import java.io.*;
import java.util.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import javax.xml.namespace.QName;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;

import org.mindswap.query.ValueMap;

import org.mathweb.util.Java2WSDL;
import org.mathweb.owls.OWLSParser;
import org.mathweb.serv.ReasoningService;


public class AprosClient
{

  public String readFile(String fileName){
    try {
      FileInputStream isFile = new FileInputStream(fileName);
      int nChar;
      StringBuffer sbRead = new StringBuffer();
      nChar = isFile.read();
      while (nChar > -1) {
        sbRead.append((char) nChar);
        nChar = isFile.read();
      }
      isFile.close();
      return sbRead.toString();
    } catch (IOException ioe) {
      return null;
    }
  }

  public void waitMillis(long millis)
  {
    long t1 = System.currentTimeMillis();
    while ((System.currentTimeMillis() - t1) < millis);
  }
  
  public static void main(String [] args) {
    String msHome = System.getProperty("mathserv.home");
    try {
        String hostname;
        if ((args.length > 0) && (!args[0].trim().equals(""))) 
            hostname = args[0];
        else 
            hostname = "localhost";
        OWLSParser owlsParser = new OWLSParser();
        
        EClient c = new EClient();
        //c.waitMillis(3000);
        
        String wsdl = null;
      Vector ms = new Vector();
      ms.add("proveProblem");
      ms.add("proveProblemXml");
      
      wsdl = (new Java2WSDL()).java2WSDL(hostname, "OtterService", "org.mathweb.atp.Otter" , ms );
      System.out.println(" wsdl:  " + wsdl);

      ReasoningService service = owlsParser.parseServiceFile(msHome + "/etc/services/owls/1.1/AprosService.owl", wsdl);
      System.out.println("Service " + service);

      String fofProb;
      //      fofProb = c.readFile(msHome + "/examples/owl/fof2.owl");
      fofProb = c.readFile(msHome + "/examples/owl/omdoc1.owl"); 
      
      Hashtable map = new Hashtable();
      map.put("tstp_problem", fofProb);
      ValueMap resTab = service.invokeOWLS(map);
      System.out.println("Sent problem and got '" + resTab + "'");
      
    } catch (Exception e) {
      e.printStackTrace();
      System.err.println(e.toString());
    }
  }
}
