package org.mathweb.atp;

import java.io.*;
import java.util.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import javax.xml.namespace.QName;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;

import org.mindswap.query.ValueMap;

import org.mathweb.owls.OWLSParser;
import org.mathweb.onto.OWLJDom;
import org.mathweb.util.Java2WSDL;
import org.mathweb.util.TSTPCreator;
import org.mathweb.serv.ReasoningService;


public class EClient
{

  public String readFile(String fileName){
    try {
      FileInputStream isFile = new FileInputStream(fileName);
      int nChar;
      StringBuffer sbRead = new StringBuffer();
      nChar = isFile.read();
      while (nChar > -1) {
        sbRead.append((char) nChar);
        nChar = isFile.read();
      }
      isFile.close();
      return sbRead.toString();
    } catch (IOException ioe) {
      return null;
    }
  }

  public void waitMillis(long millis)
  {
    long t1 = System.currentTimeMillis();
    while ((System.currentTimeMillis() - t1) < millis);
  }
  
  public static void main(String [] args) {
    String msHome = System.getProperty("mathserv.home");
    OWLJDom owlJDom = OWLJDom.getInstance();
    TSTPCreator creator = new TSTPCreator();
    
    String timeInd = owlJDom.createTimeIndi(8, 8);
    try {
      String hostname;
      if ((args.length > 0) && (!args[0].trim().equals(""))) 
	hostname = args[0];
      else 
	hostname = "localhost";
      
      OWLSParser owlsParser = new OWLSParser();
      
      EClient c = new EClient();
      //c.waitMillis(3000);
      
      String fofProb;
      fofProb = c.readFile(msHome + "/examples/owl/cnf3.owl");
      fofProb = creator.tstp2OWLProblem(msHome + "/thirdParty/TPTPWorld/TPTP/Problems/LCL/LCL181-3.p");
      
      timeInd =  c.readFile(msHome + "/examples/owl/time.owl");

      String wsdl = null;
      Vector ms = new Vector();
      ms.add("proveProblem");
      
      wsdl = (new Java2WSDL()).java2WSDL(hostname, "EService", "org.mathweb.atp.E" , ms );
      System.out.println(" wsdl:  " + wsdl);

      ReasoningService service = owlsParser.parseServiceFile(msHome + "/etc/services/owls/1.1/EService.owl", wsdl);
      System.out.println("Service " + service);
      
      Hashtable map = new Hashtable();
      map.put("tstp_problem", fofProb);
      map.put("time_res", timeInd);

      ValueMap resTab = service.invokeOWLS(map);
      System.out.println("Sent problem and got '" + resTab + "'");
      
    } catch (Exception e) {
      System.err.println(e.toString());
    }
  }
}
