// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathWeb agent system

Authors: Juergen Zimmer

email: jzimmer@mathweb.org
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB nformatik                                            
Universitaet des Saarlandes                                          
Bau 36, 4. Stock                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathWeb, see 
http://www.mathweb.org/mathweb/agents

See the file "LICENSE" or
http://www.mathweb.org/mathweb/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/

/** For testing:

runt org.mathweb.broker.XmlRpcBrokerClient /home/jzimmer/import/mathserve/thirdParty/TPTPWorld/TPTP/Problems/PUZ/PUZ001+1.p 


*/
package org.mathweb.broker;

import java.io.*;
import java.util.*;

import java.util.Enumeration;
import java.util.ArrayList;
import java.util.Iterator;

import org.apache.xmlrpc.*;

import org.apache.log4j.Level;
import org.apache.log4j.Logger; 
import org.apache.log4j.FileAppender; 
import org.apache.log4j.SimpleLayout; 
import org.apache.log4j.PatternLayout; 

import org.jdom.*;

import org.mathweb.util.*;
import org.mathweb.core.BasicService;


/**
   @author Juergen Zimmer, Saarland University, Germany
   @version $Date: 2005/06/30 11:16:26 $ $Revision: 1.5 $
*/
public class XmlRpcBrokerClient extends BasicService {
  
  private static Logger logger = Logger.getLogger("XmlRpcBrokerClient");
  private static String logFileName = getSystemProperty("xmlrpcbroker.log.file", "XMLRPCBROKER_LOG_FILE");
  private static FileAppender appender = newAppender(logFileName);

  private org.apache.xmlrpc.XmlRpcClient brokerConnection;

  public XmlRpcBrokerClient()  {
    super();
    logger.setLevel(Level.ALL);
    //  logger.setLevel(Level.OFF);
    if (!logger.getAllAppenders().hasMoreElements()) logger.addAppender(appender);
  }
  
  private void test(String problem)   {
    try{
      System.out.println(problem);
      String url = "http://localhost:12345";
      int time = 10;
      brokerConnection = new org.apache.xmlrpc.XmlRpcClient(url);
      Vector params = new Vector();
      params.addElement(problem);
      params.addElement(new Integer(time));

  //     String command = "proveProblemChoice";
//       Object resultChoice = brokerConnection.execute(command, params);

//       command = "proveProblemSplit";
//       Object resultSplit = brokerConnection.execute(command, params);

//       command = "proveProblemOpt";
//       Object resultOpt = brokerConnection.execute(command, params);

//       System.out.println("choice: " + resultChoice);
//       System.out.println("split: " + resultSplit);
//       System.out.println("opt: " + resultOpt);
  
      Object zenonRes = brokerConnection.execute("proveProblemFocal", params);
      System.out.println("zenon: " + zenonRes);
  } catch (Exception e) {
      System.out.println("broker error " + e.getMessage());
    }
  }
    
  /*  the name a TSTP file. */
  public static void main(String argv[]) throws Exception {
    XmlRpcBrokerClient client = new XmlRpcBrokerClient();
    String problemFile = null;
    if (argv.length > 0) {
      problemFile = argv[0];
      String problem = client.readFile(problemFile);
      client.test(problem);
    }
  }
  
} // end XmlRpcBrokerClient.java

      
/* Settings for Emacs.
 * Local variables:
 * c-basic-offset: 2
 * tab-width: 2
 * indent-tabs-mode: nil
 * End:
 */

