/*****************************************************************
JADE - Java Agent DEvelopment Framework is a framework to develop 
multi-agent systems in compliance with the FIPA specifications.
Copyright (C) 2000 CSELT S.p.A. 

GNU Lesser General Public License

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, 
version 2.1 of the License. 

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.
*****************************************************************/
package org.mathweb.core;

import nl.tue.win.riaca.openmath.lang.*;

/**
@author Juergen Zimmer - University of Edinburgh
@version  $Date: 2004/04/18 17:53:20 $ $Revision: 1.1 $  
*/  
public class OMUtils {
   
  private static final char mynewline = (char) 10;

  public boolean equal(OMObject obj1, OMObject obj2){
    // TODO is that correct OMObject matching? 
    if ((obj1 instanceof OMString) && (obj2 instanceof OMString))
      return ((OMString) obj1).getString().equals(((OMString) obj2).getString());
    if ((obj1 instanceof OMSymbol) && (obj2 instanceof OMSymbol))
      return ( (((OMSymbol) obj1).getName().equals(((OMSymbol) obj2).getName()))
	       && (((OMSymbol) obj1).getCD().equals(((OMSymbol) obj2).getCD())));
    else return false;
  }
  
  public OMString trimOMString(OMString ostr)
  {
    String newstr = removeNewlines(ostr.getString());
    ostr.setString(newstr.trim());
    return ostr;
  }
  
  private String removeNewlines(String src){
    StringBuffer buffer = new StringBuffer();
    char[] array = new char[src.length()];
    src.getChars(0, src.length(), array, 0);
    LOOP: for(int i = 0; i < array.length; i++){
        if(array[i] == mynewline){
          continue LOOP;
        }
        buffer.append(array[i]);
    }
    return buffer.toString();
  }
  

  
}
