package org.mathweb.reasoning.logic;

/**
 * Argument is an abstract class representing an argument to a predicate.
 * The two types of arguments are constants and variables and as such
 * this class is the superclass of Constant and Varible
 *
 * @author Daniel Terry, Harlan Crystal
 * @date October 22, 2003
 */
public abstract class Argument extends Symbol{
    /**
     * Name constructor 
     * @param name The identifier for this Argument
     */
    public Argument(String name) {
	super(name);
    }

    /**
     * @return True if this argument is a variable.
     */
    public abstract boolean isVariable();
}
