package org.mathweb.reasoning.logic;

import org.mathweb.reasoning.parser.Parser;


/**
 * A Constant is represented by an argument, which is simply a symbol
 *
 * TODO: The set of identifiers for Variables should be disjoint from the
 * set used for Constants.  This is not enforced.
 *
 * @author Daniel Terry, Harlan Crystal
 * @date October 22, 2003
 */
public class Constant extends Argument {
 
    /**
     * Name Constructor
     *
     * @exception IllegalArgumentException Thrown if constant doesn't follow the naming convention.
     */
    public Constant(String name) {
	super(name);

//         if (! name.matches(Parser.CONSTANT_REGEX))
//             throw new IllegalArgumentException("Constants should be one or more lower case letters followed by zero or more numbers.");
    }

    public String toString(){
	return super.toString();
    }

    /**
     * @return False!  Used for checking if this is a variable or not when we don't know this is a constant, just an
     * argument.
     */
    public boolean isVariable() {
        return false;
    }

    public boolean equals(Constant name){
	return super.equals(name);
    }

    public boolean equals(Object name){
	try{
	    return equals((Constant)name);
	} catch(ClassCastException cce){
	    return false;
	}
    }


}

