package org.mathweb.reasoning.logic;


/**
 * A base class for representing symbols/names of various types.
 *
 * @author Daniel Terry.
 */
public class Symbol extends CachedHashCodeObject implements Comparable {
    private String name;

    /**
     * Construct a new symbol with given name.
     *
     * @param name The name of the symbol.
     */
    public Symbol(String name) {
        if (name == null)
            throw new IllegalArgumentException("Symbol with null name");
	this.name = name;
    }

    public String toString() {
	return name;
    }
    
    public boolean equals(Symbol s) {
        return name.equals(s.name);
    }

    public boolean equals(Object name){
	try{
	    return equals((Symbol) name);
	}
	catch(ClassCastException cse){
	    return false;
	}
    }

    public String getName(){
	return name;
    }

    public int compareTo(Object o) {
        Symbol s = (Symbol) o;
        
        return name.compareTo(s.name);
    }

    protected void computeHashCode() {
        this.myhashcode = name.hashCode();
    }
}
