package org.mathweb.reasoning.logic;

/**
 * A Variable is represented by an argument, which is simply a symbol
 *
 * An immutable class.
 *
 *TODO: The set of identifiers for Variables should be disjoint from the
 *      set used for Constants
 *
 * @author Daniel Terry, Harlan Crystal
 * @date October 22, 2003
 */
public class Variable extends Argument {
  private String type = null;
  /**
     * Name Constructor
     *
     * @param name The name of the variable.
     * @exception IllegalArgumentException Thrown if variable doesn't follow naming convention.
     */
    public Variable(String name) {
 	super(name);
//         if (! name.matches("[a-z]+[0-9]*")) 
//             throw new IllegalArgumentException("Variables should be one or more lower case letters followed by zero or more numbers.");
    }

    public Variable(String name, String type) {
 	super(name);
	this.type = type;
    }
    
    public String toString(){
	return super.toString();
    }

    public boolean isVariable() {
        return true;
    }

    public String getType() {
        return type;
    }

    public boolean equals(Variable name){
        return super.equals(name);
    }

    public boolean equals(Object name){
	try{
	    return equals((Variable)name);
	} catch(ClassCastException cce){
	    return false;
	}
    }

    /**
     * @return A new variable with given name.
     */
    public Variable rename(String name){
	return new Variable(name);
    }

    /**
     * Renames this variable to be followed by the number.
     * 
     * @param num The number to append to the name.
     * @return The renamed version of this variable.
     */
    public Variable rename(int num){
      String oldName = this.getName();
      String newName = oldName;
      // cut off the @number at the end of instantiated variable names
      String[] st= newName.split("@"); 
      if (st.length>0) newName = st[0];
      
      return rename(newName + "@" + num);
    }

}
