package org.mathweb.reasoning.partialorderplanner;
import javax.swing.tree.*;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import java.awt.*;
import javax.swing.border.*;
import java.util.*;
import org.mathweb.reasoning.planning.*;

public class ActionTree extends DTTree {
    Action action;

    public ActionTree(Action action) {
	super();
	this.action = action;
	rootNode.setUserObject(action.getTask());
	createNodes();
    }

    public void createNodes() {
 	DefaultMutableTreeNode preconditions = new DefaultMutableTreeNode("Preconditions");
 	addNodeAndExpand(rootNode, preconditions);
 	addAllChildren(action.copyPreconditions(), preconditions);

 	DefaultMutableTreeNode postconditions = new DefaultMutableTreeNode("PostConditions");
 	addNodeAndExpand(rootNode, postconditions);
 	addAllChildren(action.copyPostconditions(), postconditions);

 	DefaultMutableTreeNode bcs = new DefaultMutableTreeNode("Binding Constraints");
 	addNodeAndExpand(rootNode, bcs);
 	addAllChildren(action.getBindingConstraints().getSet(), bcs);
    }
}
