package org.mathweb.reasoning.partialorderplanner;
import javax.swing.*;
import javax.swing.tree.*;
import java.util.*;
import java.awt.*;

public class DTTree extends JTree {
    protected DefaultMutableTreeNode rootNode;
    protected DefaultTreeModel treeModel;

    public DTTree(){
	setRootVisible(true);
	rootNode = new DefaultMutableTreeNode("Root");
	treeModel = new DefaultTreeModel(rootNode);
	setModel(treeModel);
    }

    protected void addAllChildren(Collection children, DefaultMutableTreeNode parent){
	if(children.size() == 0){
	    parent.add(new DefaultMutableTreeNode("None"));
	    return;
	}
	for(Iterator it = children.iterator(); it.hasNext();){
	    DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(it.next());
	    addNodeAndExpand(parent, newNode);
	}
    }

    protected void addNode(DefaultMutableTreeNode parent, DefaultMutableTreeNode child){
	treeModel.insertNodeInto(child, parent, parent.getChildCount());
    }

    protected void addNodeAndExpand(DefaultMutableTreeNode parent, DefaultMutableTreeNode child){
	addNode(parent, child);
	
	expandPath(new TreePath(treeModel.getPathToRoot(parent)));
	makeVisible(new TreePath(treeModel.getPathToRoot(child)));

	//expandPath(new TreePath(child.getPath()));
    }


    public DefaultMutableTreeNode findNodeByUserObject(Object object){
	DefaultMutableTreeNode cur;
	for(Enumeration nodes = rootNode.depthFirstEnumeration(); nodes.hasMoreElements(); ){
	    cur = (DefaultMutableTreeNode)nodes.nextElement();
	    if(cur.getUserObject().equals(object))
		return cur;
	}
	return null;
    }

}
