package org.mathweb.reasoning.partialorderplanner;
import javax.swing.tree.DefaultMutableTreeNode;
import org.mathweb.reasoning.logic.*;
import org.mathweb.reasoning.planning.*;

public class POPTreeNode extends DefaultMutableTreeNode {
    PartialOrderPlan plan;
    OpenCondition openCondition;
    Action achiever;

    public POPTreeNode(PartialOrderPlan plan, OpenCondition openCondition, Action achiever){
	super(plan);
	this.plan = plan;
	this.openCondition = openCondition;
	this.achiever = achiever;
    }
    
    public String toString() {
	return achiever.getTask().toString() + " --> " + openCondition.getCondition() +
	    " --> " + openCondition.getOwner();
    }
}
