package org.mathweb.reasoning.partialorderplanner;
import javax.swing.*;
import javax.swing.tree.*;
import java.util.*;
import java.awt.*;
import javax.swing.border.*;
import org.mathweb.reasoning.logic.*;
import org.mathweb.reasoning.planning.*;

public class SearchTree extends DTTree {
    private PartialOrderPlanner planner;

    public SearchTree (PartialOrderPlanner planner){
	super();
	this.planner = planner;
	planner.setSearchTree(this);
 	setBorder(new LineBorder(Color.ORANGE, 3));
	rootNode.setUserObject(planner.getRoot().getPlan());
	
	initCellRenderer();

    }

    private void initCellRenderer(){
	//DefaultTreeCellRenderer r = new DefaultTreeCellRenderer();
	//r.setTextSelectionColor(Color.BLUE);
	//System.out.println((Component)r.getTreeCellRendererComponent(this, new String("HI"), false, true, true, 1,true));
	setCellRenderer(new SearchTreeCellRenderer());
    }

    public void addNode(Literal parent, org.mathweb.reasoning.planning.Action action, PartialOrderPlan plan){
	DefaultMutableTreeNode parentNode = findNodeByUserObject(parent);
	//addNode(parentNode, new SearchTreeActionNode(action, plan));
	addNodeAndExpand(parentNode, new SearchTreeActionNode(action, plan));
    }

    public void addNode(Object parent, Object newChild){
	DefaultMutableTreeNode parentNode = findNodeByUserObject(parent);
	//addNode(parentNode, new DefaultMutableTreeNode(newChild));
	addNodeAndExpand(parentNode, new DefaultMutableTreeNode(newChild));
    }

    private void addNode(DefaultMutableTreeNode planNode, Literal condition){
  	//addNode(planNode, new LiteralTreeNode(condition));
  	addNodeAndExpand(planNode, new LiteralTreeNode(condition));
    }
    
//     public void addNode(Literal condition, org.mathweb.reasoning.planning.Action action){
//  	DefaultMutableTreeNode parentNode = findNodeByUserObject(parent);
//  	addNode(parentNode, new DefaultMutableTreeNode(newChild));
//     }
    
//     public void addNode(org.mathweb.reasoning.planning.Action, PartialOrderPlan plan){
//  	DefaultMutableTreeNode parentNode = findNodeByUserObject(parent);
//  	addNode(parentNode, new DefaultMutableTreeNode(newChild));
//     }
    

//     public void addNode(PartialOrderPlan parent, PartialOrderPlan child, OpenCondition condition,org.mathweb.reasoning.planning.Action achiever){
//  	DefaultMutableTreeNode parentNode = findNodeByUserObject(parent);
//  	addNode(parentNode, new POPTreeNode(child, condition, achiever));
//     }

//     public void addNode(PartialOrderPlan parent, Literal condition) {
// 	DefaultMutableTreeNode parentNode = findNodeByUserObject(parent);
// 	addNode(parentNode, new POPTreeNode(condition));
//     }
}
