package org.mathweb.reasoning.planning;
import org.mathweb.reasoning.logic.*;
/**
 * An abstract interface that all planners should implement.
 *
 * @author Harlan Crystal, Daniel Terry
 * @date October 28, 2003
 */
public interface Planner {
    /**
     * Generates a plan to move from the given initial state to the goal state.
     *
     * @param initial The initial state.
     * @param goal The goal state.
     * @return A plan to move from the inital state to the goal state.  If no plan could be found, returns null.
     */
    public Plan generatePlan(State initial, State goal);
}
