package org.mathweb.reasoning.planning;

import org.mathweb.reasoning.logic.Symbol;
import org.mathweb.reasoning.partialorderplanner.NameGen;
/**
 * Represents the name of an action.
 *
 * @author Daniel Terry, Harlan Crystal
 */
public class Task extends Symbol {
    public Task(String name){
	super(name);
    }

    public boolean equals(Task name){
	return super.equals(name);
    }

    public boolean equals(Object name){
	try{
	    return equals((Task)name);
	}catch(ClassCastException cce){
	    return false;
	}
    }
    
    public boolean equalsByOriginalName(Task t) {
      String name1, name2;
      String[] st1 = this.getName().split("_"); 
      if (st1.length > 1) name1 = st1[0]; else name1= this.getName();
      String[] st2 = t.getName().split("_");
      if (st2.length > 1) name2 = st2[0]; else name2= t.getName();
      return name1.equals(name2);
    }

    /**
     * Renames this task.
     *
     * @param nameGen Used to generate unique names.
     * @return The renamed version of this task.
     */
    public Task rename(NameGen nameGen) {
        return new Task(getName() + "_" + nameGen.getNext());
    }
}
