package org.mathweb.reasoning.search;
import java.util.Vector;
import java.util.Collection;
import java.util.Iterator;
/**
 * A abstract fringe so searching methods can be interchanged easily.
 *
 * @author Harlan Crystal, Daniel Terry
 * @date October 28, 2003
 */
public interface Fringe {

    /**
     * Adds a collection of Nodes to the fringe.
     */
    public void addAllToFringe(Collection nodes);

    /**
     * Adds a Node that is a successor from an expanded node.
     */
    public void addToFringe(Node nextNode);

    /**
     * @return True if there are any more nodes in the fringe to expand.
     */
    public boolean hasNext();

    /**
     * @return The next Node to continue searching from.
     */
    public Node getNext();

    /**
     * @return The number of nodes in the fringe.
     */
    public int size();

}
