package org.mathweb.reasoning.search;
/**
 * A wrapper class which contains the depth of a node in the search space.
 *
 * Should be subclassed to carry any other data.
 *
 * @author Harlan Crystal, Daniel Terry
 * @date November 22, 2003
 */
public class Node {
    private final int depth;
    
    public Node(int depth) {
        this.depth = depth;
    }

    public int getDepth() {
        return depth;
    }
    
    public String toString() {
        return "Node depth: " + depth;
    }

    public int hashCode() {
        return (new Integer(depth)).hashCode();
    }

    public boolean equals(Node n) {
        return n.depth == depth;
    }

    public boolean equals(Object o) {
        try {
            return equals((Node) o);
        } catch (ClassCastException e) {
            return false;
        }
    }
}
