package org.mathweb.reasoning.search;
import java.util.Vector;
import java.util.Collection;
import java.util.Iterator;
/**
 * A Queue for doing BFS search strategy.
 *
 * @author Harlan Crystal, Daniel Terry
 * @date October 28, 2003
 */
public class Queue implements Fringe {
    private Vector queue;

    public Queue() {
        queue = new Vector();
    }

    public void addAllToFringe(Collection nodes) {
        queue.addAll(nodes);
    }

    public void addToFringe(Node nextNode) {
        queue.add(nextNode);
    }

    public boolean hasNext() {
        return ! queue.isEmpty();
    }

    public Node getNext() {
      Node next = (Node) queue.get(0);
      queue.remove(0);
      return next;
    }

    public Object stackPop() {
	Object next = queue.get(queue.size()-1);
	queue.remove(queue.size()-1);
	return next;
    }

    public int size() {
        return queue.size();
    }

    public String toString() {
        String ret = "{";
        for (Iterator it = queue.iterator(); it.hasNext(); )
            ret += it.next();
        return ret +"}";
    }
}
