// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathWeb agent system

Authors: Juergen Zimmer

email: jzimmer@mathweb.org
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB nformatik                                            
Universitaet des Saarlandes                                          
Bau 36, 4. Stock                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathWeb, see 
http://www.mathweb.org/mathweb/agents

See the file "LICENSE" or
http://www.mathweb.org/mathweb/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/
package org.mathweb.serv;

import org.jdom.Element;

import org.mathweb.serv.*;


/**
 * Example of a useful base class for handing agent arguments.
 * Classes which formerly extended jade.Agent may now extend this class.
 */
public class Input {

  public String name;
  public String signature;
  public String contents;

  public Input()
  {
    name = "";
    signature= "";
  }

  public Input(String n, String sig)
  {
    name = n;
    signature= sig;
  }
 
  public Input(String n, String sig, String cont)
  {
    name = n;
    signature= sig;
    contents = cont;
  }
  
  public String getName(){ return name;}
  public String getSignature() { return signature; }
  public String getContents(){ return contents;}
  
  public void trim(){
    signature = signature.trim();
  }
  
  public String toString()
  {
    // TODO
    return name + ":: " + signature.toString();
  }
  
}
