// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathWeb agent system

Authors: Juergen Zimmer

email: jzimmer@mathweb.org
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB nformatik                                            
Universitaet des Saarlandes                                          
Bau 36, 4. Stock                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathWeb, see 
http://www.mathweb.org/mathweb/agents

See the file "LICENSE" or
http://www.mathweb.org/mathweb/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/


package org.mathweb.trans;

import java.io.*;
import java.util.Vector;
import java.net.MalformedURLException;


import org.apache.log4j.Level;
import org.apache.log4j.Logger; 

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.Namespace;
import org.jdom.JDOMException;
import org.jdom.xpath.XPath;

import dk.capgemini.tc.JProf;

import org.mathweb.core.BasicService;
import org.mathweb.core.CommandThread;

import org.mathweb.atp.TSTP2X;
import org.mathweb.atp.Otter;

import org.mathweb.onto.OntoReasoner;
import org.mathweb.onto.PellReasoner;
import org.mathweb.onto.OWLJDom;


/**
@author Juergen Zimmer University of Edinburgh
@version $Date: 2005/06/29 14:07:14 $ $Revision: 1.8 $
*/
public class Otterfier extends BasicService {

  static boolean verbose=true;
  
  protected static String resultConcept = "TstpCnfBrFPRefutation";

 /**  executables and environments */
//   public String ACL_HOME = getSystemProperty("acl.home", "ACL_HOME");
//   public String[] acl_envs = new String[] {"ACL_HOME="+ACL_HOME};
//   public String aclExecutable = findSystemExecutable(ACL_HOME, "lisp", "alisp");
  
//   public String OtterfierDump = getSystemProperty("Otterfier.dump", "OTTERFIER_DUMP");
//   public String OtterfierExecutable = getSystemProperty("Otterfier.exec", "OTTERFIER_EXEC");
//   public String OtterfierXtermExecutable = getSystemProperty("Otterfier.exec.xterm", "OTTERFIER_EXEC_XTERM");
//   public String OtterfierEmacs = getSystemProperty("Otterfier.emacs.exec", "OTTERFIER_EMACS_EXEC");
//   public String OtterfierIlisp = getSystemProperty("Otterfier.ilisp", "OTTERFIER_ILISP");
//   public String emacsGeometry = getSystemProperty("Otterfier.emacs.geometry", "OTTERFIER_EMACS_GEOMETRY");

  /** TSTP trafo stuff */
  private static TSTP2X tstp2X = new TSTP2X();
  
  /** Ontology stuff */
  private static OWLJDom owlJDom;
  private static OntoReasoner reasoner;
  
  /** For communication with Lisp process */
  private static String sep = File.separator;

  public static final int defaultNice = 15;
  public Throwable exception;
  private static Logger logger = Logger.getLogger("Otterfier");

  public Otterfier()
  {
    super();
    owlJDom = OWLJDom.getInstance();
    //    reasoner =  PellReasoner.getNewReasoner();
    //logger.setLevel(Level.OFF);
    logger.setLevel(Level.ALL);
  }
  
  
  /**
   * Translate a resolution proof into a resolution proof 
   * in restricted Otter calculus:
   *   binary resolution, paramodulation, and factoring.
   * 
   * @param atpResult string containing the result of a first-order 
   *        theorem prover containing a resolution proof object.
   * @return A new FoAtpResult containing an equivalent resolution proof.
   */
  public String otterfy(String atpResult)
  {
    long startTime = System.currentTimeMillis();
    long cpuStart = JProf.getCurrentThreadCpuMillis();
    return owlJDom.createFailure(null, startTime, cpuStart, "Error: Otterfier hasn't been integrated yet!");
  }
  
  private String createResult(String probID, String stat, String output) {

    return null;
  }
  
  public void shutdown()
  {
    return;
  }

  public void test () {
    try {
      String tstpProof = readFile(msHome + "/examples/owl/otterfier-in.owl");
      String otterfied = otterfy(tstpProof);
      logger.info(otterfied);
    }
    catch(Exception ex){
      ex.printStackTrace();
    }
  } //end test()
  
  
  public static void main(String argv[]) throws Exception {
    Otterfier e = new Otterfier();
    e.test();
  }
  
} // end Otterfier.java


/* Settings for Emacs.
 * Local variables:
 * c-basic-offset: 2
 * tab-width: 2
 * indent-tabs-mode: nil
 * End:
 */
