package org.mathweb.trans;

import java.io.*;
import java.util.*;
import javax.xml.namespace.QName;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;

import org.mindswap.query.ValueMap;


import org.mathweb.owls.OWLSParser;
import org.mathweb.serv.ReasoningService;

public class TrampCNFClient
{

  public String readFile(String fileName){
    try {
      FileInputStream isFile = new FileInputStream(fileName);
      int nChar;
      StringBuffer sbRead = new StringBuffer();
      nChar = isFile.read();
      while (nChar > -1) {
        sbRead.append((char) nChar);
        nChar = isFile.read();
      }
      isFile.close();
      return sbRead.toString();
    } catch (IOException ioe) {
      return null;
    }
  }

  public void waitMillis(long millis)
  {
    long t1 = System.currentTimeMillis();
    while ((System.currentTimeMillis() - t1) < millis);
  }
  
  public static void main(String [] args) {
    String msHome = System.getProperty("mathserv.home");
    try {
      String endpoint = 
	"http://localhost:8080/axis/services/TrampCNF";
      OWLSParser owlsParser = new OWLSParser();
      
      TrampCNFClient c = new TrampCNFClient();
      
      String fofProb = c.readFile(msHome + "/examples/owl/fof2.owl");
      
      ReasoningService service = owlsParser.parseServiceFile(msHome + "/etc/services/owls/1.1/TrampCNFService.owl");
      System.out.println("Service " + service);
      
      Hashtable map = new Hashtable();
      map.put("fof_problem", fofProb);
      ValueMap resTab = service.invokeOWLS(map);
      System.out.println("Sent problem and got '" + resTab + "'");
      

    } catch (Exception e) {
      e.printStackTrace();
      System.err.println(e.toString());
    }
  }
}
