package org.mathweb.trans;


import java.io.*;
import java.util.*;
import javax.xml.namespace.QName;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;

import org.mindswap.query.ValueMap;


import org.mathweb.owls.OWLSParser;
import org.mathweb.serv.ReasoningService;

public class TrampNDClient
{

  public String readFile(String fileName){
    try {
      FileInputStream isFile = new FileInputStream(fileName);
      int nChar;
      StringBuffer sbRead = new StringBuffer();
      nChar = isFile.read();
      while (nChar > -1) {
        sbRead.append((char) nChar);
        nChar = isFile.read();
      }
      isFile.close();
      return sbRead.toString();
    } catch (IOException ioe) {
      return null;
    }
  }

  public void waitMillis(long millis)
  {
    long t1 = System.currentTimeMillis();
    while ((System.currentTimeMillis() - t1) < millis);
  }
  
  public static void main(String [] args) {
    try {
      String msHome = System.getProperty("mathserv.home");
      String endpoint = 
	"http://localhost:8080/axis/services/TrampNDforFOF";
      
      OWLSParser owlsParser = new OWLSParser();
      
      TrampNDClient c = new TrampNDClient();
      
      String fofProb = c.readFile(msHome + "/examples/owl/fof5.owl");
      String tstpProof = c.readFile(msHome + "/examples/owl/otter-proof5.owl");
      String deltaRel = "";
      
      ReasoningService service = owlsParser.parseServiceFile(msHome + "/etc/services/owls/1.1/TrampNDService.owl");
      System.out.println("Service " + service);
      
      Hashtable map = new Hashtable();
      map.put("fof_problem", fofProb);
      map.put("atp_result", tstpProof);
      map.put("delta_relation", deltaRel);
      ValueMap resTab = service.invokeOWLS(map);
      System.out.println("Sent problem and got '" + resTab + "'");

      //      c.waitMillis(3000);
       } catch (Exception e) {
           System.err.println(e.toString());
       }
   }
}
