/* This class is part of the ActiveMath project.
   Copyright D.F.K.I. GmbH, Saarbruecken, Germany
   Please refer to the License that was in the distribution.
   Using this software presupposes you agree with it.
*/

package org.mathweb.util;

import java.util.LinkedList;


/**
 * Queue.java
 *
 * A straightforward implementation of a queue.
 *
 * Created: Thu Mar  7 10:49:49 2002
 *
 * @author <a href="http://www.ags.uni-sb.de/~eric">Eric Andres</a>
 *         <a href="mailto:eric@ags.uni-sb.de"><small><font color=green>(E-Mail)</font></small></a>
 */

public class Queue {

  LinkedList _list = new LinkedList();

  /**
   * Default Constructor
   */
  public Queue() {
    //----------
  }
  public void show()
  {
    for(int i=0; i<_list.size(); i++)
      System.out.print(_list.get(i) + " " );
    System.out.println("");
  }
  
  public boolean isEmpty()
  {
    return _list.isEmpty();
  }
  
  /**
   * enqueue the given message at the end of the list.
   *
   * @param mess the message to enqueue. 
   */
  public synchronized void enqueue(Object mess) {
    //------------------------------------------
    
    _list.addLast(mess);
    notifyAll();
  }
  
  public boolean contains(Object o)
  {
    return   _list.contains(o);
  }
  
  /**
   * dequeues the first element of this queue.
   */
  public synchronized Object dequeue() { //throws InterruptedException {
    //--------------------------------------------------------------

    //     while (_list.size() == 0) {
    //       wait();
    //     }
    
    Object m = _list.getFirst();
    _list.removeFirst();
    notifyAll();
    return m;
  }

}







