// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathWeb agent system

Authors: Juergen Zimmer

email: jzimmer@mathweb.org
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB nformatik                                            
Universitaet des Saarlandes                                          
Bau 36, 4. Stock                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathWeb, see 
http://www.mathweb.org/mathweb/agents

See the file "LICENSE" or
http://www.mathweb.org/mathweb/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/
package org.mathweb.util;

import java.io.*;
import java.util.*;

import org.apache.log4j.Level;
import org.apache.log4j.Logger; 
import org.apache.log4j.FileAppender; 
import org.apache.log4j.SimpleLayout; 

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.Namespace;
import org.jdom.JDOMException;
import org.jdom.xpath.XPath;

/**
@author Juergen Zimmer, Saarland University, Germany
@version $Date: 2005/06/29 14:28:43 $ $Revision: 1.5 $
*/
public class Quoter {
  
  public String readFile(String fileName){
    try {
      FileInputStream isFile = new FileInputStream(fileName);
      int nChar;
      StringBuffer sbRead = new StringBuffer();
      nChar = isFile.read();
      while (nChar > -1) {
        sbRead.append((char) nChar);
        nChar = isFile.read();
      }
      isFile.close();
      return sbRead.toString();
    } catch (IOException ioe) {
      return null;
    }
  }
  
  public String quote(String input){
    try {
      Text text = new Text(input);
      StringWriter writer = new StringWriter();
      XMLOutputter outputter = new XMLOutputter(" ", true);
      outputter.output(text, writer);
      //      System.out.println(writer.toString());
      return writer.toString();
    }
    catch(Exception ex){
      ex.printStackTrace();
      return null;
    }
  }
  
  public static void main(String[] args) {
    try {
      Quoter quote  = new Quoter();
      String string = quote.readFile(args[0]); 
      Element root = new Element("quoted", "http://www.tptp.org#");
      root.addContent("\n");
      root.addContent(string);
      StringWriter writer = new StringWriter();
      Document doc = new Document(root);
      XMLOutputter outputter = new XMLOutputter(" ", true);
      outputter.output(doc, writer);
      //      System.out.println(writer.toString());
    }
    catch(Exception ex){
      ex.printStackTrace();
    }
    System.exit(0);
  }
}

