// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathWeb agent system

Authors: Juergen Zimmer

email: jzimmer@mathweb.org
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB nformatik                                            
Universitaet des Saarlandes                                          
Bau 36, 4. Stock                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathWeb, see 
http://www.mathweb.org/mathweb/agents

See the file "LICENSE" or
http://www.mathweb.org/mathweb/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/
package org.mathweb.util;

import java.io.*;
import java.util.*;

import org.apache.log4j.Level;
import org.apache.log4j.Logger; 
import org.apache.log4j.FileAppender; 
import org.apache.log4j.SimpleLayout; 

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.Namespace;
import org.jdom.JDOMException;
import org.jdom.xpath.XPath;

import javax.xml.transform.Transformer;
import javax.xml.transform.ErrorListener;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

/**
@author Juergen Zimmer, Saarland University, Germany
@version $Date: 2005/04/12 12:10:42 $ $Revision: 1.1 $
*/
public class XslTrafo {
  
  public String readFile(String fileName){
    try {
      FileInputStream isFile = new FileInputStream(fileName);
      int nChar;
      StringBuffer sbRead = new StringBuffer();
      nChar = isFile.read();
      while (nChar > -1) {
        sbRead.append((char) nChar);
        nChar = isFile.read();
      }
      isFile.close();
      return sbRead.toString();
    } catch (IOException ioe) {
      return null;
    }
  }
  
  public static void main(String[] args) {
    try {
      XslTrafo trafo = new XslTrafo();
      String tptp2PostXslStr = trafo.readFile(args[0]);
      String tstpXml = trafo.readFile(args[1]);
      StringReader tptp2PostXsl = new StringReader(tptp2PostXslStr);
      
      TransformerFactory tFactory = TransformerFactory.newInstance();
      Transformer  transformer = tFactory.newTransformer(new StreamSource(tptp2PostXsl));
      StringWriter  writer = new StringWriter();
      transformer.transform(new StreamSource(new StringReader(tstpXml)), 
			    new StreamResult(writer));
      System.out.println(writer.toString());
    }
    catch(Exception ex){
      ex.printStackTrace();
    }
    System.exit(0);
  }
}

