
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : mathweb.scm
;; DESCRIPTION : Secure routines for mathweb plugin
;; AUTHOR      : Henri Lesourd, Uni Saarbrucken, 2004.
;;
;; This software falls under the GNU general public license and comes WITHOUT
;; ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(texmacs-module (mathweb)
  (:use (texmacs plugin plugin-cmd))
  (:export mathweb-call mathweb-initialize))

(define (mathweb-initialize)
  (display* "Loading Mathweb...\n"))

(tm-define (mathweb-call cmd data)
  (:type (string string -> object))
  (:synopsis "Call a MathWeb service")
  (:secure #t)
  (display* "c=" cmd "; d=" data "_\n")
  (cond
   ((in? cmd '("prove" "compute"))
    (display "prove|compute\n")
    (if (string? data)
        (plugin-eval "mathweb" "default" (string-append cmd "#" data))
        "The given input is not a string!"
    ))
   (else "Unknown command")
   )
  )
