//-----------------------------------------------------------------------------
#define MAX_PARENTS 64
//-----------------------------------------------------------------------------
typedef struct {
    int ForceContinue;
    int Quietness;
    int VerifyLeaves;
    String ProblemFileName;
    int CheckParentRelevance;
    int CheckRefutation;
    String TheoremProver;
    String ModelFinder;
    String Saturator;
    String UnsatisfiabilityChecker;
    int TimeLimit;
    int KeepFiles;
    String KeepFilesDirectory;
    String DerivationFileName;
} OptionsType;

typedef ANNOTATEDFORMULA ANNOTATEDFORMULAArray[MAX_PARENTS];
//-----------------------------------------------------------------------------
#define QPRINTF(Q,P) if ((P) >= (Q.Quietness)) printf
//-----------------------------------------------------------------------------
#define OTTER "Otter---3.3"
#define PARADOX "Paradox---1.1"
#define SPASS "SPASS---2.1"
#ifndef TPTP_HOME
    #define TPTP_HOME "/home/graph/tptp"
#endif
#define SYSTEM_ON_TPTP "SystemExecution/SystemOnTPTP"

#define DEFAULT_THEOREM_PROVER OTTER
#define DEFAULT_MODEL_FINDER PARADOX
#define DEFAULT_SATURATOR SPASS
#define DEFAULT_UNSATISFIABILITY_CHECKER OTTER
#define DEFAULT_TIME_LIMIT 30

#define DEFAULT_KEEP_FILES_DIRECTORY "/tmp"
//-----------------------------------------------------------------------------
int GlobalInterrupted;
//-----------------------------------------------------------------------------
