#ifndef PARSING_H
#define PARSING_H
//-----------------------------------------------------------------------------
#include "DataTypes.h"
#include "Tokenizer.h"
//-----------------------------------------------------------------------------
void SetAllowFreeVariables(int OnOff);

void IncreaseVariableUseCount(VARIABLENODE Variable,int HowMuch);

void PrintVariableList(VARIABLENODE Variables);
TERM NewTerm(void);
void FreeTerm(TERM * Term,VARIABLENODE * Variables);
TERM DuplicateTerm(TERM Original,ContextType Context,int ForceNewVariables);

FORMULA NewFormula(void);
void FreeFormula(FORMULA * Formula,VARIABLENODE * Variables);
FORMULAWITHVARIABLES NewFormulaWithVariables(void);
TERM ParseTerm(READFILE Stream,ContextType Context,VARIABLENODE * EndOfScope,
TermType Type,ConnectiveType Quantification,int * InfixNegatedAtom,
int VariablesMustBeQuantifiedAlready);
FORMULA ParseAtom(READFILE Stream,ContextType Context,
VARIABLENODE * EndOfScope,int VariablesMustBeQuantifiedAlready);
FORMULA ParseUnaryFormula(READFILE Stream,ContextType Context,
VARIABLENODE * EndOfScope,int VariablesMustBeQuantifiedAlready);
FORMULA DuplicateFormula(FORMULA Original,ContextType Context,
int ForceNewVariables);

void FreeFormulaWithVariables(FORMULAWITHVARIABLES * FormulaWithVariables);
FORMULAWITHVARIABLES DuplicateFormulaWithVariables(FORMULAWITHVARIABLES 
Original,SIGNATURE Signature,int ForceNewVariables);
FORMULA DuplicateInternalFormulaWithVariables(FORMULA Original,ContextType
OriginalContext);
FORMULAWITHVARIABLES ParseFormulaWithVariables(READFILE Stream,
SIGNATURE Signature,int VariablesMustBeQuantifiedAlready);

//----Exported for use by main routine
ANNOTATEDFORMULA DuplicateAnnotatedFormula(ANNOTATEDFORMULA Original,
SIGNATURE Signature);
void FreeAnnotatedFormula(ANNOTATEDFORMULA * AnnotatedFormula);
ANNOTATEDFORMULA ParseAnnotatedFormula(READFILE Stream,SIGNATURE Signature);

LISTNODE ParseFILEOfFormulae(FILE * FileStream,SIGNATURE Signature,
int ExpandIncludes,char * NameFilter);
LISTNODE ParseFileOfFormulae(char * FileName,char * CurrentFileName,
SIGNATURE Signature,int ExpandIncludes,char * NameFilter);
LISTNODE ParseStringOfFormulae(char * Content,SIGNATURE Signature,
int ExpandIncludes,char * NameFilter);
TERM ParseStringTerm(char * Content,SIGNATURE Signature,
int VariablesMustBeQuantifiedAlready);
//-----------------------------------------------------------------------------
#endif
