#include <stdio.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include "DataTypes.h"
#include "Utilities.h"
#include "Tokenizer.h"
#include "Parsing.h"
#include "Signature.h"
#include "Examine.h"
#include "List.h"
#include "Tree.h"
#include "TreeStatistics.h"
#include "ListStatistics.h"
#include "PrintTSTP.h"
//-----------------------------------------------------------------------------
int main(int argc, char *argv[]) {

    LISTNODE Head;
    SIGNATURE Signature;
    ListStatisticsRecordType Statistics;

    if (argc == 1) {
        printf("Usage: MakeListStats <TSTP file name>\n");
        return(0);
    }

    Signature = NewSignature();
    SetNeedForNonLogicTokens(0);
    SetAllowFreeVariables(1);
    if ((Head = ParseFileOfFormulae(argv[1],NULL,Signature,1,NULL)) != NULL) {
        if (GetListStatistics(Head,&Statistics) != NULL) {
            PrintListStatistics(stdout,Statistics);
        } else {
            printf("ERROR: Could not get statistics for %s\n",argv[1]);
        }
        FreeListOfAnnotatedFormulae(&Head);
        assert(Head == NULL);
    } else {
        printf("ERROR: Could not parse %s\n",argv[1]);
    }

    return(0);
}
//-----------------------------------------------------------------------------
