#include <stdio.h>
#include <unistd.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <sys/wait.h>

int main(int argc, char* argv[]) {

struct rusage ResourceUsage;
int KBUsed;
int ChildPID;
int DiedPID;

if ((ChildPID = fork()) == 0) {
/*----Child - start process */
    execv(argv[1],argv+1);
    perror("Did not start process");
    exit(-1);
    }

/*----If here, then parent */
DiedPID = 0;
while (((DiedPID = wait(NULL)) != ChildPID) && (DiedPID != -1))
    printf("Process %d died\n",DiedPID);
printf("The child PID was %d\n",ChildPID);

if (getrusage(RUSAGE_CHILDREN,&ResourceUsage) == 0) {
    KBUsed = (ResourceUsage.ru_maxrss * getpagesize()) / 1024 ;
    printf("Used %d KB\n",KBUsed);
    }
else {
    perror("Error getting resource usage");
    exit(-2);
    }

exit(0);
}
