#!/usr/local/bin/perl -w

use strict "vars";
#------------------------------------------------------------------------------
sub eqp {
    my($InputLine,%AKAs) = @_;

    my $Language;
    my $Name;
    my $FinalName;
    my $Source;
    my @SourceParts;
    my $Formula;
    my @AlternativeNames;
    my $InferenceRule;
    my @Parents;
    my $Parent;
    my $Parents;
    my $Type;
    my @Source;
    my @UsefulInfos;
    my @TPTPLiterals;
    my $LHS;
    my $RHS;
    my $Sign;

    my @EqualityInferenceRules = (
        "para",
        "demod",
        "back_demod",
        "flip",
    );

#----Clause normal form, cnf, is assumed to be the language of the Otter file.
    $Language = "cnf";
#----Extract main components
#DEBUG print(stderr "=========InputLine is $InputLine\n");
    ($Name,$Source,$Formula) = ($InputLine =~ /^([\d,]*) \(wt=\d+\) \[(.*)\] (.*)\. *$/);
#DEBUG print("Name is $Name\n");
#DEBUG print("Source is $Source\n");
#DEBUG print("Formula is $Formula\n");

#----If some error, just return the language
    if (!defined($Name) || !defined($Source) || !defined($Formula)) {
        return($Language);
    }

#----Get the name
    @AlternativeNames = split(/,/,$Name);
    $FinalName = shift(@AlternativeNames);
    foreach $Name (@AlternativeNames) {
        $AKAs{$Name} = $FinalName;
    }

#----Check if initial or inferred
    if ($Source eq "") {
        $Type = "initial";
        @UsefulInfos = ();
        @Source = ("file");
#DEBUG print("Made a file source\n");
    } else {
        $Type = "derived";
        @UsefulInfos = ("iquote('$Source')");
        @Source = ();
        while ($Source ne "") {
            ($InferenceRule,$Parents,$Source) = ($Source =~ 
/([a-z]+)\(([^\)]+)\)(.*)$/);
            $Source =~ s/^,//;
            $Parents =~ s/^\[//;
            $Parents =~ s/\]$//;
            $InferenceRule =~ tr/A-Z/a-z/;
#DEBUG print("Inference rule ==$InferenceRule==\n");
#DEBUG print("Parents ==$Parents==\n");
#DEBUG print("Remaining source ==$Source==\n");
#----If a subinference already exists, keep it
            if (scalar(@Source) > 0) {
                @Parents = [MakeArray(@Source)];
#DEBUG print("inference parent to start\n");
            } else {
#DEBUG print("no parents to start\n");
                @Parents = ();
            }
#----Get the rest of the parents
            @SourceParts = split(/,/,$Parents);
            while (scalar(@SourceParts) > 0) {
                $Parent = shift(@SourceParts);
#----If any have an AKA, use that
                if (exists($AKAs{$Parent})) {
#DEBUG print("$Parent is also known as $AKAs{$Parent}\n");
                    $Parent = $AKAs{$Parent};
                }
                push(@Parents,($Parent));
#DEBUG print("added parent ==$Parent==@Parents==\n");
            }
#----Check if equality parent is needed
            if (grep(/$InferenceRule/,@EqualityInferenceRules)) {
                push(@Parents,("theory(equality)"));
            }
            @Source = ("inference",$InferenceRule,["status(thm)"],[@Parents]);
#DEBUG print("Made an inference source\n");
        }
    }

#----Fix up the clause.
#----Check if the empty clause
    if ($Formula =~ /\$F/) {
        @TPTPLiterals = ('$false');
    } else {
#----Rename Skolems
        $Formula =~ s/\$/sk_/g;
        if ($Formula =~ /^-\(/) {
            $Sign = "~";
            ($Formula) = ($Formula =~ /^-\((.*)\)$/);
        } else {
            $Sign = "";
        }
        ($LHS,$RHS) = ($Formula =~ /(.*) = (.*)/);
#----Remove leading spaces (sometimes there?)
        $LHS =~ s/^ *//;
        $RHS =~ s/^ *//;
        @TPTPLiterals = ("${Sign}equal($LHS,$RHS)");
    }


    return($Language,$FinalName,$Type,[@TPTPLiterals],[@Source],[@UsefulInfos],
%AKAs);
}
#------------------------------------------------------------------------------
return 1;
#------------------------------------------------------------------------------
