#!/usr/local/bin/perl -w

use strict "vars";
#------------------------------------------------------------------------------
sub gandalf {
    my($InputLine) = @_;

    my $Language;
    my $Name;
    my $Source;
    my @SourceParts;
    my $Formula;
    my @AlternativeNames;
    my $InferenceRule;
    my @Parents;
    my $Parent;
    my $Type;
    my @Source;
    my @UsefulInfos;
    my @TPTPLiterals;
    my @GandalfLiterals;
    my $Literal;

    my @EqualityInferenceRules = (
        "para",
        "demod",
    );

#----Clause normal form, cnf, is assumed to be the language
    $Language = "cnf";
#----Extract main components
    ($Name,$Source,$Formula) = ($InputLine =~ /^([\d]*) +\[(.*)\] +(.*)$/);
#----Delete trailing . and spaces (. missing on last - useless!)
#DEBUG print("Formula is initially $Formula\n");
    $Formula =~ s/\. *$//;
    $Formula =~ s/(\^.)/gupper($1)/eg;
#DEBUG print("Formula is now $Formula\n");

#----Discard if one of those weird lines - will fail verification
    if ($Source eq "?" && $Formula eq "?") {
        $Source = "";
        $Formula = "missing_in_proof_output";
    }

    @SourceParts = split(/[:,]/,$Source);
#----Check if initial or inferred
    if (scalar(@SourceParts) == 0) {
        $Type = "initial";
        @UsefulInfos = ();
        @Source = ("file");
#DEBUG print("Made a file source\n");
    } else {
        $Type = "derived";
        @UsefulInfos = ("iquote('$Source')");
        @Source = ();
        while (scalar(@SourceParts) > 0) {
            $InferenceRule = shift(@SourceParts);
            $InferenceRule =~ tr/A-Z/a-z/;
#DEBUG print("Inference rule ==$InferenceRule==\n");
#----If a subinference already exists, keep it
            if (scalar(@Source) > 0) {
                @Parents = [MakeArray(@Source)];
#DEBUG print("inference parent to start\n");
            } else {
#DEBUG print("no parents to start\n");
                @Parents = ();
            }
#----Get the rest of the parents
            while (scalar(@SourceParts) > 0 && $SourceParts[0] =~ /^\d/) {
                $Parent = shift(@SourceParts);
#----Remove details - just want the name here
                $Parent =~ s/\..*//;
                push(@Parents,($Parent));
#DEBUG print("added parent ==$Parent==@Parents==\n");
            }
#----Check if equality parent is needed
            if (grep(/$InferenceRule/,@EqualityInferenceRules)) {
                push(@Parents,("theory(equality)"));
            }
            @Source = ("inference",$InferenceRule,["status(thm)"],[@Parents]);
#DEBUG print("Made an inference source\n");
        }
    }

#----Fix up the clause.
#----Check if the empty clause
    if ($Formula eq "contradiction") {
        @TPTPLiterals = ('$false');
    } else {
        @TPTPLiterals = ();
        @GandalfLiterals = split(/\|/,$Formula);
        foreach $Literal (@GandalfLiterals) {

#----Remove leading spaces (sometimes there?)
            $Literal =~ s/^ *//;
            if ($Literal =~ /^-/) {
                $Literal =~ s/^-//;
				push(@TPTPLiterals,("~$Literal"));
            } else {
                push(@TPTPLiterals,("$Literal"));
            }
        }
    }

    return($Language,$Name,$Type,[@TPTPLiterals],[@Source],[@UsefulInfos]);
}
#------------------------------------------------------------------------------
sub gupper {
    my ($Gupper) = @_;

    $Gupper =~ s/\^//;
    $Gupper =~ tr/a-z/A-Z/;

    return($Gupper);
}
#------------------------------------------------------------------------------
return 1;
#------------------------------------------------------------------------------
