#!/usr/bin/perl -w
    
use strict "vars";
#------------------------------------------------------------------------------
sub vampire {
    my($InputLine) = @_;
    my $Language;
    my $Name;
    my $Source;
    my @SourceParts;
    my $RecordedSource;
    my @InferenceRules;
    my $NextRule;
    my $Formula;
    my $Type;
    my @Source;
    my @Parents;
    my $EqualityInf;
    my @UsefulInfos;
    my @TPTPLiterals;
    my @VampireLiterals;
    my $Thm;

    my @EqualityInferenceRules = (
	"br",      #binary resolution
	"hr",      #hyperresolution
	"fs",      #forward superposition
	"bs",      #backward superposition
	"er",      #equality resolution
	"ef",      #equality factoring
	"fd",      #forward demodulation
	"bd",      #backward demodulation
	"ers",     #equality resolution
	"fsr",     #forward subsumption resolution
    );

    my @NonLogicalConsequenceRules = (
	"pp",      #by preprocessing
	"sp",      #splitting
	"rea",     #"reanimated" passive clause (selected in Discount algorithm) 
	"nm",      #the clause is a part of a name introduction in
                   #splitting, or obtained by preprocessing from such a clause  
        "ns",      #negative selection (does not mean that all the selected literals are negative)
	"sg",	   #subgoal (one of the parents was hyp., conj., or was a clausified goal
	"sbit",    #simplification by a build in theory
	"bitf",    #created by a biuld in theory
    );

#----Clause normal form, cnf, is assumed to be the language of the Vampire file.
     $Language = "cnf";

#----Extract main components
     ($Name,$Formula,$Source) = ($InputLine =~ /(\d.*)\. (.*)\[(.*)\]/);
    
#     print("Parts are:\n $Name\n $Source\n $Formula\n");
	
     $RecordedSource = $Source;
     @UsefulInfos = ("iquote('$Source')");
     @SourceParts = split(/[ ,]/,$Source);
     $Type = "derived";
     @Source = ();
     @Parents = ();
     $EqualityInf = "";
     $Thm = "thm";

     while (scalar(@SourceParts) > 0) {
          $NextRule = shift(@SourceParts);
          $NextRule =~ tr/A-Z/a-z/;
	  if  ($NextRule eq "in") {
	       $Type = "initial";
	       @Source = ("file");
	  } else {
	  if ($NextRule =~ /[^\d]/) {
		if (!$InferenceRules[0]) {
			push(@InferenceRules, $NextRule);
		} else {
			$InferenceRules[0] = "$InferenceRules[0]_$NextRule";
		}
		if (!$EqualityInf && grep(/$NextRule/,@EqualityInferenceRules)) {
 		        $EqualityInf = ("equality");
	        }
		if ($Thm eq "thm" && grep(/$NextRule/,@NonLogicalConsequenceRules)) {
 		        $Thm = "sat";
	        }
	  } else {
		push(@Parents, ($NextRule));
          }}
    }
    if ($EqualityInf ne "") {
	push(@Parents,("theory(equality)"));
    }
	@Source = ("inference","[@InferenceRules]",[status($Thm)],[@Parents]);

#----Check if the empty clause
    if ($Formula =~ /#/) {
       @TPTPLiterals = ("$false");
    } else {
       @TPTPLiterals = ();
       @VampireLiterals = split(/[\|\\ ][ \/\/]/,$Formula);
       pop(@VampireLiterals);
       foreach (@VampireLiterals) {
            s/^ *//;
#----Convert equality literals to form equals(---,---)
	    if (s/==/,/ || s/=/,/) {
		$_ = "equals($_)";
	    }
	    if (s/!==/,/ || s/!=/,/) {
		$_ = "~equals($_)";
	    }
            push(@TPTPLiterals,("$_"));
       }
   }

    return($Language,$Name,$Type,[@TPTPLiterals],[@Source],[@UsefulInfos]);
}
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
return 1;
#------------------------------------------------------------------------------
