#!/usr/local/bin/perl -w

use strict "vars";
#------------------------------------------------------------------------------
sub otter {
    my($InputLine,%AKAs) = @_;

    my $Language;
    my $Name;
    my $FinalName;
    my $Source;
    my @SourceParts;
    my $Formula;
    my @AlternativeNames;
    my $InferenceRule;
    my @Parents;
    my $Parent;
    my $Type;
    my @Source;
    my @UsefulInfos;
    my @TPTPLiterals;
    my @OtterLiterals;
    my $Literal;

    my @EqualityInferenceRules = (
        "para_into",
        "para_from",
        "demod",
        "flip",
    );

#----Clause normal form, cnf, is assumed to be the language of the Otter file.
    $Language = "cnf";
#----Extract main components
#DEBUG print(stderr "=========InputLine is $InputLine\n");
    ($Name,$Source,$Formula) = ($InputLine =~ /^([\d,]*) \[(.*)\] (.*)\. *$/);
#DEBUG print("Name is $Name\n");
#DEBUG print("Source is $Source\n");
#DEBUG print("Formula is $Formula\n");

#----If some error, just return the language
    if (!defined($Name) || !defined($Source) || !defined($Formula)) {
        return($Language);
    }

#----Get the name
    @AlternativeNames = split(/,/,$Name);
    $FinalName = shift(@AlternativeNames);
    foreach $Name (@AlternativeNames) {
        $AKAs{$Name} = $FinalName;
    }

    @SourceParts = split(/,/,$Source);
#----Check if initial or inferred
    if (scalar(@SourceParts) == 0) {
        $Type = "initial";
        @UsefulInfos = ();
        @Source = ("file");
#DEBUG print("Made a file source\n");
    } else {
        $Type = "derived";
        @UsefulInfos = ("iquote('$Source')");
        @Source = ();
        while (scalar(@SourceParts) > 0) {
            $InferenceRule = shift(@SourceParts);
            $InferenceRule =~ tr/A-Z/a-z/;
#----Knock off .1 from flips
            $InferenceRule =~ s/\.\d*//g;
#DEBUG print("Inference rule ==$InferenceRule==\n");
#----If a subinference already exists, keep it
            if (scalar(@Source) > 0) {
                @Parents = [MakeArray(@Source)];
#DEBUG print("inference parent to start\n");
            } else {
#DEBUG print("no parents to start\n");
                @Parents = ();
            }
#----Get the rest of the parents
            while (scalar(@SourceParts) > 0 && $SourceParts[0] =~ /^\d/) {
                $Parent = shift(@SourceParts);
                $Parent =~ s/\..*//;
#----If any have an AKA, use that
                if (exists($AKAs{$Parent})) {
#DEBUG print("$Parent is also known as $AKAs{$Parent}\n");
                    $Parent = $AKAs{$Parent};
                }
                push(@Parents,($Parent));
#DEBUG print("added parent ==$Parent==@Parents==\n");
            }
#----Check if equality parent is needed
            if (grep(/$InferenceRule/,@EqualityInferenceRules)) {
                push(@Parents,("theory(equality)"));
            }
            @Source = ("inference",$InferenceRule,["status(thm)"],[@Parents]);
#DEBUG print("Made an inference source\n");
        }
    }

#----Fix up the clause.
#----Check if the empty clause
    if ($Formula =~ /\$F/) {
        @TPTPLiterals = ('$false');
    } else {
#----Rename Skolems
        $Formula =~ s/\$/sk_/g;
        @TPTPLiterals = ();
        @OtterLiterals = split(/\|/,$Formula);
        foreach $Literal (@OtterLiterals) {
#----Remove leading spaces (sometimes there?)
            $Literal =~ s/^ *//;
            if ($Literal =~ /^-/) {
                $Literal =~ s/^-//;
				push(@TPTPLiterals,("~$Literal"));
            } else {
                push(@TPTPLiterals,("$Literal"));
            }
        }
    }

    return($Language,$FinalName,$Type,[@TPTPLiterals],[@Source],[@UsefulInfos],
%AKAs);
}
#------------------------------------------------------------------------------
return 1;
#------------------------------------------------------------------------------
