/*--------------------------------------------------------------*
/* equal.c      TGTP and HERBY
/*
/* Copyright Newborn Software 1999, 2000
/*
/* functions:
/* equal_predicate().....................#1
/* esa_for_fxns()........................#2
/* test_equality_fxn()...................#3
/* esa_for_lits()........................#4
/* test_lits()...........................#5
/* test_equality().......................#6
/*--------------------------------------------------------------*/

#include <strings.h>
#include <stdio.h>

#include "constHS.h"
#include "clauseHS.h"

/*--------------------------------------------------------------*/
/* externally defined  functions
/*--------------------------------------------------------------*/


/*--------------------------------------------------------------*/
/* externally defined constants
/*--------------------------------------------------------------*/

extern int base;
extern int equal_pred;

extern clause *clist[];
char *OutPtr;

/*--------------------------------------------------------------*/
/* internally defined functions
/*--------------------------------------------------------------*/

void equal_predicate();
void esa_for_fxns();
int test_equality_fxn();
void esa_for_lits();
int test_lits();

/*--------------------------------------------------------------*/
/*      equal_predicate()        .................. #1
/*
/*      see if "Equal" predicate is implicitly one of the     
/*      predicates.  Look for p(x,x), the ~p(x,y) | p(y,x), etc.
/*
/*      called by:   prepare_clauses     theo.c 
/*
/*      calls:       Nobody
/*
/*      returns:     Nil
/*--------------------------------------------------------------*/

void equal_predicate()
{
literal *l, *l1, *l2, *l3; 
clause *c;
long i, j, k, v1, v2, v3, v4, v5, v6;
int *p, *q, *r;
long pargs, qargs;
long l1id, l2id, l3id;
long ee, plus_lit;

for(i = 0L; i <= base ; i++) { 
   c = clist[i]; 
   if(c->c_nlit != 1) continue;
   if(c->c_nv != 1L) continue;
   if((c->c_lit->l_id & ARGMASK) != 2L) continue;
   if((c->c_lit->l_id & NEGMASK) != 0L) continue;
   p = &c->c_lit->l_id;
   p++; 
   v1 = *p++;
   v2 = *p;
   if(v1 != v2) continue;
   if((v1 & FCNMASK) != 0L) continue;
   ee = c->c_lit->l_id & IDMASK;
   c->c_bits |= EQCLS;
   OutPtr += sprintf(OutPtr,"EQ: %ld",i + 1L);

   for(j = 0L; j <= base; j++) {
      c = clist[j];
      if(c->c_nlit != 2) continue;
      if(c->c_nv != 2) continue;
      l1 = c->c_lit;
      if((l1->l_id & IDMASK) != ee) continue;
      l2 = l1->l_next;
      if((l1->l_id & NEGMASK) == (l2->l_id & NEGMASK)) continue;
      if((l1->l_id & IDMASK) != (l2->l_id & IDMASK)) continue;
      p = &l1->l_id;
      q = &l2->l_id;
      p++; q++;
      v1 = *p++;
      v2 = *p;
      v3 = *q++;
      v4 = *q; 
      if(v1 != v4) continue;
      if(v2 != v3) continue;
      if((v1 & FCNMASK) != 0L) continue;
      if((v2 & FCNMASK) != 0L) continue;

      c->c_bits |= EQCLS; 
      OutPtr += sprintf(OutPtr,".%ld",j + 1L);

      for(k = 0L; k <= base; k++) {
         c = clist[k]; 
         if(c->c_nlit != 3) continue;
         if(c->c_nv != 3) continue;
         l1 = c->c_lit;
         if((l1->l_id & IDMASK) != ee) continue;
         l2 = l1->l_next;
         l3 = l2->l_next;
         l1id = l1->l_id; l2id = l2->l_id; l3id = l3->l_id;
         if((l1id & NEGMASK) == (l2id & NEGMASK) &&
              (l1id & NEGMASK) == (l3id & NEGMASK)) continue;

         if((l1->l_id & IDMASK) != (l2->l_id & IDMASK)) continue;
         if((l1->l_id & IDMASK) != (l3->l_id & IDMASK)) continue;

         if(((l1->l_id & NEGMASK) == 0L) &&
            ((l2->l_id & NEGMASK) != 0L) &&
            ((l3->l_id & NEGMASK) != 0L))  {
            plus_lit = 1L;}
         if(((l1->l_id & NEGMASK) != 0L) &&
            ((l2->l_id & NEGMASK) == 0L) &&
            ((l3->l_id & NEGMASK) != 0L))  {
            plus_lit = 2L;}
         if(((l1->l_id & NEGMASK) != 0L) &&
            ((l2->l_id & NEGMASK) != 0L) &&
            ((l3->l_id & NEGMASK) == 0L))  {
            plus_lit = 3L;}
         p = &l1->l_id;
         q = &l2->l_id;
         r = &l3->l_id;

         p++; q++; r++;
         v1 = *p++;
         v2 = *p;
         v3 = *q++;
         v4 = *q; 
         v5 = *r++;
         v6 = *r;
         if(v1 == v3 && v2 == v6 && v4 == v5) goto equal3;
         if(v1 == v3 && v2 == v5 && v4 == v6) goto equal3;
         if(v1 == v4 && v2 == v6 && v3 == v5) goto equal3;
         if(v1 == v4 && v2 == v5 && v3 == v6) goto equal3;
         if(v1 == v5 && v2 == v4 && v3 == v6) goto equal3;
         if(v1 == v5 && v2 == v3 && v4 == v6) goto equal3;
         if(v1 == v6 && v2 == v4 && v3 == v5) goto equal3;
         if(v1 == v6 && v2 == v3 && v4 == v5) goto equal3;
         continue;
         equal3:
         if((v1 & FCNMASK) != 0L) continue;
         if((v2 & FCNMASK) != 0L) continue;
         if((v3 & FCNMASK) != 0L) continue;
         if((v4 & FCNMASK) != 0L) continue;
         if((v5 & FCNMASK) != 0L) continue;
         if((v6 & FCNMASK) != 0L) continue;

         c->c_bits |= EQCLS;
         OutPtr += sprintf(OutPtr,".%ld\n",k + 1L);
         if(equal_pred == 0L) {
	     equal_pred = (c->c_lit->l_id & ~NEGMASK);}
         return;}}}

return;
}

/*-----------------------------------------------------*/
/*      esa_for_fxns()    ................#2           */
/*                                                     */
/*      determine whether clause c is an equality      */
/*      substitution axiom, e. g. ~equal(x,y) |        */
/*      equal(f(x),f(y)                                */
/*                                                     */
/*      called by:   prepare clauses()     theo.c      */
/*                                                     */
/*      calls:       equality_sub_fxn()    theo.c      */
/*                                                     */
/*      returns:     1 is clause is an esa             */
/*                   0 if it is not.                   */
/*-----------------------------------------------------*/
 
void esa_for_fxns()
{
clause *c;
literal *l1, *l2;
long i, v1, v2;
int *p;

OutPtr += sprintf(OutPtr,"ESAF:");

for(i = 0L; i <= base; i++) { 
   c = clist[i]; 
   if(c->c_nlit != 2) {continue;}
 
   l1 = c->c_lit;
   l2 = l1->l_next;
 
   if((l1->l_id & ~NEGMASK) != equal_pred) {continue;}
   if((l2->l_id & ~NEGMASK) != equal_pred) {continue;}
   if((l1->l_id ^ l2->l_id ^ NEGMASK) != 0L) {continue;} 
 
   if((l1->l_id & NEGMASK) == 0L) {
      l1 = l2;
      l2 = c->c_lit;}
/*-------------------------------------------------------*/
/*   clause with two equal lits.  l1 is the "~" one.     */
/*   now see if l1 is of form equal(x,y)                 */
/*-------------------------------------------------------*/

   p = &l1->l_id;
   p++;

   v1 = *p++;
   v2 = *p;
   if(((v1 & FCNMASK) == 0L) && ((v2 & FCNMASK) == 0L && v1 != v2)) {
 
/*--------------------------------------------------------*/
/*   thus far, we have found that "~equal(x,y) is present */
/*--------------------------------------------------------*/

      if(test_equality_fxn(l2,v1,v2)) {
         c->c_bits |= EQCLS;
         OutPtr += sprintf(OutPtr," %ld",i + 1L);}}}

OutPtr += sprintf(OutPtr,"\n");
return;
}
 
/*-----------------------------------------------------------------*/
/*   test_equality_fxn()           ................#3              */
/*                                                                 */
/*   now see if the equality literal is a equality substitution    */
/*   for example, equal(f(x,y),f(z,y)) would pass.                 */ 
/*                                                                 */
/*   called by:  esa_for_fxns()       theo.c                       */
/*                                                                 */
/*   calls:      nobody                                            */
/*                                                                 */
/*   returns:    0 if l_equal is not an equality substitution fxn  */
/*               1 if it is                                        */ 
/*-----------------------------------------------------------------*/
 
int test_equality_fxn(l_equal,v1,v2)
literal *l_equal;
long v1, v2;
{
long  a;
int esv;                    /* equality substitution variable  */
int *p, *p1;
 
esv = 0;
 
p1 = p = &l_equal->l_id;
 
for(a = (*p++ & ARGMASK) ; a > 1L ; a--) {
   if(*p & FCNMASK) {
      a += *p++ & ARGMASK;}
   else {
      p++;}}
/*--------------------------------------*/
/* if first symbol is a variable, then  */
/* return, since clause shows symmetry  */
/* in the equality predicate.           */
/*--------------------------------------*/

if((*p & FCNMASK) == 0L) {return(0);} 

/*--------------------------------------*/
/* p now points to beginning of 2nd     */
/* half of the equality predicate.      */
/* p1 now points to the beginning.      */
/* now a scan is made comparing each    */
/* symbol in the two halfs              */
/*--------------------------------------*/

for(a = (*p1++ & ARGMASK) ; a > 1L ; a--) {
   if(*p != *p1) {
      if((*p == v1 && *p1 == v2) || (*p == v2 && *p1 == v1)) {
         esv++;
         if(esv > 1) {
            return(0);}}}
   if(*p1 & FCNMASK) {
      a +=*p1++ & ARGMASK;
      p++;}
   else {
      p++; p1++;}} 
 

return(1);
}
 
 
/*-----------------------------------------------------*/
/*      esa_for_lits()    ................#4           */
/*                                                     */
/*      determine whether clause c is an equality      */
/*      substitution axiom  for literals.              */
/*      for example: ~equal(x,y) | ~P(x) | P(y)        */
/*                                                     */
/*      called by:   prepare clauses()     theo.c      */
/*                                                     */
/*      calls:       test_lits()           theo.c      */
/*                                                     */
/*      returns:     1 is clause is an esa             */
/*                   0 if it is not.                   */
/*-----------------------------------------------------*/
 
void esa_for_lits()
{
clause *c;
literal *l1, *e_lit, *p_lit, *n_lit;
long i, v1, v2;
int *p;

OutPtr += sprintf(OutPtr,"ESAP:");

for(i = 0L; i <= base; i++) { 
   c = clist[i]; 
   if(c->c_nlit != 3) {continue;}

   e_lit = p_lit = n_lit = 0L;

   for(l1 = c->c_lit; l1 != 0L; l1 = l1->l_next) {
      if((l1->l_id & ~NEGMASK) == equal_pred) {e_lit = l1;}
      else if((l1->l_id & ~NEGMASK) != equal_pred) {
         if((l1->l_id & NEGMASK) == 0L) {p_lit = l1;}
         else {
            n_lit = l1;}}}
   if(e_lit == 0L || p_lit == 0L || n_lit == 0L) {continue;}
   if((p_lit->l_id & ~NEGMASK) != (n_lit->l_id & ~NEGMASK)) {continue;}

   p = &e_lit->l_id;
   p++;

   v1 = *p++;
   v2 = *p;
   if(((v1 & FCNMASK) == 0L) && ((v2 & FCNMASK) == 0L && v1 != v2)) {
 
/*--------------------------------------------------------*/
/*   thus far, we have found that "~equal(x,y) is present */
/*   now test the two literals.                           */
/*--------------------------------------------------------*/

      if(test_lits(p_lit,n_lit,v1,v2)) { 
         c->c_bits |= EQCLS;
         OutPtr += sprintf(OutPtr," %ld",i + 1L);}}} 

OutPtr += sprintf(OutPtr,"\n");
return;
}
  
/*-----------------------------------------------------------------*/
/*   test_lits()                   ................#5              */
/*                                                                 */
/*   now see if other two literals differ by only one var.         */
/*   for example, p(x,y) and p(x,z)    would pass.                 */ 
/*                                                                 */
/*   called by:  esa_for_lits()       theo.c                       */
/*                                                                 */
/*   calls:      nobody                                            */
/*                                                                 */
/*   returns:    0 if l_equal is not an equality substitution fxn  */
/*               1 if it is                                        */ 
/*-----------------------------------------------------------------*/
 
int test_lits(l1,l2,v1,v2)
literal *l1, *l2;
long v1, v2;
{
long  a;
int esv;                    /* equality substitution variable  */
int *p1, *p2;
 
esv = 0;
 
p1 = &l1->l_id;
p2 = &l2->l_id;
 
for(a = (*p1++ & ARGMASK) ; a > 0L ; a--) {
   if(*p2 != *p1) {
      if((*p2 == v1 && *p1 == v2) || (*p2 == v2 && *p1 == v1)) {
         esv++;
         if(esv > 1) {
            return(0);}}}
   if(*p1 & FCNMASK) {
      a +=*p1++ & ARGMASK;
      p2++;}
   else {
      p2++; p1++;}} 
return(1);
}

/*--------------------------------------------------------------*/
/*      test_equality_(l)       ......................#6
/*
/*      tests to see if equal(string1,string1) is the case
/*
/*      called from:   install_clause()                build.c
/*
/*      calls:         nobody
/*
/*      returns:    0 => if equal(string1,string1) is not the case
/*                  1 => if equal(string1,string1) is the case
/*--------------------------------------------------------------*/
 
int test_equality(l_equal)
literal *l_equal;
{
int *p, *p1, a;

p1 = p = &l_equal->l_id;

for(a = (*p++ & ARGMASK) ; a > 1 ; a--) {
   if(*p & FCNMASK) {
      a += *p++ & ARGMASK;}
   else {
      p++;}}
 
/*--------------------------------------*/
/* p now points to beginning of 2nd     */
/* half of the equality predicate.      */
/* p1 now points to the beginning.      */
/* now a scan is made comparing each    */
/* symbol in the two halfs              */
/*--------------------------------------*/

for(a = (*p1++ & ARGMASK) ; a > 1 ; a--) {
   if(*p != *p1) { 
      return(0);}
   if(*p1 & FCNMASK) {
      a +=*p1++ & ARGMASK;
      p++;}
   else {
      p++; p1++;}}

return(1);
}
