#include "const.h"
#include "clause.h"

#include <strings.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

extern int rename_preds;
extern int rename_fxns;
extern int number_preds, number_fxns;

extern char *pidtbl[], *fidtbl[];

void rename_functions();
void rename_routine();

/*--------------------------------------------------------------*/
/*      rename_functions()              .............. #18a
/*
/*      replace names of some functions with shorter names
/*
/*      called by:
/*
/*      call: nobody
/*
/*      returns: nil
/*---------------------------------------------------------------*/

void rename_functions()
{
char *ii, *jj, *q;
int a, b, k, test, replace;

rename_fxns = rename_preds = 0;

/*------------------------------------*/
/* predicate names to replace         */
/*------------------------------------*/

rename_routine("basic_output","BOUT",1);
rename_routine("between","B",1);
rename_routine("colinear","COL",1);
rename_routine("equal","E.",1);
rename_routine("equidistant","D",1);
rename_routine("homomorphism","HOM",1);
rename_routine("in_interval","IIVL",1);
rename_routine("is_a_theorem","THM",1);
rename_routine("less_or_equal","LE",1);
rename_routine("less_than_or_equal","LE",1);
rename_routine("little_set","LST",1);
rename_routine("member","MBR",1);
rename_routine("ordered_pair_predicate","OPP",1);
rename_routine("positive_integer","POSINT",1);
rename_routine("product","P",1);
rename_routine("proper_subset","PRS",1);
rename_routine("single_valued_set","SVS",1);
rename_routine("subset","SUS",1);
rename_routine("sum","S",1);

/*------------------------------------*/
/* function names to replace          */
/*------------------------------------*/

rename_routine("a_real_number","ARN",2);
rename_routine("absolute","ABS",2);
rename_routine("abstraction","ABST",2);
rename_routine("add","A",2);
rename_routine("add_inverter","0",2);
rename_routine("additive_identity","0",2);
rename_routine("additive_inverse","AI",2);
rename_routine("apply","APY",2);
rename_routine("associator","ASSR",2);
rename_routine("codomain","CDMN",2);
rename_routine("commutator","CMTR",2);
rename_routine("compose","COMP",2);
rename_routine("composition_function","CMPF",2);
rename_routine("continuous","CONT",2);
rename_routine("cross_product","CXP",2);
rename_routine("divide","D",2);
rename_routine("domain_relation","DOMR",2);
rename_routine("domain","DOMN",2);
rename_routine("double_divide","DD",2);
rename_routine("epsilon_0","EP0",2);
rename_routine("equivalent","Q",2);
rename_routine("euclid1","EUC1",2);
rename_routine("euclid2","EUC2",2);
rename_routine("extension","EXTN",2);
rename_routine("extreme_point","EXPT",2);
rename_routine("falsehood","FH",2);
rename_routine("greatest_lower_bound","GLB",2);
rename_routine("identity","ID",2);
rename_routine("implies","IMP",2);
rename_routine("infinity","IY",2);
rename_routine("inner_pasch","INPH",2);
rename_routine("intersection","INT",2);
rename_routine("inverse","INV",2);
rename_routine("inverter_table","ITBL",2);
rename_routine("join","J",2);
rename_routine("least_upper_bound","LUB",2);
rename_routine("less_or_equal","LE",2);
rename_routine("list_reversion","LVN",2);
rename_routine("lower_bound","LB",2);
rename_routine("lower_dimension_point_1","LDP1",2);
rename_routine("lower_dimension_point_2","LDP2",2);
rename_routine("lower_dimension_point_3","LDP3",2);
rename_routine("make_reverse_list","MRVL",2);
rename_routine("member_of_1_not_of_2","M1N2",2);
rename_routine("meet","M",2);
rename_routine("midpoint","MIDP",2);
rename_routine("minimum","MIN",2);
rename_routine("multiplicative_identity","1",2);
rename_routine("multiplicative_inverse","MI",2);
rename_routine("multiply","M",2);
rename_routine("negate","N",2);
rename_routine("non_ordered_pair","NOP",2);
rename_routine("not_reversion","NRN",2);
rename_routine("null_class","NULC",2);
rename_routine("one","1",2);
rename_routine("ordered_pair","ORP",2);
rename_routine("outer_pasch","OTPH",2);
rename_routine("pair","PR",2);
rename_routine("possible_reversion","PRVN",2);
rename_routine("projection1","PR1",2);
rename_routine("projection2","PR2",2);
rename_routine("reflection","REFL",2);
rename_routine("subset_relation","SUBR",2);
rename_routine("successor","SUC",2);
rename_routine("successor_relation","SUCR",2);
rename_routine("universal_class","UCLS",2);
rename_routine("union","U",2);
rename_routine("unordered_pair","UNPR",2);
rename_routine("upper_bound","UB",2);

return;
}
/*--------------------------------------------------------------*/
/* rename routine()
/*--------------------------------------------------------------*/

void rename_routine(pred_symb,new_symb,pf_type) 
char pred_symb[];
char new_symb[];
int pf_type;
{
int a, k, test, numberpfs;
char *jj, *jjj, *sym_ptr, *new_sptr;;

if(pf_type == 1) numberpfs = number_preds;
else numberpfs = number_fxns;

for (a = 1; a <= numberpfs; a++) {
   if(pf_type == 1) {jj = pidtbl[a];}
   else jj = fidtbl[a];
   jjj = jj;
   sym_ptr = &pred_symb[0];
   new_sptr = &new_symb[0];
   test = 1;
   while(*jj != 0x00000000) {
      if(*sym_ptr == 0x00000000) {test = 0;break;}
      if(*jj++ != *sym_ptr++) {test = 0; break;}}
   if(*sym_ptr != 0x00000000) {test = 0;}

   if(test) {
      if(pf_type == 1) rename_preds++;
      else rename_fxns++;
      jj = jjj;
      while(*new_sptr != 0x00000000) {
	 *jj++ = *new_sptr++;}
      *jj = 0x00000000; 
      return;}}
return;
}

