#include "../ladr/top_input.h"

#define PROGRAM_NAME    "unfast"
#define PROGRAM_VERSION "2005-A"
#include "../PROGRAM_DATE.h"

static char Help_string[] =
"\nThis program takes a stream of fastparse terms and writes them\n"
"as ordinary terms.  The following symbols/arities are recognized.\n"
"arity 2: [=mjfd+*/]; arity 1: [cgi-~']; variables are r--z.  Other symbols\n"
"are constants.  Input should be one term per line, terminated\n"
"with a period, without spaces.  Lines starting with % are echoed.\n\n";

/*************
 *
 *   main()
 *
 *************/

int main(int argc, char **argv)
{
  Clause c;

  if (string_member("help", argv, argc) ||
      string_member("-help", argv, argc)) {
    printf("\n%s, version %s, %s\n",PROGRAM_NAME,PROGRAM_VERSION,PROGRAM_DATE);
    printf("%s", Help_string);
    exit(1);
  }

  init_standard_ladr();

  fast_set_defaults();

  c = fast_read_clause(stdin, stderr);
  while (c != NULL) {
    fwrite_clause(stdout, c, FALSE, FALSE);
    fflush(stdout);
    zap_clause(c);
    c = fast_read_clause(stdin, stderr);
  }
  exit(0);
}  /* main */
