#ifndef TP_IBUFFER_H
#define TP_IBUFFER_H

#include "fatal.h"

/* INTRODUCTION
*/

/* Public definitions */

#define IBUF_INIT_SIZE    40000
#define IBUF_EOF        INT_MIN

struct ibuffer {
  int write_position; /* current number of ints in buf (next pos to write) */
  int read_position;  /* next pos to read */
  int size;           /* size of buf */
  int *buf;           /* the buffer */
};

typedef struct ibuffer * Ibuffer;

/* End of public definitions */

/* Public function prototypes from ibuffer.c */

Ibuffer ibuf_init(void);

void ibuf_free(Ibuffer ibuf);

void ibuf_write(Ibuffer ibuf, int i);

void ibuf_write_block(Ibuffer ibuf, int *a, int n);

void ibuf_rewind(Ibuffer ibuf);

int ibuf_read(Ibuffer ibuf);

int ibuf_xread(Ibuffer ibuf);

int ibuf_length(Ibuffer ibuf);

int *ibuf_buffer(Ibuffer ibuf);

Ibuffer fd_read_to_ibuf(int fd);

void p_ibuf(Ibuffer ibuf);

#endif  /* conditional compilation of whole file */
