#ifndef TP_IOUTIL_H
#define TP_IOUTIL_H

#include "parse.h"
#include "fastparse.h"
#include "formula.h"
#include "clist.h"
#include "just.h"
#include "clauseid.h"
#include "accanon.h"
#include "compress.h"

/* INTRODUCTION
*/

/* Public definitions */

/* End of public definitions */

/* Public function prototypes from ioutil.c */

void fwrite_formula(FILE *fp, Formula f);

Clause read_clause(FILE *fin, FILE *fout);

Clause parse_clause_from_string(char *s);

BOOL end_of_list_clause(Clause c);

Clist read_clause_clist(FILE *fin, FILE *fout, char *name, BOOL assign_id);

Plist read_clause_list(FILE *fin, FILE *fout, BOOL assign_id);

void sb_write_clause_jmap(String_buf sb, Clause c,
			  BOOL print_id_just, BOOL justification_last,
			  Ilist map);

void sb_write_clause(String_buf sb, Clause c,
		     BOOL print_id, BOOL justification_last);

void fwrite_clause_jmap(FILE *fp, Clause c,
			BOOL print_id_just, BOOL justification_last,
			Ilist map);

void fwrite_clause(FILE *fp, Clause c,
		   BOOL print_id_just, BOOL justification_last);

void f_clause(Clause c);

void fwrite_clause_clist(FILE *fp, Clist lst, BOOL print_ids, BOOL justifications_last);

void fwrite_demod_clist(FILE *fp, Clist lst, BOOL print_ids, BOOL justifications_last);

void fwrite_clause_list(FILE *fp, Plist lst, char *name);

void f_clauses(Plist p);

Formula read_formula(FILE *fin, FILE *fout);

BOOL end_of_list_formula(Formula f);

Plist read_formula_list(FILE *fin, FILE *fout);

void fwrite_formula_list(FILE *fp, Plist lst, char *name);

void zap_formula_list(Plist lst);

BOOL end_of_list_term(Term t);

BOOL end_of_commands_term(Term t);

Plist read_term_list(FILE *fin, FILE *fout);

void fwrite_term_list(FILE *fp, Plist lst, char *name);

void zap_term_list(Plist lst);

Term term_reader(BOOL fast);

void term_writer(Term t, BOOL fast);

Clause clause_reader(BOOL fast);

void clause_writer(Clause c, BOOL fast);

BOOL bad_constants_in_clause(Clause c);

void check_constants_in_clist(Clist l);

#endif  /* conditional compilation of whole file */
