#ifndef TP_LISTTERM_H
#define TP_LISTTERM_H

#include "term.h"

/* INTRODUCTION
This package has routines for managing binary-tree lists built
from Terms, which allows you to do some LISPy and Prology things.
However, you must be careful to keep track of any terms that are
shared and to recycle your own garbage.
*/

/* Public definitions */

/* End of public definitions */

/* Public function prototypes from listterm.c */

Term get_nil_term();

Term listterm_cons(Term t1, Term t2);

BOOL cons_term(Term t);

BOOL nil_term(Term t);

BOOL proper_listterm(Term t);

Term listterm_append(Term list, Term element);

int listterm_length(Term t);

Term listterm_i(Term lst, int i);

BOOL listterm_member(Term t, Term lst);

Plist listterm_to_tlist(Term t);

#endif  /* conditional compilation of whole file */
