#ifndef TP_MEMORY_H
#define TP_MEMORY_H

#include "fatal.h"
#include <sys/time.h>
#include <sys/resource.h>

/* INTRODUCTION
*/

/* Public definitions */

#define BYTES_POINTER   sizeof(void *)  /* bytes per pointer */
#define CEILING(n,d)    ((n)%(d) == 0 ? (n)/(d) : (n)/(d) + 1)

/* End of public definitions */

/* Public function prototypes from memory.c */

void *get_cmem(unsigned n);

void *get_mem(unsigned n);

void free_mem(void *q, unsigned n);

void memory_report(FILE *fp);

int megs_malloced(void);

void set_max_megs(int megs);

void set_max_megs_proc(void (*proc)(void));

int bytes_palloced(void);

void *tp_alloc(size_t n);

unsigned mega_mem_calls(void);

#endif  /* conditional compilation of whole file */
