#ifndef TP_PARAMOD_H
#define TP_PARAMOD_H

#include "clash.h"
#include "parautil.h"
#include "basic.h"

/* INTRODUCTION
This package has a paramodulation inference rule.
*/

/* Public definitions */

/* where to paramodulate into */

typedef enum { PARA_ALL,
	       PARA_ALL_EXCEPT_TOP,
	       PARA_TOP_ONLY } Para_loc;

/* End of public definitions */

/* Public function prototypes from paramod.c */


void paramodulation_options(BOOL ordered_inference,
			    BOOL ordered_instance,
			    BOOL basic_paramodulation);

int para_instance_prunes();

int basic_paramodulation_prunes(void);

void para_from_into(Clause from, Context cf,
		    Clause into, Context ci,
		    BOOL top_check,
		    void (*proc_proc) (Clause));

Clause para_pos(Clause from, Ilist from_pos, Clause into, Ilist into_pos);

#endif  /* conditional compilation of whole file */
