#ifndef TP_PARAUTIL_H
#define TP_PARAUTIL_H

#include "termflag.h"
#include "termorder.h"
#include "unify.h"
#include "just.h"
#include "parse.h"

/* INTRODUCTION
This package contains a few utilites for paramodulation and demodulation.
*/

/* Public definitions */

/* End of public definitions */

/* Public function prototypes from parautil.c */

void init_paramod(void);

BOOL eq_atom(Term a);

BOOL pos_eq(Literal lit);

BOOL neg_eq(Literal lit);

BOOL pos_eq_unit(Clause c);

BOOL neg_eq_unit(Clause c);

BOOL contains_pos_eq(Clause c);

BOOL contains_eq(Clause c);

void mark_renamable_flip(Term atom);

BOOL renamable_flip_eq(Term atom);

BOOL renamable_flip_eq_test(Term atom);

void mark_oriented_eq(Term atom);

BOOL oriented_eq(Term atom);

BOOL same_term_structure(Term t1, Term t2);

void flip_eq(Term atom, int n);

void orient_equalities(Clause c, BOOL allow_flips);

BOOL eq_tautology(Clause c);

Term top_flip(Term a);

void zap_top_flip(Term a);

Literal literal_flip(Literal a);

void zap_literal_flip(Literal a);

BOOL pos_equality_in_clauses(Plist l);

BOOL equality_in_clauses(Plist l);

BOOL neg_nonunit_in_clauses(Plist l);

Clause new_constant(Clause c);

Clause fold_denial(Clause c, int alpha_max);

BOOL equational_def_2(Term alpha, Term beta);

int equational_def(Clause c);

Ordertype unfold_order(Term alpha, Term beta);

#endif  /* conditional compilation of whole file */
