#ifndef TP_RESOLVE_H
#define TP_RESOLVE_H

#include "clash.h"
#include "lindex.h"
#include "parautil.h"

/* INTRODUCTION
*/

/* Public definitions */

enum {  /* literal selection */
  LIT_SELECTION_MAXIMAL,
  LIT_SELECTION_ALL,
  LIT_SELECTION_FIRST_MAXIMAL,
  LIT_SELECTION_FIRST
};

enum {  /* types of resolution (binary, hyper, UR) */
  POS_RES,  /* positive */
  NEG_RES,  /* negative */
  ALL_RES   /* unrestricted */
};

/* End of public definitions */

/* Public function prototypes from resolve.c */


void resolution_options(BOOL ordered_inference,
			BOOL ordered_instance,
			char *lit_selection,
			BOOL initial_nuclei,
			int nucleus_limit);

int res_instance_prunes();

void hyper_resolution(Clause c, BOOL positive, Lindex idx,
		      void (*proc_proc) (Clause));

void ur_resolution(Clause c, int target_constraint, Lindex idx,
		   void (*proc_proc) (Clause));

Clause instantiate_clause(Clause c, Context subst);

void binary_resolution(Clause c,
		       BOOL positive_res,
		       Lindex idx,
		       void (*proc_proc) (Clause));

void binary_factors(Clause c, void (*proc_proc) (Clause));

void merge_literals0(Clause c);

void merge_literals(Clause c);

Clause copy_inference(Clause c);

Clause resolve2(Clause c1, int n1, Clause c2, int n2);

Clause resolve3(Clause c1, Literal l1, Clause c2, Literal l2);

Clause xx_resolve2(Clause c, int n);

#endif  /* conditional compilation of whole file */
