#include "std_options.h"

/* Private definitions and types */

/* Flags */

static int Prolog_style_variables = -1;
static int Clocks = -1;

/*************
 *
 *   init_standard_options()
 *
 *************/

/* DOCUMENTATION
*/

/* PUBLIC */
void init_standard_options(void)
{
  /* Flags */
  Prolog_style_variables = init_flag("prolog_style_variables", FALSE);
  Clocks                 = init_flag("clocks",                 TRUE);

}  /* init_standard_options */

/*************
 *
 *   process_standard_options()
 *
 *************/

/* DOCUMENTATION
*/

/* PUBLIC */
void process_standard_options(void)
{

  if (flag(Clocks))
    enable_clocks();
  else
    disable_clocks();

  /* Prolog_style_variables is handled during input. */

}  /* process_standard_options */

/*************
 *
 *   clocks_id()
 *
 *************/

/* DOCUMENTATION
*/

/* PUBLIC */
int clocks_id(void)
{
  return Clocks;
}  /* clocks_id */

/*************
 *
 *   prolog_style_variables_id()
 *
 *************/

/* DOCUMENTATION
*/

/* PUBLIC */
int prolog_style_variables_id(void)
{
  return Prolog_style_variables;
}  /* prolog_style_variables_id */
