#ifndef TP_TERMORDER_H
#define TP_TERMORDER_H

#include "order.h"
#include "glist.h"
#include "term.h"
#include "flatterm.h"

/* INTRODUCTION
*/

/* Public definitions */

/* Term ordering method */

typedef enum { LRPO_METHOD,
	       LPO_METHOD,
	       RPO_METHOD,
	       KBO_METHOD
             } Order_method;

/* End of public definitions */

/* Public function prototypes from termorder.c */

void assign_order_method(Order_method method);

Ordertype term_compare_ncv(Term t1, Term t2);

Ordertype term_compare_vcp(Term t1, Term t2);

BOOL greater_multiset(Term a1[], int n1, Term a2[], int n2);

BOOL lrpo_multiset(Term t1, Term t2);

BOOL lrpo(Term s, Term t);

void init_kb_weights(Plist weights);

int kbo_weight(Term t);

BOOL kbo(Term alpha, Term beta);

BOOL term_greater(Term alpha, Term beta);

Ordertype term_order(Term alpha, Term beta);

int flat_kbo_weight(Flatterm f);

BOOL flat_lrpo(Flatterm s, Flatterm t);

BOOL flat_greater(Flatterm alpha, Flatterm beta);

#endif  /* conditional compilation of whole file */
