#ifndef TP_TOP_INPUT_H
#define TP_TOP_INPUT_H

#include "options.h"
#include "clock.h"
#include "parautil.h"
#include "basic.h"
#include "maximal.h"
#include "ioutil.h"
#include "symbolcheck.h"
#include "std_options.h"

/* INTRODUCTION
*/

/* Public definitions */

enum { CLAUSES, FORMULAS, TERMS };

/* What shall we do if we read an unknown flag or parameter? */

enum {
  IGNORE_UNKNOWN,
  NOTE_UNKNOWN,
  WARN_UNKNOWN,
  KILL_UNKNOWN
};

/* End of public definitions */

/* Public function prototypes from top_input.c */

void fprint_top_input_mem(FILE *fp, BOOL heading);

void p_top_input_mem();

void flag_handler(FILE *fout, Term t, BOOL echo, int unknown_action);

void parm_handler(FILE *fout, Term t, BOOL echo, int unknown_action);

void accept_list(char *name, int type, Plist *l);

void read_from_file(FILE *fin, FILE *fout, BOOL echo, int unknown_action);

void read_all_input(int argc, char **argv, FILE *fout,
		    BOOL echo, int unknown_action);

Term read_commands(FILE *fin, FILE *fout, BOOL echo, int unknown_action);

void init_standard_ladr(void);

#endif  /* conditional compilation of whole file */
