#ifndef MACE4_GROUND_H
#define MACE4_GROUND_H

/* INTRODUCTION
*/

/* Public definitions */

typedef struct mclause * Mclause;

struct mclause {
  BOOL subsumed;
  int numlits;
  int active;
  Term *lits;
  Mclause next;
};

#define MAX_MACE_VARS      50

#define TERM_FLAG(t,flag)  (TP_BIT(t->private_flags, 1 << flag))
#define NEGATED(t)         (TERM_FLAG(t,Negation_flag))
#define LITERAL(t)         (TERM_FLAG(t,Relation_flag))
#define LIT(c,i)           ((c)->lits[i])

#define OR_TERM(t)        (SYMNUM((Term) t) == Or_sn)   /* ok if variable */
#define NOT_TERM(t)       (SYMNUM((Term) t) == Not_sn)  /* ok if variable */
#define EQ_TERM(t)        (SYMNUM((Term) t) == Eq_sn)   /* ok if variable */
#define FALSE_TERM(t)     ((t) == Domain[0])  /* ok if not variable */
#define TRUE_TERM(t)      ((t) == Domain[1])  /* ok if not variable */

/* End of public definitions */

/* Public function prototypes from syms.c */

void fprint_mclause_mem(FILE *fp, int heading);
void p_mclause_mem(void);
void zap_mterm(Term t);
void zap_mclause(Mclause c);
int lit_position(Mclause parent, Term child);
Mclause containing_mclause(Term t);
void generate_ground_clauses(Clause c, Mstate state);

#endif  /* conditional compilation of whole file */
