#ifndef MACE4_SYMS_H
#define MACE4_SYMS_H

/* INTRODUCTION
*/

/* Public definitions */

/* Symbol types */

#define FUNCTION       0
#define RELATION       1

/* Symbol attributes */

#define ORDINARY_SYMBOL  0
#define EQUALITY_SYMBOL  1

typedef struct symbol_data * Symbol_data;

struct symbol_data {  /* SORT */
  int sn;             /* ordinary symbol ID */
  int mace_sn;        /* MACE symbol ID */
  int arity;
  int type;           /* FUNCTION or RELATION */
  int base;
  int attribute;      /* ORDINARY_SYMBOL or EQUALITY_SYMBOL */
  Symbol_data next;
};

/* End of public definitions */

/* Public function prototypes from syms.c */

Symbol_data get_symbol_data(void);
Symbol_data find_symbol_data(int sn);
void init_built_in_symbols(void);
int collect_mace_syms(Term t, int type);
void p_symbol_data(Symbol_data s);
Symbol_data find_symbol_node(int id);
int id_to_domain_size(int id);
int max_index(int id, Symbol_data s);

#endif  /* conditional compilation of whole file */
