#include "../ladr/header.h"

/*************
 *
 *   random_permutation()
 *
 *************/

void random_permutation(int *a, int n)
{
  int i, t, k;
  for (i = 0; i < n; i++)
    a[i] = i;
  for (i = n-1; i >= 0; i--) {
    /* Get a random number k in [0,...,i], then swap a[i] and a[k]. */
    k = rand() % (i+1);
    t = a[i];
    a[i] = a[k];
    a[k] = t;
  }
}  /* random_permutation */

/*************
 *
 *   int_power()
 *
 *************/

int int_power(int n, int exp)
{
  if (exp <= 0)
    return 1;
  else
    return n * int_power(n, exp-1);
}  /* int_power */

#define MAX_PRIME 1000

/*************
 *
 *   prime()
 *
 *************/

BOOL prime(int n)
{
  /* Is n a prime number?  If n is too big, a fatal error occurs.         */
  /* On the first call, use the sieve of Eratosthenes to set up an array. */

  static BOOL a[MAX_PRIME+1];
  static BOOL initialized = FALSE;

  if (!initialized) {
    int i, p;
    for (i = 2; i <= MAX_PRIME; i++)
      a[i] = TRUE;
    p = 2;
    while (p*p < MAX_PRIME) {
      int j = p*p;
      while (j  < MAX_PRIME) {
	a[j] = FALSE;
	j = j + p;
      }
      do p++; while (a[p] == FALSE);
    }
    initialized = TRUE;
  }
  if (n > MAX_PRIME)
    exit(1); // fatal_error("prime: n out of range");
  else if (n < 2)
    return FALSE;
  else
    return a[n];
}  /* prime */
