/*-----------------------------------------------------*/
/*-----------------------------------------------------*/
/*
/* compwff.c
/*
/* Copyright Newborn Software 1993, 1996, 1999, 2004
/*
/* functions:
/*  main_fof()..........................#1
/*  count_wff_chars()...................#2
/*  pid_check().........................#3
/*  pid_gen()...........................#4
/*  binop().............................#5
/*  yyparse()...........................#6
/*-------------------------------------------------------*/
/*
/*                   Function linkage for COMPILE
/*
/*    main_fof()
/*        pf_initsym()--------   pf_init()......
/*        count_wff_chars().......
/*        yyparse()
/*            v_init().......
/*            v_lexout().....
/*            pid_check()......
/*            pid_gen()
/*                pf_find()--------   tree_find()......
/*                pf_add()--------  tree_add().......
/*                pf_getnode()-------  pf_alloc()....
/*                emit_code()   
/*            v_lexin()......
/*            binop()--------   op_alloc()..........
/*            v_find()........
/*            v_add()-------  v_find()........
/*            pf_getnode()-------  pf_alloc()......
/*            yylex()
/*                tcheck().......
/*                yylook()-----   yyback()......
/*            emitinit()......
/*            emit_code()......
/*            pf_find()------    tree_find()......
/*            pf_add()------    tree_add().......
/*            op_alloc()..........
/*            op_clause()
/*                op_iffimpneg()
/*                    setop()...........
/*                    whatop()...........
/*                    op_alloc()..........
/*                    op_copy()
/*                        op_alloc()..........
/*                        emit_code()
/*                    skolinit().........
/*                    op_skolemize()
/*                        atom()...........
/*                        whatop()...........
/*                        pf_add()------   tree_add()....
/*                    pf_getnode()-------    pf_alloc()....
/*                    emit_code().........
/*                    op_release()..........
/*                op_standardize()-------   change()......      
/*                op_cnform()
/*                    atom()...........
/*                    whatop()...........
/*                    op_alloc()..........
/*                    op_copy()
/*                        op_alloc()..........
/*                        emit_code().........
/*                op_emit()
/*                        print_predicate()-- print_argument()...
/*                op_rel_expr()------  op_release()..........
/*
/*--------------------------------------------------------------*/
/*
/*                      FUNCTIONS in COMPILE
/*
/*    c-FILES
/*
/*    compwff.c
/*        main_fof()      pid_check()
/*        pid_gen()       binop()                yyparse()
/*
/*    emit.c
/*        emitinit()      emit_code()
/*
/*    err.c
/*        yerror()
/*
/*    lexwff.c
/*        tcheck()         yylex()               yylook()
/*        yyback()
/*
/*    ops.c
/*        op_alloc()       op_release()
/*        atom()           setop()               whatop()
/*        op_rel_expr()    op_clause()           op_copy()
/*        op_iffimpneg()   op_standardize()      change()
/*        op_cnform()      skolinit()            op_skolemize()
/*        op_emit()        print_predicate()     print_argument()
/*
/*    pfsym.c
/*        pf_init()         pf_alloc()           pf_release()
/*        pf_initsym()      pf_getnode()         pf_add()
/*        pf_find()
/*
/*    tree.c
/*        tree_add()        tree_find()
/*
/*    varsym.c
/*        v_init()          v_lexin()             v_lexout()
/*        v_find()          v_add()
/*
/*-------------------------------------------------------------*/
/*    h-files
/*
/*    compwff.h
/*
/*-------------------------------------------------------------*/
 
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
 
#include "compwff.h"
#include "clause.h"
#include "const.h"
 
/*--------------------------------------------------------------*/
/* externally defined functions
/*--------------------------------------------------------------*/

extern void CompileFOF();

extern fof_yerror(), fof_yyerror();   /* error printing etc     */
 
extern void fof_pf_add(), fof_pf_initsym();
extern ffpfnode *fof_pf_find(),*fof_pf_getnode();
 
extern fof_v_init();            /* variable symbol table stuff  */
extern ffvnode *fof_v_find(),*fof_v_add();
extern fof_v_lexin(),fof_v_lexout();
extern void fof_emit_code(), fof_emitinit(); /* atom emissions  */
extern void fof_print0();
extern void fof_op_sort();
 
extern ffopnode *fof_op_alloc(), *fof_op_clause();

/*--------------------------------------------------------------*/
/* externally defined constants
/*--------------------------------------------------------------*/

extern int ffyychar;
extern int ffcode[],ffcodeic;
extern char ffyytext[];                 /* lexemes go here      */
extern int ffskolemid;
extern int ffclause_count;
extern ffpfnode *ffpidtbl[],*fffidtbl[];
extern int ffsklist[DPMAX]; 

/*--------------------------------------------------------------*/
/* internally defined constants
/*--------------------------------------------------------------*/

int ffyyv[YYMAXDEPTH];      /* where the values are stored      */
int ffyychar = -1;          /* current input token number       */
int ffyynerrs = 0;              /* number of errors             */
short ffyyerrflag = 0;          /* error recovery flag          */
 
int ffdcltype,ffargdefault;
int fftneg,ffdynamic;       /* 1 = negate wffs on entry         */
int ffquantype;                     /* O_ALL / O_EX             */
int ffyylval, ffyyval;

int fftough, ffunknown, ffsatisfiable;

char fftheoCodeBuffer[200000],*fftheoCodePtr;
char ffclause_form[200000], *ffclause_form_ptr;

char ffresults[200000], *ffOutPtr;

char *ffClauseStart[2000],*ffClauseEnd[2000];
int ffClauseWeight[2000], ffClauseRank[2000];

char ffskolem_list[2000];

/*--------------------------------------------------------------*/
/* internally defined functions
/*--------------------------------------------------------------*/

int main_fof();
void fof_pid_check();
int fof_pid_gen();
int fof_binop();
int fof_yyparse();

/*--------------------------------------------------------------*/
/* main_fof()                        ....................#1
/*
/* calls:  fof_pf_initsym()
/*         fof_yyparse()
/*--------------------------------------------------------------*/
 
int main_fof()
{
char zz, chartemp, chartemp1;   
int i,j, m, n;
char *ffclause_form_ptr2;
char *zzz, *zzz2, *zzz3;
int lbrackets, commas;
int argumentz;

for(j = 0; j < 200000; j++) {ffclause_form[j] = 0;}
   ffclause_form_ptr = &ffclause_form[0];

ffOutPtr = &ffresults[0];

CompileFOF();
	
fftneg = 0;                   /* negate on T_THEOREM          */
ffdynamic = 1;                /* default dynamic value        */
ffskolemid = 1;               /* create opnode space          */
ffclause_count = 0;

for(i = 0; i < 2000; i++) {
   ffClauseStart[i] = ffskolem_list[i] = 0;}

fof_pf_initsym();         /* predicate function symbol table  */
fof_yyparse();                    /* parse the file           */

/*---------------------------------------------------*/
/* put hex 04 at end of file                         */
/*---------------------------------------------------*/

fof_op_sort();

zzz = &ffclause_form[0];
while(zzz < ffclause_form_ptr) {
   zzz2 = zzz;
   zzz2--;
   if(*zzz2 == 'S' && *zzz == 'K') {
      zzz3 = zzz;
      zzz++;
      n = 0;
      while(*zzz != '(') {
         if(*zzz >= '0' && *zzz <= '9') {
            n = n * 10 + ( (int) ( *zzz - '0') );}
         zzz++;}
      
      lbrackets =  1;
      commas = 0;
      zzz++;
      if(*zzz == ')') {ffskolem_list[n] = 0;goto skk;}
      while(lbrackets != 0) {
         if(lbrackets == 1 && *zzz == ',') commas++;
	 else if(*zzz == '(') lbrackets++;
	 else if(*zzz == ')') lbrackets--;
         zzz++;}	 
      ffskolem_list[n] = commas + 1;
skk:
      zzz = zzz3;
      zzz++;}
   else zzz++;}

return;
}

/*------------------------------------------------------------*/
/* fof_pid_check(p,a,type,msg,patch)    ................#3
/*
/* pid_check will make sure that the number of arguments
/* found match the declared number in the pfnode.
/* if the pfnode was dynamically created
/* we take the opportunity to set the args number.
/* We patch the generated code with the number
/* of arguments found
/*
/* called by:  fof_yyparse()          compwff.c
/*
/* calls:      fof_yerror()           err.c
/*
/* returns:    nil
/*-----------------------------------------------------------*/
 
void fof_pid_check(p,a,type,msg,patch)
ffpfnode *p;
int a, type, msg, patch;
{
int ptr, f, qq;
 
f = (type == P_PRED) ? 0 : FXNMASK;
 
if(p != 0) {   
   if((int) p <= 200) {printf("fatal error!!!  Edit wffs.\n");exit(0);}
   if((p->ffp_bits & P_TYPE) != type) {fof_yerror(msg);}
   else {
      if(a > MAXARGS) {fof_yerror(E_TOOMANYARGS);}
      else {
         if(p->ffp_nargs == -1) {p->ffp_nargs = a;}
         else {
	    if(p->ffp_nargs != a) {fof_yerror(E_ARGNUM);}}
         if(patch != -1) ffcode[patch] |= p->ffp_nargs;}}}
}
 
/*-----------------------------------------------------------*/
/* fof_pid_gen()                  ................#4
/*
/*pid_gen will [create and] generate a predicate/function
/*pfnode and emit code as well
/*
/* called by: fof_yyparse()               compwff.c
/*
/* calls:     fof_pf_find()               pfsym.c
/*            fof_yerror()                err.c
/*            fof_pf_getnode()            pfsym.c
/*            fof_pf_add()                pfsym.c
/*            fof_emit_code()             emit.c
/*
/* returns:   pointer to new pfnode
/*----------------------------------------------------------*/
 
int fof_pid_gen(type)
int type;
{
ffpfnode *p;
 
if((p = fof_pf_find(ffyytext)) == 0) {
   p = fof_pf_getnode(ffyytext);             /* define the ID    */
   p->ffp_nargs = -1;
   p->ffp_bits |= type;
   fof_pf_add(p);}                           /* add it to table  */
 
if(p != 0) {
   fof_emit_code(((type == P_FUNC) ? FXNMASK : 0) + (p->ffp_id<<FARGSHIFT));}
return((int) p);
}
 
/*-----------------------------------------------------------*/
/* fof_binop()              .........................#5
/*
/* will create an opnode for the given operator and
/* point its operands at the two passed parameters.
/*
/* called by:  fof_yyparse()             compwff.c
/*
/* calls:      fof_op_alloc()            ops.c
/*
/* returns:    pointer to new opnode
/*------------------------------------------------------------*/
 
int fof_binop(lhs,rhs,op)
ffopnode *lhs,*rhs;
int op;
{
ffopnode *o;
o = fof_op_alloc();
o->ffo_lhs = lhs; o->ffo_rhs = rhs;
o->ffo_bits = op | O_BIN;
return((int) o);
}
 
short ffyyexca[] = {
-1, 1,
0, -1,
-2, 0,
-1, 2,
0, 1,
-2, 8,
};
 
short ffyyact[] = { 
   5,  13,  11,  12,   9,  10,  29,  40,  22,  23,
  29,  24,  22,  23,  35,  24,  26,  76,  25,  41,
  26,  30,  25,  39,  76,  30,  72,  68,  35,  36,
  55,  96,  77,  95,  79,  90,  88,  83,  86,  77,
  91,  87,  67,  36,  80,  46,  88,  53,  58,  85,
  82,  43,  44,  45,  46,  44,  45,  46,  73,  66,
  74,  52,  17,  21,  19,  38,  65,  33,  20,  16,
   4,   3,  75,  15,  14,  28,  27,  31,  84,  51,
  81,  50,  48,  47,  37,  18,  78,  42,  49,  57,
  34,  32,   8,   7,   6,   2,   1,  54,   0,   0,
  56,   0,   0,  59,   0,   0,  60,  61,  62,  63,
  64,   0,   0,  70,  71,  69,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,  89,   0,   0,
  92,   0,   0,   0,   0,   0,   0,   0,  94,  93 };
 
short ffyypact[] = { 
-275,-1000,-275,-250,-1000,-1000,-1000,-250,-228,-1000,
-1000,-1000,-1000,-1000,-250,-1000,-249,-1000,-254,-1000,
-1000,-206,-1000,-1000,-246,-1000,-1000,-1000,-217,-1000,
-1000,-249,-242,-1000,-216,-1000,-1000,-249,-1000,-1000,
-1000,-246,-1000,-246,-246,-246,-246,-229,-229,-1000,
-250,-250,-239,-1000,-1000,-1000,-1000,-1000,-237,-1000,
-1000,-203,-203,-215,-1000,-226,-1000,-1000,-1000,-226,
-219,-218,-1000,-224,-1000,-217,-1000,-1000,-230,-1000,
-229,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-232,-232,
-1000,-238,-1000,-1000,-234,-1000,-1000 };
 
short ffyypgo[] = { 
   0,  96,  95,  71,  69,  65,  70,  94,  93,  62,
  92,  91,  67,  90,  89,  86,  85,  64,  63,  68,
  83,  66,  82,  59,  81,  80,  79,  78,  76,  75,
  61,  58,  60,  72 };
 
short ffyyr1[] = { 
   0,   1,   1,   1,   3,   2,   2,   6,   8,   6,
   4,   5,   5,   7,   7,   7,  10,  10,  10,  11,
  11,  13,  13,  12,  14,  14,  15,  15,   9,   9,
  17,  16,  16,  20,  19,  22,  19,  21,  21,  23,
  23,  18,  18,  18,  18,  18,  24,  18,  26,  18,
  18,  25,  25,  27,  27,  28,  28,  28,  30,  29,
  29,  31,  31,  32,  32,  33,  33 };
 
short ffyyr2[] = { 
   0,   1,   4,   3,   1,   1,   2,   1,   0,   3,
   1,   1,   1,   3,   1,   1,   1,   1,   1,   1,
   2,   1,   1,   2,   0,   3,   1,   3,   3,   1,
   1,   1,   2,   0,   3,   0,   3,   1,   3,   1,
   1,   3,   3,   3,   3,   2,   0,   4,   0,   4,
   1,   1,   1,   1,   1,   1,   3,   4,   1,   1,
   1,   1,   3,   1,   4,   1,   1 };
 
short ffyychk[] = { 
-1000,  -1,  -2,  -3,  -6, 275,  -7,  -8, -10, 279,
 280, 277, 278, 276,  -3,  -6,  -4,  -9, -16, -17,
 -19, -18, 262, 263, 261, 268, 266, -28, -29, 256,
 271,  -4, -11, -12, -13, 256, 271,  -4,  -5, 272,
 256, 273, -19, 257, 258, 259, 260, -20, -22, -18,
 -24, -26, -30, 264,  -5, 272, -12, -14, 264,  -5,
 -17, -18, -18, -18, -18, -21, -23, 271, 256, -21,
  -9,  -9, 265, -31, -32, -33, 256, 271, -15, 271,
 270, -25, 269, 256, -27, 267, 256, 265, 270, -30,
 265, 270, -23, -32, -31, 271, 265 };
 
short ffyydef[] = { 
   8,  -2,  -2,   0,   5,   4,   7,   0,   0,  14,
  15,  16,  17,  18,   0,   6,   0,  10,   0,  29,
  31,  30,  33,  35,   0,  46,  48,  50,  55,  59,
  60,   0,   0,  19,  24,  21,  22,   0,   3,  11,
  12,   0,  32,   0,   0,   0,   0,   0,   0,  45,
   0,   0,   0,  58,   9,  13,  20,  23,   0,   2,
  28,  41,  42,  43,  44,  34,  37,  39,  40,  36,
   0,   0,  56,   0,  61,  63,  65,  66,   0,  26,
   0,  47,  51,  52,  49,  53,  54,  57,   0,   0,
  25,   0,  38,  62,   0,  27,  64 };
 
/*----------------------------------------------------------*/
/* fof_yyparse()                        ..................#6
/*
/* called by:  main_fof()          compwff.c
/*
/* calls:      yylex()             lexwff.c
/*             v_init()            varsym.c
/*             fof_emitinit()      emit.c
/*             fof_op_clause()     ops.c
/*             fof_yerror()        err.c
/*             fof_pf_find()       pfsym.c
/*             fof_pf_getnode()    varsym.c
/*             fof_pf_add()        pfsym.c
/*             v_add()             varsym.c
/*             fof_op_alloc()      ops.c
/*             fof_binop()         compwff.c
/*             fof_v_lexout()      varsym.c
/*             fof_pid_check()     compwff.c
/*             fof_pid_gen()       compwff.c
/*             fof_v_find()        varsym.c
/*             fof_emit_code()     emit.c
/*
/* returns:    nil
/*----------------------------------------------------------*/
 
int fof_yyparse() 
{
short ffyys[YYMAXDEPTH];
short ffyyj, ffyym;
int *ffyypvt;
short ffyystate, *ffyyps, ffyyn;
int *ffyypv;
short *ffyyxi;
char ffzz;
 
ffyystate = 0;
ffyychar = -1;
ffyynerrs = 0;
ffyyerrflag = 0;
ffyyps= &ffyys[-1];
ffyypv= &ffyyv[-1];
 
ffyystack:           /* put a state and value onto the stack */

if(++ffyyps > &ffyys[YYMAXDEPTH]) {printf("yacc so");return;}

*ffyyps = ffyystate;
++ffyypv;
*ffyypv = ffyyval;
 
ffyynewstate:

ffyyn = ffyypact[ffyystate];

if(ffyyn <= YYFLAG) {goto ffyydefault;}     /* simple state */

if(ffyychar < 0) if((ffyychar = fof_yylex()) < 0) {ffyychar = 0;}

if((ffyyn += ffyychar) < 0 || ffyyn >= YYLAST ) {goto ffyydefault;}

if(ffyychk[ffyyn = ffyyact[ffyyn]] == ffyychar) { /* valid shift      */
   ffyychar = -1;
   ffyyval = ffyylval;
   ffyystate = ffyyn;
   if(ffyyerrflag > 0) --ffyyerrflag;
   goto ffyystack;}
 
ffyydefault:

/*----------------------*/
/* default state action */
/*----------------------*/
 
if((ffyyn = ffyydef[ffyystate]) == -2) {
   if(ffyychar < 0) if((ffyychar = fof_yylex()) < 0) ffyychar = 0;

/*------------------------------*/
/* look through exception table */
/*------------------------------*/
		
   for(ffyyxi = ffyyexca;(*ffyyxi != (-1)) || 
	     (ffyyxi[1] != ffyystate); ffyyxi += 2);
 
   while(*(ffyyxi += 2) >= 0) {
      if(*ffyyxi == ffyychar) break;}
			
   if((ffyyn = ffyyxi[1]) < 0) return(0);}      /* accept */
 
if(ffyyn == 0) {                                /* error  */

/*-------------------------------------*/
/* error ... attempt to resume parsing */
/*-------------------------------------*/
	
   switch(ffyyerrflag){
		
      case 0:                      /* brand new error */
	 printf("yychar = %x\n",ffyychar);
	 printf("syntax error");
	 ++ffyynerrs;
 
      case 1:
      case 2: /* incompletely recovered error ... try again */
 
	 ffyyerrflag = 3;
 
      /* find a state where "error" is a legal shift action */
 
	 while(ffyyps >= ffyys) {
	    ffyyn = ffyypact[*ffyyps] + YYERRCODE;
	    if(ffyyn >= 0 && ffyyn < YYLAST && 
		    ffyychk[ffyyact[ffyyn]] == YYERRCODE) {
	       ffyystate = ffyyact[ffyyn];/* simulate shift of "error"*/
	       goto ffyystack;}
	    ffyyn = ffyypact[*ffyyps];
 
/*-----------------------------------------------------*/
/* the current yyps has no shift on "error", pop stack */
/*-----------------------------------------------------*/
 
	    --ffyyps;
	    --ffyypv;}
 
/*--------------------------------------------------------------*/
/* there is no state on the stack with an error shift ... abort */
/*--------------------------------------------------------------*/
 
ffyyabort:
      
	 return;
 
      case 3:             /* no shift yet; clobber input char  */
	 if(ffyychar == 0) goto ffyyabort; /* don't discard EOF, quit */
	 ffyychar = -1;
	 goto ffyynewstate;}}     /* try again in the same state    */
 
	/* reduction by production ffyyn */

ffyyps -= ffyyr2[ffyyn];
ffyypvt = ffyypv;
ffyypv -= ffyyr2[ffyyn];
ffyyval = ffyypv[1];
ffyym = ffyyn;
			/* consult goto table to find next state */
ffyyn = ffyyr1[ffyyn];
ffyyj = ffyypgo[ffyyn] + *ffyyps + 1;
if(ffyyj >= YYLAST || ffyychk[ffyystate = ffyyact[ffyyj]] != -ffyyn) {
   ffyystate = ffyyact[ffyypgo[ffyyn]];}

switch(ffyym) {
 
   case 4:
      fftneg = 1; 
      fof_v_init();
      fof_print0("negated_conclusion\n",0); 
      break;
 
   case 8:
      fof_v_init(); 
      fof_emitinit(); 
      break;
 
   case 10:
      fof_op_clause(ffyypvt[-0],fftneg);
      break;
 
   case 12:
      fof_yerror(E_NODOT); 
      break;
 
   case 14:
      ffdynamic = 0; 
      break;
 
   case 15:
      ffdynamic = 1; 
      break;
 
   case 16:
      ffdcltype = P_PRED; 
      ffargdefault = -1; 
      break;
 
   case 17:
      ffdcltype = P_FUNC; 
      ffargdefault = -1; 
      break;
 
   case 18:
      ffdcltype = P_FUNC; 
      ffargdefault = 0; 
      break;
 
   case 19:
      ffyyval = 1; 
      break;
 
   case 20:
      ffyyval = ffyypvt[-1] + 1; 
      break;
 
   case 21:
      fof_yerror(E_NOID); 
      break;
 
   case 22:
      {ffpfnode *pf;
      ffyyval = 0;
      if((pf = fof_pf_find(ffyytext)) != 0) {fof_yerror(E_MULTIDEF);}
      else {
	 pf = fof_pf_getnode(ffyytext);    /* add to tree */
	 pf->ffp_nargs = -1;
	 pf->ffp_bits |= ffdcltype;      /* add in type */
	 fof_pf_add(pf);                 /* add it in */
	 ffyyval = (int) pf;}} 
	 break;
 
   case 23:
      {ffpfnode *pf;
      pf = (ffpfnode *) ffyypvt[-1];
      if(pf != 0) {
	 if(ffargdefault == 0 && ffyypvt[-0] != 0) {fof_yerror(E_CONSTARG);}
	 else {pf->ffp_nargs = ffyypvt[-0];}}}
      break;
 
   case 24:
      ffyyval = 0; 
      break;
 
   case 25:
      ffyyval = ffyypvt[-1]; 
      break;
 
   case 26:
      ffyyval = 1; 
      break;
 
   case 27:
      ffyyval = ffyypvt[-2] + 1; 
      break;
 
   case 28:
      ((ffopnode*) ffyypvt[-0])->ffo_qlist = (ffopnode *) ffyypvt[-2];
      ffyyval = ffyypvt[-0];
      break;
 
   case 29:
      ffyyval = ffyypvt[-0]; 
      break;
 
   case 30:
      {ffopnode *o;
      o = fof_op_alloc();
      o->ffo_expr = (ffopnode *) ffyypvt[-0];
      o->ffo_bits = O_WFF;
      o->ffo_qlist = 0;
      ffyyval = (int) o;} 
      break;
 
   case 31:
      ffyyval = ffyypvt[-0]; 
      break;
 
   case 32:
      {ffopnode *o;
      for(o=(ffopnode *) ffyypvt[-1];o->ffo_next!=0;o=o->ffo_next);
      o->ffo_next = (ffopnode *) ffyypvt[-0];
      ffyyval = ffyypvt[-1];}
      break;
 
   case 33:
      ffquantype = O_ALL; 
      break;
 
   case 34:
      ffyyval = ffyypvt[-0]; 
      break;
 
   case 35:
      ffquantype = O_EX;  
      break;
 
   case 36:
      ffyyval = ffyypvt[-0]; 
      break;
 
   case 37:
      ffyyval = ffyypvt[-0]; 
      break;
 
   case 38:
      {ffopnode *l;                       /* add to END of list */
      l = (ffopnode *) ffyypvt[-2];
      if(l != 0) {
	 while(l->ffo_next != 0) {l = l->ffo_next;}
	 l->ffo_next = (ffopnode *) ffyypvt[-0];}
      ffyyval = ffyypvt[-2];}
      break;
 
   case 39:
      {ffvnode *v; ffopnode *o;
      v = fof_v_add(ffyytext);
      o = fof_op_alloc();
      o->ffo_var = (ffopnode *) v->ffv_id;       /* quantified ID */
      o->ffo_bits = ffquantype | O_QUAN;
      o->ffo_next = 0;
      ffyyval = (int) o;}
      break;
 
   case 40:
      fof_yerror(E_NOID); 
      ffyyval = 0; 
      break;
 
   case 41:
      ffyyval = fof_binop(ffyypvt[-2],ffyypvt[-0],O_IFF); 
      break;
 
   case 42:
      ffyyval = fof_binop(ffyypvt[-2],ffyypvt[-0],O_IMP); 
      break;
 
   case 43:
      ffyyval = fof_binop(ffyypvt[-2],ffyypvt[-0],O_OR); 
      break;
 
   case 44:
      ffyyval = fof_binop(ffyypvt[-2],ffyypvt[-0],O_AND);  
      break;
 
   case 45:
      {ffopnode *o;
      o = (ffopnode *) ffyypvt[-0];
      o->ffo_bits ^= O_LNEG;
      ffyyval = ffyypvt[-0];}
      break;
	
   case 46:
      fof_v_lexin(); 
      break;
 
   case 47:
      fof_v_lexout();
      ffyyval = ffyypvt[-1]; 
      break;
 
   case 48:
      fof_v_lexin(); 
      break;
 
   case 49:
      fof_v_lexout();
      ffyyval = ffyypvt[-1]; 
      break;
 
   case 50:
      {ffopnode *o;
      o = fof_op_alloc();                   /* grab a node */
      o->ffo_pred = (ffopnode *) ffyypvt[-0];/* predicate code */
      o->ffo_bits = O_ATOM;
      ffyyval = (int) o;} 
      break;
		
   case 52:
      fof_yerror(E_NORBRACKET);
      break;
 
   case 54:
      fof_yerror(E_NORBRACE); 
      break;
 
   case 55:
      fof_pid_check(ffyypvt[-0],0,P_PRED,E_PREDEXP,-1);
      ffyyval = ffcodeic - 1;
      break;
 
   case 56:
      fof_pid_check(ffyypvt[-2],0,P_PRED,E_PREDEXP,-1);
      ffyyval = ffyypvt[-1];
      break;
 
   case 57:
      fof_pid_check(ffyypvt[-3],ffyypvt[-1],P_PRED,E_PREDEXP,ffyypvt[-2]);
      ffyyval = ffyypvt[-2];
      break;
 
   case 58:
      ffyyval = ffcodeic - 1; 
      break;
 
   case 59:
      fof_yerror(E_NOPID); 
      ffyyval = 0; 
      break;
 
   case 60:
      ffyyval = fof_pid_gen(P_PRED); 
      break;
 
   case 61:
      ffyyval = 1; 
      break;
 
   case 62:
      ffyyval = ffyypvt[-2] + 1; 
      break;
 
   case 63:
      fof_pid_check(ffyypvt[-0],0,P_FUNC,E_FUNCEXP,-1); 
      break;
 
   case 64:
      fof_pid_check(ffyypvt[-3],ffyypvt[-1],P_FUNC,E_FUNCEXP,ffyypvt[-2]); 
      break;
 
   case 65:
      {fof_yerror(E_NOID);} 
      break;
 
   case 66:
      {ffvnode *v;
      ffyyval = 0;
      if((v = fof_v_find(ffyytext)) == 0) {ffyyval = fof_pid_gen(P_FUNC);}
      else {fof_emit_code(v->ffv_id<<FARGSHIFT);}}  /* emit var. */
      break;}
 
goto ffyystack;  /* stack new state and value */
 
}

