/*--------------------------------------------------------------*
/* equal.c
/* copyrighted by Monty Newborn 2005
/*
/* functions:
/* equal_predicate().....................#1
/* esa_for_fxns()........................#2
/* test_equality_fxn()...................#3
/* esa_for_lits()........................#4
/* test_lits()...........................#5
/*--------------------------------------------------------------*/

#include <strings.h>
#include <stdio.h>

#include "const.h"
#include "clause.h"

/*--------------------------------------------------------------*/
/* externally defined functions
/*--------------------------------------------------------------*/

extern void print0();

/*--------------------------------------------------------------*/
/* externally defined constants
/*--------------------------------------------------------------*/

extern int base;
extern int equal_pred;
extern int equal_clist_index;
extern int cade_format;
extern int equal_xyyzxz;

extern clause *clist[];

extern char *OutPtr;

/*--------------------------------------------------------------*/
/* internally defined functions
/*--------------------------------------------------------------*/

void equal_predicate();
void esa_for_fxns();
int test_equality_fxn();
void esa_for_lits();
int test_lits();

/*--------------------------------------------------------------*/
/* internally defined functions
/*--------------------------------------------------------------*/

int plus_lit;

/*--------------------------------------------------------------*/
/*      equal_predicate()        .................. #1
/*
/*      see if "Equal" predicate is implicitly one of the     
/*      predicates.  Look for p(x,x), the ~p(x,y) | p(y,x), etc.
/*
/*      called by:   prepare_clauses()   theo.c or herby.c
/*
/*      calls:       esa_for_fxns()      equal.c
/*                   esa_for_lits()      equal.c
/*
/*      returns:     Nil
/*--------------------------------------------------------------*/

void equal_predicate()
{
literal *l, *l1, *l2, *l3; 
clause *c;
int i, j, k, v1, v2, v3, v4, v5, v6;
int *p, *q, *r;
int pargs, qargs;
int l1id, l2id, l3id;
int ee;

if(cade_format == 0) printf("EQ: ");
OutPtr += sprintf(OutPtr,"EQ: ");

for(i = 0; i <= base ; i++) { 
   c = clist[i]; 
   if(c->c_nlit != 1) {continue;}
   if(c->c_nv != 1) {continue;}
   if((c->c_lit->l_id & ARGMASK) != 2) {continue;}
   if((c->c_lit->l_id & NEGMASK) != 0) {continue;}
   p = &c->c_lit->l_id;
   p++; 
   v1 = *p++;
   v2 = *p;
   if(v1 != v2) {continue;}
   if(v1 & FCNMASK) {continue;}
   ee = c->c_lit->l_id & IDMASK;
   c->c_bits |= EQCLS;

   if(cade_format == 0) printf(" %d",i + 1);
   OutPtr += sprintf(OutPtr," %d",i + 1);

   for(j = 0; j <= base; j++) {
      c = clist[j];
      if(c->c_nlit != 2) {continue;}
      if(c->c_nv != 2) {continue;}
      l1 = c->c_lit;
      if((l1->l_id & IDMASK) != ee) {continue;}
      l2 = l1->l_next;
      if((l1->l_id & NEGMASK) == (l2->l_id & NEGMASK)) {continue;}
      if((l1->l_id & IDMASK) != (l2->l_id & IDMASK)) {continue;}
      p = &l1->l_id;
      q = &l2->l_id;
      p++; q++;
      v1 = *p++;
      v2 = *p;
      v3 = *q++;
      v4 = *q; 
      if(v1 != v4) {continue;}
      if(v2 != v3) {continue;}
      if(v1 & FCNMASK) {continue;}
      if(v2 & FCNMASK) {continue;}

      c->c_bits |= EQCLS; 

      if(cade_format == 0) printf(".%d",j + 1);
      OutPtr += sprintf(OutPtr,".%d",j + 1);

      for(k = 0; k <= base; k++) {
         c = clist[k]; 
         if(c->c_nlit != 3) {continue;}
         if(c->c_nv != 3) {continue;}
         l1 = c->c_lit;
         if((l1->l_id & IDMASK) != ee) {continue;}
         l2 = l1->l_next;
         l3 = l2->l_next;
         l1id = l1->l_id; l2id = l2->l_id; l3id = l3->l_id;
         if((l1id & NEGMASK) == (l2id & NEGMASK) &&
              (l1id & NEGMASK) == (l3id & NEGMASK)) {continue;}

         if((l1->l_id & IDMASK) != (l2->l_id & IDMASK)) {continue;}
         if((l1->l_id & IDMASK) != (l3->l_id & IDMASK)) {continue;}

         if(((l1->l_id & NEGMASK) == 0) &&
            ((l2->l_id & NEGMASK) != 0) &&
            ((l3->l_id & NEGMASK) != 0))  {plus_lit = 1;}
         if(((l1->l_id & NEGMASK) != 0) &&
            ((l2->l_id & NEGMASK) == 0) &&
            ((l3->l_id & NEGMASK) != 0))  {plus_lit = 2;}
         if(((l1->l_id & NEGMASK) != 0) &&
            ((l2->l_id & NEGMASK) != 0) &&
            ((l3->l_id & NEGMASK) == 0))  {plus_lit = 3;}
         p = &l1->l_id;
         q = &l2->l_id;
         r = &l3->l_id;

         p++; q++; r++;
         v1 = *p++;
         v2 = *p;
         v3 = *q++;
         v4 = *q; 
         v5 = *r++;
         v6 = *r;
         if(v1 == v3 && v2 == v6 && v4 == v5) goto equal3;
         if(v1 == v3 && v2 == v5 && v4 == v6) goto equal3;
         if(v1 == v4 && v2 == v6 && v3 == v5) goto equal3;
         if(v1 == v4 && v2 == v5 && v3 == v6) goto equal3;
         if(v1 == v5 && v2 == v4 && v3 == v6) goto equal3;
         if(v1 == v5 && v2 == v3 && v4 == v6) goto equal3;
         if(v1 == v6 && v2 == v4 && v3 == v5) goto equal3;
         if(v1 == v6 && v2 == v3 && v4 == v5) goto equal3;
         continue;
         equal3:
         if(v1 & FCNMASK) continue;
         if(v2 & FCNMASK) continue;
         if(v3 & FCNMASK) continue;
         if(v4 & FCNMASK) continue;
         if(v5 & FCNMASK) continue;
         if(v6 & FCNMASK) continue;

         c->c_bits |= EQCLS;

         if(cade_format == 0) printf(".%d",k + 1);
         OutPtr += sprintf(OutPtr,".%d",k + 1);
         equal_xyyzxz = k + 1;
         if(equal_pred == 0) {
	     equal_pred = (c->c_lit->l_id & ~NEGMASK);}
         equal_clist_index = i;}}}

if(cade_format == 0) printf("\n");
OutPtr += sprintf(OutPtr,"\n");

esa_for_fxns();
esa_for_lits();
return;
}

/*-----------------------------------------------------*/
/*      esa_for_fxns()    ................#2           */
/*                                                     */
/*      determine whether clause c is an equality      */
/*      substitution axiom, e. g. ~equal(x,y) |        */
/*      equal(f(x),f(y)                                */
/*                                                     */
/*      called by:   equal_predicate()     theo.c      */
/*                                                     */
/*      calls:       test_equality_fxn()   equal.c     */
/*                                                     */
/*      returns:     Nil                               */
/*-----------------------------------------------------*/
 
void esa_for_fxns()
{
clause *c;
literal *l1, *l2;
int i, v1, v2;
int *p;

if(cade_format == 0) printf("ESAF:");
OutPtr += sprintf(OutPtr,"ESAF:");

for(i = 0; i <= base; i++) { 
   c = clist[i]; 
   if(c->c_nlit != 2) {continue;}
 
   l1 = c->c_lit;
   l2 = l1->l_next;
 
   if((l1->l_id & ~NEGMASK) != equal_pred) {continue;}
   if((l2->l_id & ~NEGMASK) != equal_pred) {continue;}
   if(l1->l_id ^ l2->l_id ^ NEGMASK) {continue;} 
 
   if((l1->l_id & NEGMASK) == 0) {
      l1 = l2;
      l2 = c->c_lit;}
/*-------------------------------------------------------*/
/*   clause with two equal lits.  l1 is the "~" one.     */
/*   now see if l1 is of form equal(x,y)                 */
/*-------------------------------------------------------*/

   p = &l1->l_id;
   p++;

   v1 = *p++;
   v2 = *p;
   if(((v1 & FCNMASK) == 0) && ((v2 & FCNMASK) == 0 && v1 != v2)) {
 
/*--------------------------------------------------------*/
/*   thus far, we have found that "~equal(x,y) is present */
/*--------------------------------------------------------*/

      if(test_equality_fxn(l2,v1,v2)) {
         c->c_bits |= EQCLS;

         OutPtr += sprintf(OutPtr," %d",i + 1);
         if(cade_format == 0) printf(" %d",i + 1);}}}

if(cade_format == 0) printf("\n");
OutPtr += sprintf(OutPtr,"\n");
return;
}
 
/*-----------------------------------------------------------------*/
/*   test_equality_fxn()           ................#3              */
/*                                                                 */
/*   now see if the equality literal is a equality substitution    */
/*   for example, equal(f(x,y),f(z,y)) would pass.                 */ 
/*                                                                 */
/*   called by:  esa_for_fxns()       equal.c                      */
/*                                                                 */
/*   calls:      nobody                                            */
/*                                                                 */
/*   returns:    0 if l_equal is not an equality substitution fxn  */
/*               1 if it is                                        */ 
/*-----------------------------------------------------------------*/
 
int test_equality_fxn(l_equal,v1,v2)
literal *l_equal;
int v1, v2;
{
int  a;
int esv;                    /* equality substitution variable  */
int *p, *p1;
 
esv = 0;
 
p1 = p = &l_equal->l_id;
 
for(a = (*p++ & ARGMASK); a > 1; a--) {
   if(*p & FCNMASK) {
      a += *p++ & ARGMASK;}
   else {p++;}}
   
/*--------------------------------------*/
/* if first symbol is a variable, then  */
/* return, since clause shows symmetry  */
/* in the equality predicate.           */
/*--------------------------------------*/

if((*p & FCNMASK) == 0) {return(0);} 

/*--------------------------------------*/
/* p now points to beginning of 2nd     */
/* half of the equality predicate.      */
/* p1 now points to the beginning.      */
/* now a scan is made comparing each    */
/* symbol in the two halfs              */
/*--------------------------------------*/

for(a = (*p1++ & ARGMASK); a > 1; a--) {
   if(*p != *p1) {
      if((*p == v1 && *p1 == v2) || (*p == v2 && *p1 == v1)) {
         esv++;
         if(esv > 1) {return(0);}}}
   if(*p1 & FCNMASK) {
      a +=*p1++ & ARGMASK;
      p++;}
   else {
      p++; p1++;}} 
 

return(1);
}
 
 
/*-----------------------------------------------------*/
/*      esa_for_lits()    ................#4           */
/*                                                     */
/*      determine whether clause c is an equality      */
/*      substitution axiom  for literals.              */
/*      for example: ~equal(x,y) | ~P(x) | P(y)        */
/*                                                     */
/*      called by:   equal_predicate()     theo.c      */
/*                                                     */
/*      calls:       test_lits()           equal.c     */
/*                                                     */
/*      returns:     Nil                               */
/*-----------------------------------------------------*/
 
void esa_for_lits()
{
clause *c;
literal *l1, *e_lit, *p_lit, *n_lit;
int i, v1, v2;
int *p;

if(cade_format == 0) printf("ESAP:");
OutPtr += sprintf(OutPtr,"ESAP:");

for(i = 0; i <= base; i++) { 
   c = clist[i]; 
   if(c->c_nlit != 3) {continue;}

   e_lit = p_lit = n_lit = 0;

   for(l1 = c->c_lit; l1 != 0; l1 = l1->l_next) {
      if((l1->l_id & ~NEGMASK) == equal_pred) {e_lit = l1;}
      else if((l1->l_id & ~NEGMASK) != equal_pred) {
         if((l1->l_id & NEGMASK) == 0) {p_lit = l1;}
         else {n_lit = l1;}}}
   if(e_lit == 0 || p_lit == 0 || n_lit == 0) {continue;}
   if((p_lit->l_id & ~NEGMASK) != (n_lit->l_id & ~NEGMASK)) {continue;}

   p = &e_lit->l_id;
   p++;

   v1 = *p++;
   v2 = *p;
   if(((v1 & FCNMASK) == 0) && ((v2 & FCNMASK) == 0 && v1 != v2)) {
 
/*--------------------------------------------------------*/
/*   thus far, we have found that "~equal(x,y) is present */
/*   now test the two literals.                           */
/*--------------------------------------------------------*/

      if(test_lits(p_lit,n_lit,v1,v2)) { 
         c->c_bits |= EQCLS;
         OutPtr += sprintf(OutPtr," %d",i + 1); 
         if(cade_format == 0) printf(" %d",i + 1);}}}

if(cade_format == 0) printf("\n");
OutPtr += sprintf(OutPtr,"\n");
return;
}
  
/*-----------------------------------------------------------------*/
/*   test_lits()                   ................#5              */
/*                                                                 */
/*   now see if other two literals differ by only one var.         */
/*   for example, p(x,y) and p(x,z)    would pass.                 */ 
/*                                                                 */
/*   called by:  esa_for_lits()       equal.c                      */
/*                                                                 */
/*   calls:      nobody                                            */
/*                                                                 */
/*   returns:    0 if l_equal is not an equality substitution fxn  */
/*               1 if it is                                        */ 
/*-----------------------------------------------------------------*/
 
int test_lits(l1,l2,v1,v2)
literal *l1, *l2;
int v1, v2;
{
int  a;
int esv;                    /* equality substitution variable  */
int *p1, *p2;
 
esv = 0;
 
p1 = &l1->l_id;
p2 = &l2->l_id;
 
for(a = (*p1++ & ARGMASK); a > 0; a--) {
   if(*p2 != *p1) {
      if((*p2 == v1 && *p1 == v2) || (*p2 == v2 && *p1 == v1)) {
         esv++;
         if(esv > 1) {return(0);}}}
   if(*p1 & FCNMASK) {
      a +=*p1++ & ARGMASK;
      p2++;}
   else {
      p2++; p1++;}} 
return(1);
}

