/*----------------------------------------------------------*/
/*
/* lexwff.c       lexical scanner
/*
/* Copyright Newborn Software 1993, 1996, 1999, 2004
/*
/* functions:
/*  fof_tcheck()...........................#1
/*  fof_yylex()............................#2
/*  fof_yylook()...........................#3
/*  fof_yyback()...........................#4
/*
/*------------------------------------------------------------*/
 
#include "string.h"
#include "stdio.h"
 
#include "compwff.h"
#include "clause.h"
#include "const.h"
 
#define fof_output(c)    putchar(c);
 
#define fof_input()    if(ffyysptr > ffyysbuf) ffyytchar = fof_U(*--ffyysptr);\
                       else if(o_tptp == 4) ffyytchar = *theoCodePtr++;\
		       else ffyytchar = getc(infile);\
		       if(ffyytchar == 10 || ffyytchar == 13) ffyylineno++;\
		       if(ffyytchar == 4 || ffyytchar == -1) ffyytchar = 0;
 
#define fof_unput(c)  {ffyytchar= (c);\
		    if(ffyytchar==10) ffyylineno--;\
		    *ffyysptr++=ffyytchar;}
 
#define fof_U(x)        x
#define fof_YYU(x)      x
 
extern void fof_yerror();          /* error message printing   */
extern int ffyylval;

extern FILE *infile;

extern char theoCodeBuffer[], *theoCodePtr;
extern char ffclause_form[200000], *ffclause_form_ptr;
extern o_tptp;
 
/*-------------------------------------------------------------*/
/* internally defined constants
/*-------------------------------------------------------------*/

int ffyyleng;
int ffyymorfg;
int ffyyprevious = YYNEWLINE;
int *ffyyfnd; 
int ffyylineno = 1;
int ffyytchar;
 
char ffyytext[YYLMAX];
char ffyysbuf[YYLMAX];
char *ffyysptr = ffyysbuf;
 
struct ffyysvf *ffyylstate [YYLMAX], **ffyylsp, **ffyyolsp;
 
struct ffyysvf {
	struct ffyywork *ffyystoff;
	struct ffyysvf *ffyyother;
	int *ffyystops;};
 
struct ffyysvf *ffyyestate;

/*-------------------------------------------------------------*/
/* internally defined functions
/*-------------------------------------------------------------*/

int fof_tcheck();
int fof_yylex();
int fof_yylook();
int fof_yyback();

/*-------------------------------------------------------------*/
/* fof_tcheck()                      .....................#1
/*
/* will check an identifier to see if it is a keyword
/*
/* called by:  fof_yylex()           lexwff.c
/*
/* calls:      nobody
/*
/* returns:    keyword
/*-------------------------------------------------------------*/
 
int fof_tcheck()
{
if(strcmp(ffyytext,"conclusion") == 0) {return(T_THEOREM);}
return(T_ID);
}
 
/*-----------------------------------------------------------*/
/* fof_yylex()                ........................#2
/*
/* called by:  fof_yyparse()          compwff.c
/*
/* calls:      fof_yylook()           lexwff.c
/*             fof_tcheck()           lexwff.c
/*             fof_yerror()           err.c
/*
/* returns:    codes for various input symbols
/*------------------------------------------------------------*/
 
int fof_yylex()
{
int ffintnstr;
int fftc;
 
while((ffintnstr = (int) fof_yylook()) >= 0) {
ffyyfussy:  switch(ffintnstr) {
      case 0:
	 return(0);
      case 1:
	 return(T_COMMA);
	 break;
      case 2:
	 return(T_FORALL);
	 break;
      case 3:
	 return(T_EXISTS);
	 break;
      case 4:
	 return(T_IMPLIES);
	 break;
      case 5:
	 return(T_IFF);
	 break;
      case 6:
	 return(T_OR);
	 break;
      case 7:
	 return(T_AND);
	 break;
      case 8:
	 return(T_NOT);
	 break;
      case 9:
	 return(T_LPAR);
	 break;
      case 10:
	 return(T_RPAR);
	 break;
      case 11:
	 return(T_LBRACKET);
	 break;
      case 12:
	 return(T_RBRACKET);
	 break;
      case 13:
	 return(T_LBRACE);
	 break;
      case 14:
	 return(T_RBRACE);
	 break;
      case 15:
	 return(T_DOT);
	 break;
      case 16:
	 return(T_COLON);
	 break;
      case 17:
	 fftc = fof_tcheck();
	 return(fftc);
	 break;
      case 18:
	 ;
	 break;
      case 19:
	 ;
	 break;
      case 20:
	 fof_yerror(E_BADCHAR);
	 break;
      case -1:
	 break;
      default:
	 printf("bad switch ffyylook %d",ffintnstr);
	 ffclause_form_ptr += sprintf(ffclause_form_ptr,
	            "bad switch ffyylook %d",ffintnstr);}}
return(0); 
}

/*--------------------------------------------------------------------*/
 
int ffyyvstop[] = {
0, 
20, 0, 
19, 20, 0, 
19, 0, 
3,  20, 0, 
17, 20, 0, 
6,  20, 0, 
9,  20, 0, 
10, 20, 0, 
1,  20, 0, 
15, 20, 0, 
16, 20, 0, 
18, 20, 0, 
20, 0, 
17, 20, 0, 
2,  20, 0, 
11, 20, 0, 
12, 20, 0, 
13, 20, 0, 
7,  20, 0, 
14, 20, 0, 
8,  20, 0, 
17, 0, 
18, 0, 
4,  0, 
5,  0, 0};
 
struct ffyywork { char ffverify, ffadvance; } ffyycrank[] = {
0,0,    0,0,    1,3,    0,0,
0,0,    0,0,    0,0,    14,25,
0,0,    0,0,    1,4,    1,5,
25,0,   4,5,    4,5,    14,25,
14,0,   0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    1,6,    1,7,
4,5,    0,0,    0,0,    1,8,
14,25,  1,9,    1,10,   2,6,
0,0,    1,11,   0,0,    1,12,
2,8,    0,0,    2,9,    2,10,
0,0,    0,0,    2,11,   0,0,
2,12,   0,0,    0,0,    1,13,
1,14,   1,15,   1,16,   15,26,
26,28,  1,17,   0,0,    0,0,
2,13,   2,14,   2,15,   2,16,
0,0,    0,0,    2,17,   0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
1,18,   0,0,    1,19,   0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    2,18,   0,0,    2,19,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
1,20,   1,21,   1,22,   1,23,
0,0,    0,0,    0,0,    0,0,
0,0,    2,20,   2,21,   2,22,
2,23,   7,0,    7,0,    7,0,
7,0,    7,0,    7,0,    7,0,
7,0,    7,0,    7,0,    7,0,
7,0,    7,0,    7,0,    7,0,
7,0,    7,0,    7,0,    7,0,
7,0,    7,0,    7,0,    7,0,
7,0,    7,0,    7,0,    7,0,
7,0,    7,0,    7,0,    7,0,
7,0,    7,0,    7,24,   7,0,
7,0,    7,0,    7,0,    0,0,
7,0,    7,0,    0,0,    0,0,
7,0,    0,0,    7,0,    7,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    7,0,    7,0,
7,0,    0,0,    7,0,    0,0,
7,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    7,0,
7,0,    7,0,    0,0,    0,0,
7,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    7,0,
7,0,    7,0,    7,0,    7,0,
16,0,   16,0,   16,0,   16,0,
16,0,   16,0,   16,0,   16,0,
16,0,   16,0,   16,0,   16,0,
16,0,   16,0,   16,0,   16,0,
16,0,   16,0,   16,0,   16,0,
16,0,   16,0,   16,0,   16,0,
16,0,   16,0,   16,0,   16,0,
16,0,   16,0,   16,0,   16,0,
16,0,   0,0,    16,0,   16,0,
16,0,   16,0,   0,0,    16,0,
16,0,   0,0,    0,0,    16,0,
0,0,    16,0,   16,0,   0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    16,0,   16,0,   16,0,
0,0,    16,27,  0,0,    16,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    16,0,   16,0,
16,0,   0,0,    0,0,    16,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    16,0,   16,0,
16,0,   16,0,   16,0,   24,0,
24,0,   24,0,   24,0,   24,0,
24,0,   24,0,   24,0,   24,0,
24,0,   24,0,   24,0,   24,0,
24,0,   24,0,   24,0,   24,0,
24,0,   24,0,   24,0,   24,0,
24,0,   24,0,   24,0,   24,0,
24,0,   24,0,   24,0,   24,0,
24,0,   24,0,   24,0,   24,0,
0,0,    24,0,   24,0,   24,0,
24,0,   0,0,    24,0,   24,0,
0,0,    0,0,    24,0,   0,0,
24,0,   24,0,   0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
24,0,   24,0,   24,0,   0,0,
24,0,   0,0,    24,0,   0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    24,0,   24,0,   24,0,
0,0,    0,0,    24,0,   0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    0,0,    0,0,    0,0,
0,0,    24,0,   24,0,   24,0,
24,0,   24,0,   0,0,    0,0,
0,0};
 
struct ffyysvf fyysqec[] = {
0,                0,              0,
ffyycrank+-1,     0,              0,
ffyycrank+-10,    fyysqec+1,      0,
ffyycrank+0,      0,              ffyyvstop+1,
ffyycrank+4,      0,              ffyyvstop+3,
ffyycrank+0,      fyysqec+4,      ffyyvstop+6,
ffyycrank+0,      0,              ffyyvstop+8,
ffyycrank+-136,   0,              ffyyvstop+11,
ffyycrank+0,      0,              ffyyvstop+14,
ffyycrank+0,      0,              ffyyvstop+17,
ffyycrank+0,      0,              ffyyvstop+20,
ffyycrank+0,      0,              ffyyvstop+23,
ffyycrank+0,      0,              ffyyvstop+26,
ffyycrank+0,      0,              ffyyvstop+29,
ffyycrank+-6,     0,              ffyyvstop+32,
ffyycrank+2,      0,              ffyyvstop+35,
ffyycrank+-263,   fyysqec+7,      ffyyvstop+37,
ffyycrank+0,      0,              ffyyvstop+40,
ffyycrank+0,      0,              ffyyvstop+43,
ffyycrank+0,      0,              ffyyvstop+46,
ffyycrank+0,      0,              ffyyvstop+49,
ffyycrank+0,      0,              ffyyvstop+52,
ffyycrank+0,      0,              ffyyvstop+55,
ffyycrank+0,      0,              ffyyvstop+58,
ffyycrank+-390,   fyysqec+7,      ffyyvstop+61,
ffyycrank+-2,     fyysqec+14,     ffyyvstop+63,
ffyycrank+2,      0,              0,
ffyycrank+0,      0,              ffyyvstop+65,
ffyycrank+0,      0,              ffyyvstop+67,
0,                0,              0};
 
struct ffyywork *ffyytop = ffyycrank+517;
 
struct ffyysvf *ffyybgin = fyysqec+1;
 
char ffyymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,'"' ,01  ,01  ,01  ,01  ,'"' ,
01  ,01  ,'"' ,'"' ,01  ,'"' ,01  ,01  ,
'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,
'"' ,'"' ,01  ,01  ,01  ,'"' ,01  ,'"' ,
01  ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,
'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,
'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,
'"' ,'"' ,'"' ,01  ,01  ,01  ,'"' ,'"' ,
01  ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,
'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,
'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,'"' ,
'"' ,'"' ,'"' ,01  ,01  ,01  ,01  ,01  ,
0};
 
char ffyyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
 
/*-------------------------------------------------------*/
/* fof_yylook()                ....................#3
/*
/* called by:  fof_yylex()              lexwff.c
/*
/* calls:      fof_yyback()             lexwff.c
/*
/* returns:    *yyfnd++
/*------------------------------------------------------*/
 
int fof_yylook()
{
struct ffyysvf *ffyystate, **fflsp;
struct ffyywork *ffyyt;
struct ffyysvf *ffyyz;
int ffyych;
struct ffyywork *ffyyr;
char *ffyylastch, ffcurr_chr;
 
/*--------------------*/
/* start off machines */
/*--------------------*/
	
if(!ffyymorfg) {
   ffyylastch = ffyytext;}
else {
   ffyymorfg = 0;
   ffyylastch = ffyytext + ffyyleng;}
	
for(;;) {
   fflsp = ffyylstate;
   ffyyestate = ffyystate = ffyybgin;
   if(ffyyprevious == YYNEWLINE) {
      ffyystate++;}
   for(;;) {
      ffyyt = ffyystate->ffyystoff;
      if(ffyyt == ffyycrank) {      /* may not be any transit's */
	 ffyyz = ffyystate->ffyyother;
	 if(ffyyz == 0) break;
	 if(ffyyz->ffyystoff == ffyycrank) break;}
      fof_input();
//    printf("%c",ffyytchar);
      *ffyylastch++ = ffyych = ffyytchar;

fftryagain:
      ffyyr = ffyyt;

      if((int) ffyyt > (int) ffyycrank) {
	 ffyyt = ffyyr + ffyych;

	 if(ffyyt <= ffyytop && ffyyt->ffverify + fyysqec == ffyystate) {
	    if(ffyyt->ffadvance + fyysqec == YYLERR) {
	       fof_unput(*--ffyylastch);
	       break;}
	    *fflsp++ = ffyystate = ffyyt->ffadvance + fyysqec;
	    goto ffcontin;}}

      else if((int) ffyyt < (int) ffyycrank) {
	 ffyyt = ffyyr = ffyycrank + (ffyycrank - ffyyt);
	 ffyyt = ffyyt + ffyych;
	 if(ffyyt <= ffyytop && ffyyt->ffverify + fyysqec == ffyystate) {
	    if(ffyyt->ffadvance + fyysqec == YYLERR) {
	       fof_unput(*--ffyylastch);
	       break;}
	    *fflsp++ = ffyystate = ffyyt->ffadvance + fyysqec;
	    goto ffcontin;}
	 ffyyt = ffyyr + fof_YYU(ffyymatch[ffyych]);
 
	 if(ffyyt <= ffyytop && ffyyt->ffverify + fyysqec == ffyystate){
	    if(ffyyt->ffadvance + fyysqec == YYLERR) { 
	       fof_unput(*--ffyylastch);
	       break;}
	    *fflsp++ = ffyystate = ffyyt->ffadvance + fyysqec;
	    goto ffcontin;}}
      if((ffyystate = ffyystate->ffyyother) && 
			(ffyyt = ffyystate->ffyystoff) != ffyycrank) {
	 goto fftryagain;}
      else  {
	 fof_unput(*--ffyylastch);break;}
ffcontin:
			;}
   while(fflsp-- > ffyylstate) {
      *ffyylastch-- = 0;
      if(*fflsp != 0 && (ffyyfnd = (*fflsp)->ffyystops) && *ffyyfnd > 0) {
	 ffyyolsp = fflsp;
	 if(ffyyextra[*ffyyfnd]){     /* must backup */
	    while(fof_yyback((*fflsp)->ffyystops,-*ffyyfnd) != 1 
					&& fflsp > ffyylstate) {
	       fflsp--;
	       fof_unput(*ffyylastch--);}}
	 ffyyprevious = fof_YYU(*ffyylastch);
	 ffyylsp = fflsp;
	 ffyyleng = ffyylastch - ffyytext + 1;
	 ffyytext[ffyyleng] = 0;
	 return(*ffyyfnd++);}
      fof_unput(*ffyylastch);}
			
   if(ffyytext[0] == 0) {
      ffyysptr = ffyysbuf;
      return(0);}
   fof_input();
// printf("%c",ffyytchar);
   ffyyprevious = ffyytext[0] = ffyytchar;
   if(ffyyprevious > 0)  fof_output(ffyyprevious);
   ffyylastch = ffyytext;}
}
 
/*--------------------------------------------------------*/
/* fof_yyback(p,m)                     .................#4
/*
/* called by:  fof_yyparse()             lexwff.c
/*
/* calls:      nobody
/*
/* returns:    0/1
/*-------------------------------------------------------*/
 
int fof_yyback(p,m)
int *p,m;
{
 
if(p == 0) return(0);
 
while(*p) {if(*p++ == m) return(1);}
	
return(0);
}
 
 
 

