/*--------------------------------------------------------------*/
/*      name.c
/*      copyrighted by Monty Newborn 2005
/*
/*      functions:
/*               void rename_functions()
/*               void rename_routine()
/*--------------------------------------------------------------*/

#include "const.h"
#include "clause.h"

#include <strings.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

extern int rename_preds;
extern int rename_fxns;
extern int number_preds, number_fxns;

extern char *pidtbl[], *fidtbl[];

void rename_functions();
void rename_routine();

/*--------------------------------------------------------------*/
/*      rename_functions()              .............. #1
/*
/*      replace names of some functions with shorter names
/*
/*      called by:
/*
/*      call: nobody
/*
/*      returns: nil
/*---------------------------------------------------------------*/

void rename_functions()
{
char *ii, *jj, *q;
int a, b, k, test, replace;

rename_fxns = rename_preds = 0;

/*------------------------------------*/
/* predicate names to replace         */
/*------------------------------------*/

rename_routine("achievable","ACH",1);
rename_routine("basic_output","BOUT",1);
rename_routine("between","B",1);
rename_routine("colinear","COL",1);
rename_routine("equal","E.",1);
rename_routine("equidistant","D",1);
rename_routine("homomorphism","HOM",1);
rename_routine("horizontal_1_1","H11",1);
rename_routine("horizontal_1_2","H12",1);
rename_routine("horizontal_1_3","H13",1);
rename_routine("horizontal_1_4","H14",1);
rename_routine("horizontal_1_5","H15",1);
rename_routine("horizontal_1_6","H16",1);
rename_routine("horizontal_2_1","H21",1);
rename_routine("horizontal_3_1","H31",1);
rename_routine("horizontal_4_1","H41",1);
rename_routine("horizontal_5_1","H51",1);
rename_routine("horizontal_6_1","H61",1);
rename_routine("horizontal_2_2","H22",1);
rename_routine("horizontal_2_3","H22",1);
rename_routine("horizontal_2_4","H24",1);
rename_routine("horizontal_2_5","H25",1);
rename_routine("horizontal_2_6","H26",1);
rename_routine("horizontal_3_2","H32",1);
rename_routine("horizontal_4_2","H42",1);
rename_routine("horizontal_5_2","H52",1);
rename_routine("horizontal_6_2","H62",1);
rename_routine("horizontal_3_3","H33",1);
rename_routine("horizontal_3_4","H34",1);
rename_routine("horizontal_3_5","H35",1);
rename_routine("horizontal_3_6","H36",1);
rename_routine("horizontal_4_3","H43",1);
rename_routine("horizontal_5_3","H53",1);
rename_routine("horizontal_6_3","H63",1);
rename_routine("horizontal_4_4","H44",1);
rename_routine("horizontal_4_5","H45",1);
rename_routine("horizontal_4_6","H46",1);
rename_routine("horizontal_5_4","H54",1);
rename_routine("horizontal_6_4","H64",1);
rename_routine("horizontal_5_5","H55",1);
rename_routine("horizontal_5_6","H56",1);
rename_routine("horizontal_6_5","H65",1);
rename_routine("horizontal_6_6","H66",1);
rename_routine("vertical_1_1","V11",1);
rename_routine("vertical_1_2","V12",1);
rename_routine("vertical_1_3","V13",1);
rename_routine("vertical_1_4","V14",1);
rename_routine("vertical_1_5","V15",1);
rename_routine("vertical_1_6","V16",1);
rename_routine("vertical_2_1","V21",1);
rename_routine("vertical_3_1","V31",1);
rename_routine("vertical_4_1","V41",1);
rename_routine("vertical_5_1","V51",1);
rename_routine("vertical_6_1","V61",1);
rename_routine("vertical_2_2","V22",1);
rename_routine("vertical_2_3","V22",1);
rename_routine("vertical_2_4","V24",1);
rename_routine("vertical_2_5","V25",1);
rename_routine("vertical_2_6","V26",1);
rename_routine("vertical_3_2","V32",1);
rename_routine("vertical_4_2","V42",1);
rename_routine("vertical_5_2","V52",1);
rename_routine("vertical_6_2","V62",1);
rename_routine("vertical_3_3","V33",1);
rename_routine("vertical_3_4","V34",1);
rename_routine("vertical_3_5","V35",1);
rename_routine("vertical_3_6","V36",1);
rename_routine("vertical_4_3","V43",1);
rename_routine("vertical_5_3","V53",1);
rename_routine("vertical_6_3","V63",1);
rename_routine("vertical_4_4","V44",1);
rename_routine("vertical_4_5","V45",1);
rename_routine("vertical_4_6","V46",1);
rename_routine("vertical_5_4","V54",1);
rename_routine("vertical_6_4","V64",1);
rename_routine("vertical_5_5","V55",1);
rename_routine("vertical_5_6","V56",1);
rename_routine("vertical_6_5","V65",1);
rename_routine("vertical_6_6","V66",1);
rename_routine("in_interval","IIVL",1);
rename_routine("is_a_theorem","THM",1);
rename_routine("less_or_equal","LE",1);
rename_routine("less_than_or_equal","LE",1);
rename_routine("little_set","LST",1);
rename_routine("member","MBR",1);
rename_routine("ordered_pair_predicate","OPP",1);
rename_routine("positive_integer","POSINT",1);
rename_routine("product","P",1);
rename_routine("proper_subset","PRS",1);
rename_routine("single_valued_set","SVS",1);
rename_routine("state","S",1);
rename_routine("subset","SUS",1);
rename_routine("sum","SM",1);

/*------------------------------------*/
/* function names to replace          */
/*------------------------------------*/

rename_routine("a_real_number","ARN",2);
rename_routine("absolute","ABS",2);
rename_routine("abstraction","ABST",2);
rename_routine("add","A",2);
rename_routine("add_inverter","0",2);
rename_routine("additive_identity","0",2);
rename_routine("additive_identityC","C0",2);
rename_routine("additive_inverse","AI",2);
rename_routine("apply","APY",2);
rename_routine("associator","ASSR",2);
rename_routine("codomain","CDMN",2);
rename_routine("commutator","CMTR",2);
rename_routine("complement","CMPL",2);
rename_routine("compose","COMP",2);
rename_routine("composition_function","CMPF",2);
rename_routine("continuous","CONT",2);
rename_routine("covered","COV",2);
rename_routine("cross_product","CXP",2);
rename_routine("difference","DIFF",2);
rename_routine("divide","D",2);
rename_routine("domain_relation","DOMR",2);
rename_routine("domain","DOMN",2);
rename_routine("double_divide","DD",2);
rename_routine("empty_set","EMS",2);
rename_routine("epsilon_0","EP0",2);
rename_routine("equivalent","Q",2);
rename_routine("euclid1","EUC1",2);
rename_routine("euclid2","EUC2",2);
rename_routine("extension","EXTN",2);
rename_routine("extreme_point","EXPT",2);
rename_routine("falsehood","FH",2);
rename_routine("greatest_lower_bound","GLB",2);
rename_routine("identity","ID",2);
rename_routine("implies","IMP",2);
rename_routine("infinity","IY",2);
rename_routine("inner_pasch","INPH",2);
rename_routine("intersection","INT",2);
rename_routine("inverse","INV",2);
rename_routine("inverter_table","ITBL",2);
rename_routine("join","J",2);
rename_routine("least_upper_bound","LUB",2);
rename_routine("less_or_equal","LE",2);
rename_routine("list_reversion","LVN",2);
rename_routine("lower_bound","LB",2);
rename_routine("lower_dimension_point_1","LDP1",2);
rename_routine("lower_dimension_point_2","LDP2",2);
rename_routine("lower_dimension_point_3","LDP3",2);
rename_routine("make_reverse_list","MRVL",2);
rename_routine("member_of_1_not_of_2","M1N2",2);
rename_routine("meet","M",2);
rename_routine("midpoint","MIDP",2);
rename_routine("minimum","MIN",2);
rename_routine("multiplicative_identity","1",2);
rename_routine("multiplicative_identityC","C1",2);
rename_routine("multiplicative_inverse","MI",2);
rename_routine("multiply","M",2);
rename_routine("multiplyC","MC",2);
rename_routine("negate","N",2);
rename_routine("non_ordered_pair","NOP",2);
rename_routine("not_covered","NCVD",2);
rename_routine("not_reversion","NRN",2);
rename_routine("null_class","NULC",2);
rename_routine("one","1",2);
rename_routine("ordered_pair","ORP",2);
rename_routine("outer_pasch","OTPH",2);
rename_routine("pair","PR",2);
rename_routine("possible_reversion","PRVN",2);
rename_routine("projection1","PR1",2);
rename_routine("projection2","PR2",2);
rename_routine("reflection","REFL",2);
rename_routine("subset_relation","SUBR",2);
rename_routine("successor","SUC",2);
rename_routine("successor_relation","SUCR",2);
rename_routine("squares","SQRS",2);
rename_routine("universal_class","UCLS",2);
rename_routine("union","U",2);
rename_routine("unordered_pair","UNPR",2);
rename_routine("upper_bound","UB",2);

return;
}
/*--------------------------------------------------------------*/
/* rename routine()
/*--------------------------------------------------------------*/

void rename_routine(pred_symb,new_symb,pf_type) 
char pred_symb[];
char new_symb[];
int pf_type;
{
int a, k, test, numberpfs;
char *jj, *jjj, *sym_ptr, *new_sptr;;

if(pf_type == 1) numberpfs = number_preds;
else numberpfs = number_fxns;

for (a = 1; a <= numberpfs; a++) {
   if(pf_type == 1) {jj = pidtbl[a];}
   else jj = fidtbl[a];
   jjj = jj;
   sym_ptr = &pred_symb[0];
   new_sptr = &new_symb[0];
   test = 1;
   while(*jj != 0x00000000) {
      if(*sym_ptr == 0x00000000) {test = 0;break;}
      if(*jj++ != *sym_ptr++) {test = 0; break;}}
   if(*sym_ptr != 0x00000000) {test = 0;}

   if(test) {
      if(pf_type == 1) rename_preds++;
      else rename_fxns++;
      jj = jjj;
      while(*new_sptr != 0x00000000) {
	 *jj++ = *new_sptr++;}
      *jj = 0x00000000; 
      return;}}
return;
}

