
/*
 * File AtomIterator.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __AtomIterator__
#define __AtomIterator__

class Atom;
class Formula;
class FormulaList;



class AtomIterator
{
public:
  AtomIterator (const Formula&);
  AtomIterator (const FormulaList&);
  ~AtomIterator ();

  bool hasNext ();
  const Atom& next ();
private:
  class Element;
  Formula* _current;
  Element* _reserve;
  void popReserve ();
}; 


#endif 


