
/*
 * File CASCMode.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __CASCMode__
#define __CASCMode__

#include <string>

using namespace std;

class Property;
class Schedule;
class Timer;
class UnitList;

namespace XML {
  class DeepElement;
};


class CASCMode {
public:
  
  class Schedule {
  public:
    Schedule (const Property&);
    string next ();
    bool hasNext () const;
  private:
    
    string schedule;
  };

  static void run (UnitList& units, Timer& timer);
  static void reportAllocationFailure ();
private:
  static void runSchedule (Schedule&,
			   UnitList& units,
			   const Property& property,
			   Timer& timer,
			   int timeLimit,
			   XML::DeepElement* log,
			   int normalSliceTimeLimit);
};

#endif
