
/*
 * File ClausalDefinition.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __ClausalDefinition__
#define __ClausalDefinition__

class Problem;
class Signature;
class PredicateSymbol;


class ClausalDefinition {
public:
  ClausalDefinition (Problem& problem,Signature& signature);
  int findAndReplace ();

private:
  class Counter;

  void deleteAll (const PredicateSymbol* s);
  bool resolveAll (const PredicateSymbol* s, Unit& u, Counter* counter);
  void resolveAllUpon (const PredicateSymbol* s,
		       const Unit& u1,
		       const Unit& u2,
		       Unit& result);

  
  Problem& _problem;
  
  Signature& _signature;
}; 

#endif
