
/*
 * File Debugger.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#if DEBUG_PREPRO

#ifndef __Debugger__
#define __Debugger__

#include "Map.hpp"


class Debugger {
public:
  static bool allocated (void* memory, int words, const string& className);
  static bool released (void* memory, int words, const string& className);
  static bool reallocated (void* memory, int words, const string& className);
  static void reportLeaks (ostream& str);
  struct Info {
    int size; 
    string className; 
    Info (int sz, const string& nm) : size(sz), className(nm) {}
    Info () {}
  };
  typedef Map<void*,Info> Memory;
  
  class Leaker {
  public:
    Leaker (ostream& str) : _stream (str) {}
    ~Leaker () { Debugger::reportLeaks(_stream); }
  private:
    ostream& _stream;
  }; 
private:
  
  static Memory _allocatedPieces;
};


#endif 

#endif 
