
/*
 * File Definition.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Definition__
#define __Definition__


class Term;
class TermList;
class Atom;
class Clause;
class Formula;
class Unit;
class Problem;
class FunctionSymbol;
class PredicateSymbol;

#include "Var.hpp"


class Definition
{
public:
  static bool makeDefinition (const Unit& original, Unit& def); 
  static int removeUnusedDefinitions (Problem&);
private:
  static bool isPredicateDefinition (const Formula&, Atom& lhs, Formula& rhs);
  static bool isPredicateDefinition (const Atom& lhs, const Formula& rhs);
  static bool occurs (const PredicateSymbol&, const Formula&);
  static int findDefinitions (Problem&);
}; 


#endif
