
/*
 * File Flattening.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Flattening__
#define __Flattening__


class Unit;
class Formula;
class Position;
class FormulaList;
class InferenceInfo;

#include "Connective.hpp"


class Flattening
{
public:
  static void flatten (Unit&);
private:
  
  Flattening () : _info(0) {}
  void flatten (Formula&, const Position&);
  bool flatten (FormulaList&, Connective, const Position&, int k);
  
  InferenceInfo* _info;
}; 


#endif
