
/*
 * File Grishin.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Grishin__
#define __Grishin__

class Atom;
class Formula;
class FormulaList;
class Sequent;
class Substitution;

#include "Signature.hpp"


class Grishin
{
public:
  Grishin ();
  ~Grishin ();
  void add (const Formula&);
  bool findDerivation ();
private:
  class SequentList;
  
  Signature _skolem;
  
  Sequent* _initial;
  bool prove (SequentList&, Substitution&);
  bool proveOr (SequentList&, Substitution&, Sequent*,
		bool sign, const FormulaList&);
  bool proveAtom (SequentList&, Substitution&, Sequent*,
		  bool sign, const Atom&);
};


#endif
