
/*
 * File KIFMode.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __KIF__
#define __KIF__

#include <string>

namespace XML {
  class Element;
};

using namespace std;

class Var;
class Term;
class TermList;
class Atom;
class Literal;
class Clause;
class Formula;
class Unit;
class UnitList;
class Refutation;
class Timer;
class Query;



class KIFMode
{
public:
  static XML::Element* toXML (const Refutation&, int answerNumber);
  static void run (UnitList& units, Timer& timer);
  static void reportAllocationFailure ();
private:
  static string toString (const Term&);
  static string toString (const TermList&);
  static string toString (const Atom&);
  static string toString (const Literal&);
  static string toString (const Clause&);
  static string toString (const Formula&);
  static XML::Element* toXML (const Unit&);
  static string toString (const Var& v);
  static Query* readQuery ();
  static bool recoverFromSyntaxError ();
}; 


#endif
