/**
 * File Lexer.hpp.
 * Defines class Lexer
 *
 * @since 11/05/2004, Manchester
 */

#ifndef __Lexer__
#define __Lexer__

#include <istream>

enum TokenType {
  TT_LPAR,
  TT_RPAR,
  TT_LBRA,
  TT_RBRA,
  TT_COMMA,
  TT_COLON,
  TT_DOT,
  TT_AND,
  TT_NOT,
  TT_OR,
  TT_IFF,
  TT_IMP,
  TT_XOR,
  TT_FORALL,
  TT_EXISTS,
  TT_PLUSPLUS,
  TT_MINUSMINUS,
  TT_VARIABLE,
  TT_NAME,
  TT_NUMBER
};

#define LBUFFER_SIZE 8100

class Lexer 
{
public:
  Lexer(std::istream& in);
private:
  void skipWhiteSpace();
  char _buffer[LBUFFER_SIZE];
  int _cursor;
}; // class Lexer

#endif

