
/*
 * File LiteralOrderingFinder.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __LiteralOrderingFinder__
#define __LiteralOrderingFinder__

class Problem;
class Options;
class Signature;


#include "Unit.hpp"



class LiteralOrderingFinder {
public:
  LiteralOrderingFinder (const Problem&, const Options&, Signature&);
  ~LiteralOrderingFinder ();
  void findOrdering ();
private:
  class Counter;
  class ArityComparator;
  
  void registerOccurrences();
  void registerOccurrences (const Unit&);
  void registerOccurrences (const Formula&, InputType, int polarity);
  void registerOccurrences (const Clause&, InputType);
  void registerOccurrences (const Atom&, InputType, int polarity);
  void registerOccurrences (const Term&, InputType, int polarity);
  void registerOccurrence (Symbol&, InputType, int polarity);

  
  const Problem& _problem;
  
  const Options& _options;
  
  Signature& _signature;
  
  int _lastSymbol;
  
  Counter* _functions;
  
  Counter* _predicates;
};

#endif
