
/*
 * File NNF.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __NNF__
#define __NNF__


class Formula;
class FormulaList;
class InferenceInfo;
class Position;
class Unit;



class NNF
{
public:
  static void ennf (Unit& f);
  static void nnf (Unit& f);
private:
  static void ennf (Formula&, bool polarity, 
		    InferenceInfo*&, const Position&);
  static void ennf (FormulaList&, bool polarity, int n,
		    InferenceInfo*&, const Position&);
  static void nnf (Formula&, bool polarity,
		   InferenceInfo*&, const Position&);
  static void nnf (FormulaList&, bool polarity, int n,
		   InferenceInfo*&, const Position&);
}; 


#endif
