
/*
 * File Pair.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __pair__
#  define __pair__


#include "Allocator.hpp"





template <class C, class D>
class Pair
{
 public:

  
  inline
  Pair ( C left, D right )
    :
    _left ( left ),
    _right ( right ) {}

  inline
  Pair () {}

  
  inline C left () const { return _left; }
  inline D right () const { return _right; }

  
  inline void left ( C lft ) { _left = lft; }
  inline void right ( D rht ) { _right = rht; }

  
  inline 
  bool operator == ( Pair& rhs ) const 
    { return left() == rhs.left() &&
             right() == rhs.right(); }

  
  CLASS_NAME("Pair");
  USE_ALLOCATOR(Pair);
 protected:  
  C _left;
  D _right;
};  





#endif


