
/*
 * File Position.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Position__
#define __Position__


#include "Lists.hpp"
#include <string>
class Formula;
class FormulaList;



class Position
  : public IntList
{
 public:
  
  Position ();
  Position (const Position&);
  explicit Position (int p); 
  Position (int head, const Position& tail);

  
  const Position& tail () const
    { return static_cast<const Position&>(IntList::tail()); }
  const Formula& subformula (const Formula&) const;
  int polarity (const Formula&) const;
  void replace (Formula& f, const Formula& g) const;
private:
  void replaceReverse (Formula& f, const Formula& g) const;
  void replaceReverse (FormulaList& fs, const Formula& g, int pos) const;
  int polarityReverse (const Formula&) const;
  int polarityReverse (int k,const FormulaList&) const;
}; 



class NonExistingPositionException {
};




inline
Position::Position () 
  : 
  IntList ()
{
} 


inline
Position::Position (const Position& ts)
  :
  IntList (ts)
{
} 


inline
Position::Position (int hd, const Position& tl)
  :
  IntList (hd,tl)
{
} 


inline
Position::Position (int hd)
  :
  IntList (hd)
{
} 


#endif 
