
/*
 * File Preprocess.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Preprocess__
#define __Preprocess__


class Unit;
class Formula;
class FormulaList;
class LiteralList;
class Options;
class Problem;
class Property;


class Preprocess
{
public:
  static void preprocess (Problem& problem, 
			  const Options& options,
			  const Property& property);
private:
  static void preprocess1 (Unit&,
			   const Options& options,
			   Problem& problem);
  static void preprocess2 (Unit&, const Options& options);
  static void normalise (Problem&);
  static int removeEqualityAxioms (Problem&);
}; 


#endif
