
/*
 * File Query.cpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#include <cstdlib>

#include "Query.hpp"

const string timeLimitString = "timeLimit";
const string depthLimitString = "depthLimit";
const string bindingsLimitString = "bindingsLimit";



Query::Query (QueryType qtype, const Formula& formula, Attribute* attributes)
  :
  _type (qtype),
  _formula (formula),
  _attributes (attributes),
  _timeLimit (5),
  _depthLimit (-1),
  _bindingsLimit (5)
{
  if (qtype == GOAL) { 
    for (Attribute* attr = attributes; attr; attr = attr->next()) {
      if (attr->name() == timeLimitString) {
	
	char* endptr; 
	_timeLimit = strtoul (attr->value().data(), &endptr, 10);
      }
      else if (attr->name() == depthLimitString) {
	
	char* endptr;
	_depthLimit = strtoul (attr->value().data(), &endptr, 10);
      }
      else if (attr->name() == bindingsLimitString) {
	
	char* endptr = 0; 
	_bindingsLimit = strtoul (attr->value().data(), &endptr, 10);
      }
    }
  }
} 


