
/*
 * File Rectify.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Rectify__
#define __Rectify__


#include "Substitution.hpp"

class Formula;
class Unit;
class VarList;
class FormulaList;
class Atom;


class Rectify 
{
public:
  static void rectify (Unit&,VarList& answerVariables);
private:
  void rectify (Formula&);
  void rectify (FormulaList&); 
  void rectify (Atom&);
  void rectify (TermList&);
  void rectify (Term&);
  void rectify (const VarList& vs, VarList& result);
  
  Substitution _subst;
  
  VarList _free;
}; 


#endif
