
/*
 * File Refutation.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */



#ifndef __Refutation__
#  define __Refutation__


#include "Unit.hpp"

class Options;

class Kernel;

class Refutation
{
 public:
  
  Refutation (const Kernel& kernel, 
	      const Problem& problem,
	      const Options& options);
  
  const UnitList& refutation () const { return _refutation; }

  
  const Kernel& kernel () const { return _kernel; }
  
  const Problem& Refutation::problem () const { return _problem; } 

  XML::Element* toXML () const;
  void prettyPrint (ostream&,int answerNumber);

  
  void* operator new (size_t);
 private:
  class Map; 

  
  const Kernel& _kernel;
  
  const Problem& _problem;
  
  const Options& _options;
  
  UnitList _refutation;

  void collect (Unit&, Map& map, bool fillGaps);
  Unit collectKernelClause (const void* clause, Map& map, bool fillGaps);
  UnitList collectKernelClauseParents (const void* parents, Map& map, bool fillGaps);
  Unit condense (Unit root, Map& condensed) const; 
}; 


#endif 
