
/*
 * File Run.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Run__
#define __Run__

using namespace std;

#include <string>
#include "VampireKernel.hpp"
#include "RunResult.hpp"


class Options;
class Problem;
class FormulaList;
class UnitList;
class Timer;

namespace XML {
  class DeepElement;
};



class Run
{
public:
  
  static string toString (RunResult res);
  
  static XML::DeepElement* log;
  static void saveLog();
  static void setSignalHandlers();
  static string signalToString (int sigNum);
  static void terminateBySignal (string signalDescription,int result);
  static void readInput (string inputFileName, 
			 FormulaList& formulas,
			 UnitList& units);
  static void run (UnitList&, Timer& timer);
  static void reportAllocationFailure ();
private:
  
  static bool saved;
  static void cancelSignalHandling ();
}; 



void runtimeErrorHook();
void debugSystemInternalErrorHook();

#endif
