
/*
 * File Skolem.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Skolem__
#define __Skolem__


#include "Substitution.hpp"

class Unit;
class Formula;
class FormulaList;
class Position;
class InferenceInfoTermList;


class Skolem
{
public:
  static void skolemise (Unit&);
private:
  
  Skolem () : _info(0) {}
  void skolemiseNNF (Formula&, 
		     const VarList&,
		     const Position& pos,
		     const Position& posWithERemoved);
  void skolemiseNNF (FormulaList&, 
		     const VarList&,
		     const Position& position,
		     const Position& posWithERemoved,
		     int pos);
  void makeSkolemTerms (const VarList& vars, 
			const TermList& skolemArgs,
			int arity,
			TermList& skolemTerms);
  
  InferenceInfoTermList* _info;
  Substitution _subst;
}; 


#endif
