
/*
 * File Statistics.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Statistics__
#define __Statistics__


namespace XML {
  class Element;
};

#include <string>
#include "VampireKernel.hpp"

class Options;

using namespace std;






class Statistics {
 public:
  
  Statistics (const VampireKernel&);

  string toString (bool detailed) const;
  XML::Element* toXML () const;
  
  void setResult (const string& result) { _result = result; }
  void output (ostream& str, const Options& opts) const;

  
  void* operator new (size_t);

 private:
  
  const VampireKernel& _kernel;
  const VampireKernel::Statistics& _statistics;
  string _result;

  long memoryInBytes () const;
  static string toString(VampireKernel::TerminationReason);
}; 


#endif 
