
/*
 * File SubformulaIterator.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __SubformulaIterator__
#define __SubformulaIterator__

class Formula;
class FormulaList;



class SubformulaIterator
{
public:
  SubformulaIterator (const Formula&);
  SubformulaIterator (const FormulaList&);
  ~SubformulaIterator ();

  bool hasNext ();
  const Formula& next ();
private:
  class Element {
  public:
    Element (const FormulaList& list, Element* rest) 
      : _isList(true), _list(const_cast<FormulaList*>(&list)), _rest(rest) {}
    Element (const Formula& f, Element* rest) 
      : _isList(false), _formula(const_cast<Formula*>(&f)), _rest(rest) {}
    bool _isList;
    union{ 
      FormulaList* _list;
      Formula* _formula;
    };
    Element* _rest;
  };
  Formula* _current;
  Element* _reserve;
}; 


#endif 


