/* $ANTLR 2.7.3 (20040506-1): "TPTP.g" -> "TPTPParser.cpp"$ */
#line 26 "TPTP.g"

    // gets inserted before the antlr generated includes in the cpp file

#line 7 "TPTPParser.cpp"
#include "TPTPParser.hpp"
#include <antlr/NoViableAltException.hpp>
#include <antlr/SemanticException.hpp>
#include <antlr/ASTFactory.hpp>
#line 30 "TPTP.g"

    // gets inserted after the antlr generated includes in the cpp file

#line 16 "TPTPParser.cpp"
#line 143 "TPTP.g"

// header of the parser file
#include <fstream>

#include "Tracer.hpp"
#include "IntNameTable.hpp"
#include "antlr/TokenStreamSelector.hpp"
#include "TPTPLexer.hpp"
#include "Options.hpp"
#include "XML.hpp"
#include "VampireException.hpp"
#include "Signature.hpp"


extern antlr::TokenStreamSelector* selector;

#line 34 "TPTPParser.cpp"
TPTPParser::TPTPParser(antlr::TokenBuffer& tokenBuf, int k)
: antlr::LLkParser(tokenBuf,k)
{
}

TPTPParser::TPTPParser(antlr::TokenBuffer& tokenBuf)
: antlr::LLkParser(tokenBuf,2)
{
}

TPTPParser::TPTPParser(antlr::TokenStream& lexer, int k)
: antlr::LLkParser(lexer,k)
{
}

TPTPParser::TPTPParser(antlr::TokenStream& lexer)
: antlr::LLkParser(lexer,2)
{
}

TPTPParser::TPTPParser(const antlr::ParserSharedInputState& state)
: antlr::LLkParser(state,2)
{
}

void TPTPParser::units(
	UnitList& us
) {
#line 174 "TPTP.g"
	
		  TRACER("TPTPParser::units");
		  Unit first;
		  UnitList vs;
		
#line 69 "TPTPParser.cpp"
	
	{
	switch ( LA(1)) {
	case LITERAL_include:
	{
		include(vs);
		break;
	}
	case LITERAL_input_formula:
	case LITERAL_input_clause:
	{
		unit(first);
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
	{
	switch ( LA(1)) {
	case LITERAL_input_formula:
	case LITERAL_input_clause:
	case LITERAL_include:
	{
		units(us);
		break;
	}
	case antlr::Token::EOF_TYPE:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
#line 190 "TPTP.g"
	
		  if (vs.isEmpty()) {
		    us = UnitList (first, us);
		  }
		  else {
		    vs.append (us);
		    us = vs;
		  }
		
#line 119 "TPTPParser.cpp"
}

void TPTPParser::include(
	UnitList& us
) {
	antlr::RefToken  nm = antlr::nullToken;
	
	kw_include();
	match(LPAR);
	nm = LT(1);
	match(FILE_NAME);
	match(RPAR);
	match(DOT);
#line 208 "TPTP.g"
	
		  string absoluteName = 
		    Options::globalOptions.includeFileName (nm->getText());
		  std::ifstream inFile (absoluteName.c_str());
		  if(!inFile) {
		    string err = "cannot open include file: '";
		    err += absoluteName + "'";
		    USER_ERROR(err);
		  };
		  TPTPLexer lexer(inFile); 
		  TPTPParser parser (lexer);
		  parser.units (us);
		
#line 147 "TPTPParser.cpp"
}

void TPTPParser::unit(
	Unit& unit
) {
	antlr::RefToken  nm1 = antlr::nullToken;
	antlr::RefToken  nm2 = antlr::nullToken;
#line 223 "TPTP.g"
	
		  InputType t;
		
#line 159 "TPTPParser.cpp"
	
	switch ( LA(1)) {
	case LITERAL_input_formula:
	{
		kw_formula();
		match(LPAR);
		nm1 = LT(1);
		match(NAME);
		match(COMMA);
		t=type();
		match(COMMA);
#line 234 "TPTP.g"
		
			  Formula f;
			
#line 175 "TPTPParser.cpp"
		formula(f);
		match(RPAR);
		match(DOT);
#line 240 "TPTP.g"
		
                if (t == CONJECTURE) {
		  f = Formula(NOT,f);
		}
			  unit = Unit(nm1->getText(), t, f);
			
#line 183 "TPTPParser.cpp"
		break;
	}
	case LITERAL_input_clause:
	{
		kw_clause();
		match(LPAR);
		nm2 = LT(1);
		match(NAME);
		match(COMMA);
		t=type();
		match(COMMA);
#line 250 "TPTP.g"
		
			  Clause c;
			
#line 199 "TPTPParser.cpp"
		clause(c);
		match(RPAR);
		match(DOT);
#line 256 "TPTP.g"
		
			  unit = Unit(nm2->getText(), t, c);
			
#line 207 "TPTPParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
}

void TPTPParser::kw_include() {
	
	match(LITERAL_include);
}

void TPTPParser::kw_formula() {
	
	match(LITERAL_input_formula);
}

InputType  TPTPParser::type() {
#line 262 "TPTP.g"
	InputType b;
#line 230 "TPTPParser.cpp"
	antlr::RefToken  tp = antlr::nullToken;
	
	tp = LT(1);
	match(NAME);
#line 266 "TPTP.g"
	
		  if (tp->getText() == "axiom")
		    b = AXIOM;
		  else if (tp->getText() == "conjecture")
		    b = CONJECTURE;
		  else if (tp->getText() == "hypothesis")
		    b = ASSUMPTION;
		  else {
		    throw antlr::ANTLRException("wrong input type: " + tp->getText());
		  }
		
#line 247 "TPTPParser.cpp"
	return b;
}

void TPTPParser::formula(
	Formula& f
) {
	
	xorformula(f);
	{
	switch ( LA(1)) {
	case T_IFF:
	{
		match(T_IFF);
#line 285 "TPTP.g"
		
			  Formula rhs;
			
#line 265 "TPTPParser.cpp"
		formula(rhs);
#line 289 "TPTP.g"
		
			  f = Formula ( IFF, f, rhs );
			
#line 271 "TPTPParser.cpp"
		break;
	}
	case RPAR:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
}

void TPTPParser::kw_clause() {
	
	match(LITERAL_input_clause);
}

void TPTPParser::clause(
	Clause& c
) {
	
#line 298 "TPTP.g"
	
		  LiteralList ls;
		
#line 299 "TPTPParser.cpp"
	match(LBRA);
	literals(ls);
	match(RBRA);
#line 304 "TPTP.g"
	
		  c = Clause (ls);
		
#line 307 "TPTPParser.cpp"
}

void TPTPParser::xorformula(
	Formula& f
) {
	
	impformula(f);
	{
	switch ( LA(1)) {
	case T_XOR:
	{
		match(T_XOR);
#line 315 "TPTP.g"
		
			  Formula rhs;
			
#line 324 "TPTPParser.cpp"
		xorformula(rhs);
#line 319 "TPTP.g"
		
			  f = Formula ( XOR, f, rhs );
			
#line 330 "TPTPParser.cpp"
		break;
	}
	case RPAR:
	case T_IFF:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
}

void TPTPParser::literals(
	LiteralList& ls
) {
	
	switch ( LA(1)) {
	case RBRA:
	{
		break;
	}
	case PP:
	case MM:
	{
#line 330 "TPTP.g"
		
			  Literal first;
			
#line 362 "TPTPParser.cpp"
		literal(first);
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			literals(ls);
			break;
		}
		case RBRA:
		{
			break;
		}
		default:
		{
			throw antlr::NoViableAltException(LT(1), getFilename());
		}
		}
		}
#line 339 "TPTP.g"
		
			  ls = LiteralList (first, ls);
			
#line 386 "TPTPParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
}

void TPTPParser::impformula(
	Formula& f
) {
	
	orformula(f);
	{
	switch ( LA(1)) {
	case T_IMP:
	{
		match(T_IMP);
#line 349 "TPTP.g"
		
			  Formula rhs;
			
#line 410 "TPTPParser.cpp"
		impformula(rhs);
#line 353 "TPTP.g"
		
			  f = Formula (IMP, f, rhs);
			
#line 416 "TPTPParser.cpp"
		break;
	}
	case RPAR:
	case T_IFF:
	case T_XOR:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
}

void TPTPParser::literal(
	Literal& l
) {
#line 376 "TPTP.g"
	
		  bool s;
		  Atom a;
		
#line 441 "TPTPParser.cpp"
	
	s=sign();
	atom(a);
#line 384 "TPTP.g"
	
		  l = Literal (s, a);
		
#line 449 "TPTPParser.cpp"
}

void TPTPParser::orformula(
	Formula& f
) {
	
	andformula(f);
	{
	switch ( LA(1)) {
	case T_OR:
	{
		match(T_OR);
#line 395 "TPTP.g"
		
			  Formula rhs;
			
#line 466 "TPTPParser.cpp"
		orformula(rhs);
#line 399 "TPTP.g"
		
			  f.makeJunction (OR, f, rhs);
			
#line 472 "TPTPParser.cpp"
		break;
	}
	case RPAR:
	case T_IFF:
	case T_IMP:
	case T_XOR:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
}

bool  TPTPParser::sign() {
#line 361 "TPTP.g"
	bool s;
#line 493 "TPTPParser.cpp"
	
	switch ( LA(1)) {
	case PP:
	{
		match(PP);
#line 365 "TPTP.g"
		
			  s = true;
			
#line 503 "TPTPParser.cpp"
		break;
	}
	case MM:
	{
		match(MM);
#line 370 "TPTP.g"
		
			  s = false;
			
#line 513 "TPTPParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	return s;
}

void TPTPParser::atom(
	Atom& a
) {
	antlr::RefToken  fun = antlr::nullToken;
	
#line 409 "TPTP.g"
	
		  TermList ts;
		
#line 533 "TPTPParser.cpp"
	fun = LT(1);
	match(NAME);
	{
	switch ( LA(1)) {
	case LPAR:
	{
		match(LPAR);
		terms(ts);
		match(RPAR);
		break;
	}
	case RPAR:
	case RBRA:
	case COMMA:
	case T_AND:
	case T_OR:
	case T_IFF:
	case T_IMP:
	case T_XOR:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
#line 419 "TPTP.g"
	
		  a = Atom ( Signature::sig.createPred (fun->getText(),ts.length()),
			     ts );
		
#line 567 "TPTPParser.cpp"
}

void TPTPParser::andformula(
	Formula& f
) {
	
#line 428 "TPTP.g"
	
		  Formula rhs;
		
#line 578 "TPTPParser.cpp"
	simple_formula(f);
	{
	switch ( LA(1)) {
	case T_AND:
	{
		match(T_AND);
		andformula(rhs);
#line 435 "TPTP.g"
		
			  f.makeJunction (AND, f, rhs);
			
#line 590 "TPTPParser.cpp"
		break;
	}
	case RPAR:
	case T_OR:
	case T_IFF:
	case T_IMP:
	case T_XOR:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
}

void TPTPParser::terms(
	TermList& ts
) {
	
#line 445 "TPTP.g"
	
		  Term t;
		
#line 617 "TPTPParser.cpp"
	term(t);
	{
	switch ( LA(1)) {
	case COMMA:
	{
		match(COMMA);
		terms(ts);
		break;
	}
	case RPAR:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
#line 454 "TPTP.g"
	
		  ts = TermList (t, ts);
		
#line 641 "TPTPParser.cpp"
}

void TPTPParser::simple_formula(
	Formula& f
) {
#line 459 "TPTP.g"
	
		  VarList vs;
		  Atom a;
		
#line 652 "TPTPParser.cpp"
	
	switch ( LA(1)) {
	case T_NOT:
	{
		match(T_NOT);
		simple_formula(f);
#line 467 "TPTP.g"
		
			  f = Formula ( NOT, f );
			
#line 663 "TPTPParser.cpp"
		break;
	}
	case T_FORALL:
	{
		match(T_FORALL);
		varlist(vs);
		match(COLON);
		simple_formula(f);
#line 475 "TPTP.g"
		
			  f = Formula ( FORALL, vs, f );
			
#line 676 "TPTPParser.cpp"
		break;
	}
	case T_EXISTS:
	{
		match(T_EXISTS);
		varlist(vs);
		match(COLON);
		simple_formula(f);
#line 483 "TPTP.g"
		
			  f = Formula ( EXISTS, vs, f );
			
#line 689 "TPTPParser.cpp"
		break;
	}
	case LPAR:
	{
		match(LPAR);
		formula(f);
		match(RPAR);
		break;
	}
	case NAME:
	{
		atom(a);
#line 492 "TPTP.g"
		
		f = Formula (a);
			
#line 706 "TPTPParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
}

void TPTPParser::term(
	Term& t
) {
	antlr::RefToken  fun = antlr::nullToken;
	antlr::RefToken  var = antlr::nullToken;
	
	switch ( LA(1)) {
	case NAME:
	{
		fun = LT(1);
		match(NAME);
#line 500 "TPTP.g"
		
			  TermList ts;
			
#line 731 "TPTPParser.cpp"
		{
		switch ( LA(1)) {
		case LPAR:
		{
			match(LPAR);
			terms(ts);
			match(RPAR);
			break;
		}
		case RPAR:
		case COMMA:
		{
			break;
		}
		default:
		{
			throw antlr::NoViableAltException(LT(1), getFilename());
		}
		}
		}
#line 509 "TPTP.g"
		
			  t = Term ( Signature::sig.createFun (fun->getText(),ts.length()),
				     ts );
			
#line 757 "TPTPParser.cpp"
		break;
	}
	case VAR:
	{
		var = LT(1);
		match(VAR);
#line 515 "TPTP.g"
		
			  Var v (IntNameTable::vars.insert(var->getText()));
			  t = Term (v);
			
#line 769 "TPTPParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
}

void TPTPParser::varlist(
	VarList& vs
) {
	
	match(LBRA);
	vars(vs);
	match(RBRA);
}

void TPTPParser::vars(
	VarList& vs
) {
	antlr::RefToken  v = antlr::nullToken;
	
	v = LT(1);
	match(VAR);
	{
	switch ( LA(1)) {
	case COMMA:
	{
		match(COMMA);
		vars(vs);
		break;
	}
	case RBRA:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
#line 537 "TPTP.g"
	
		  Var var (IntNameTable::vars.insert(v->getText()));
		  vs = VarList (var, vs);
		
#line 818 "TPTPParser.cpp"
}

void TPTPParser::initializeASTFactory( antlr::ASTFactory& )
{
}
const char* TPTPParser::tokenNames[] = {
	"<0>",
	"EOF",
	"<2>",
	"NULL_TREE_LOOKAHEAD",
	"UPPER",
	"LOWER",
	"DIGIT",
	"WHITE",
	"NUMBER",
	"WORDCHAR",
	"CHARACTER",
	"SKIP_RULE",
	"COMMENT_LINE",
	"QUOTE",
	"FILE_NAME",
	"LPAR",
	"RPAR",
	"LBRA",
	"RBRA",
	"COMMA",
	"COLON",
	"DOT",
	"T_AND",
	"T_NOT",
	"T_OR",
	"T_IFF",
	"T_IMP",
	"T_XOR",
	"T_FORALL",
	"T_EXISTS",
	"PP",
	"MM",
	"NAME",
	"VAR",
	"\"input_formula\"",
	"\"input_clause\"",
	"\"include\"",
	0
};



