
/*
 * File Tautology.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Tautology__
#define __Tautology__

class Term;
class TermList;
class Atom;
class Literal;
class LiteralList;
class Unit;


class Tautology {
public:
  static int isTautology (const Unit& in, Unit& out);
  bool lessThan (const Literal& lit1,const Literal& lit2);

private:
  static int isTautology (const LiteralList& in, LiteralList& out);
  static int compare (const Atom& a1,const Atom& a2);
  static int compare (const Term& t1,const Term& t2);
  static int compare (const TermList& ts1,const TermList& ts2);
}; 

#endif
