
/*
 * File TermVarIterator.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __TermVarIterator__
#define __TermVarIterator__

class Term;
class TermList;
class Atom;
class Literal;

#include "Var.hpp"


class TermVarIterator
{
public:
  TermVarIterator (const Term&);
  TermVarIterator (const TermList&);
  TermVarIterator (const Atom&);
  TermVarIterator (const Literal&);
  ~TermVarIterator ();

  bool hasNext ();
  Var next ();
private:
  class Element {
  public:
    Element (const TermList& list, Element* rest) 
      : _list(const_cast<TermList*>(&list)), _rest(rest) {}
    TermList* _list;
    Element* _rest;
  };
  Term* _current;
  Element* _reserve;
}; 


#endif 


