//
// File:         LiteralOrdering.hpp
// Description:  Literal ordering abstraction. 
// Created:      Jun 04, 2003, Alexandre Riazanov, riazanov@cs.man.ac.uk
//==================================================================
#ifndef LITERAL_ORDERING_H
#define LITERAL_ORDERING_H
//==================================================================
#include "jargon.hpp"
#include "VampireKernelDebugFlags.hpp"
#include "Comparison.hpp"
#include "TemporaryLiteral.hpp"
//===================================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_LITERAL_ORDERING
 #define DEBUG_NAMESPACE "LiteralOrdering"
#endif
#include "debugMacros.hpp"
//===================================================================

namespace VK
{
  class LiteralOrdering
  {
  public:
    LiteralOrdering() : _isStratified(false) {};
    virtual ~LiteralOrdering();
    
    bool isStratified() const { return _isStratified; };
    
    virtual 
    BK::Comparison compare(TemporaryLiteral& lit1,
			   TemporaryLiteral& lit2) const = 0;

    virtual
    BK::Comparison compareLayers(const TemporaryLiteral& lit1,
				 const TemporaryLiteral& lit2) const = 0;
  protected:
    bool _isStratified;
  }; // class LiteralOrdering

}; // namespace VK


//=================================================================
#endif
