
/*
 * File primes.cpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */







#include <iostream> 
#include <cstdlib> 

using namespace std;

int main ( int argc, char* argv [ ] )
{
  if (argc != 2) {
    cout << "This program must be called with one argument\n";
    return EXIT_FAILURE;
  }

  int total = atoi (argv[1]);
  if (total <= 0) {
    cout << "The argument must be a positive integer\n";
    return EXIT_FAILURE;
  }

  int* primes = new int [total+2];
  if (! primes) {
    cout << "The number is too large, insufficient memory\n";
    return EXIT_FAILURE;
  }

  
  primes[0] = 2;
  primes[1] = 3;
  int last = 1;
  cout << "2 3";
  
  for (int p = primes[last] + 2; ;p += 2) {
    for (int ind = 1; ; ind++) {
      int pind = primes[ind];
      div_t d = div (p,pind);
      if (d.rem == 0) { 
	
	break;
      }
      long double lim = pind*pind;
      if (lim > p) { 
	primes [++last] = p;
	cout << ' ' << p;
	if (last == total) { 
	  cout << "\n";
	  return EXIT_SUCCESS;
	}
	break;
      }
    }
  }
} 


