<?xml version="1.0"?>

<!-- ===================================================================

     Removes <include/> tags from xff-tstp document.
     
AUTHORS:

  Petr Pudlak <pudlak@kti.mff.cuni.cz>
  
LICENSE:

    Copyright (C) 2004  Petr Pudlak

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

==================================================================== -->

<xsl:stylesheet
    xmlns="http://www.w3.org/1999/XSL/Transform"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xff="http://xff.sf.net/xff"
    xmlns:tstp="http://xff.sf.net/xff/ext/tstp"
    version="1.0">
    
    <xsl:template match="tstp:include">
      <xsl:variable name="file" 
          select="concat('../../',concat(@filename,'.xml'))"/>
      <xsl:text>&#xa;</xsl:text>
      <xsl:comment>
        <xsl:text> +-+ Start of import from file </xsl:text>
        <xsl:value-of select="$file"/>
        <xsl:text> </xsl:text>
      </xsl:comment>
      <xsl:text>&#xa;</xsl:text>
      <xsl:apply-templates select="document($file,/)//xff:formula"/>
      <xsl:text>&#xa;</xsl:text>
      <xsl:comment>
        <xsl:text> -+- End of import from file </xsl:text>
        <xsl:value-of select="$file"/>
        <xsl:text> </xsl:text>
      </xsl:comment>
      <xsl:text>&#xa;</xsl:text>
    </xsl:template>
    
    <xsl:template match="*" priority="-1">
      <xsl:copy>
        <xsl:for-each select="@*">
          <xsl:copy/>
        </xsl:for-each>
        <xsl:apply-templates select="node()"/>
      </xsl:copy>
   </xsl:template>
</xsl:stylesheet>
